import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import java.util.*;
import javax.swing.border.*;

public class CdAssistantDialog extends JDialog implements ActionListener {
    JPanel[] panels;
    static final String OK=Messages.getString("DocSearch.ok");
    static final String CANCEL=Messages.getString("DocSearch.btnCancel");
    static final String SELECT=Messages.getString("DocSearch.btnSelect");
    JPanel advancedPanel=new JPanel();
    JPanel basicPanel=new JPanel();
    JPanel bp=new JPanel();
	//
	JPanel cdRootPanel=new JPanel();
	static final String CD_ROOT_DIR=Messages.getString("DocSearch.cdRoot");
	static final String SEL_CD_ROOT_DIR=Messages.getString("DocSearch.selCdRoot");
	JLabel cdRootLbl=new JLabel(CD_ROOT_DIR);
	JButton selCdRoot=new JButton(SEL_CD_ROOT_DIR);
	JTextField cdRootField=new JTextField(16);
	//
	JPanel splashPanel=new JPanel();
	static final String SPLASH_IMAGE=Messages.getString("DocSearch.splash");
	static final String SEL_SPLASH_IMAGE=Messages.getString("DocSearch.selSplash");
	JLabel splashLbl=new JLabel(SPLASH_IMAGE);
	JButton selsplash=new JButton(SEL_SPLASH_IMAGE);
	JTextField splashField=new JTextField(16);
	//
	JPanel startPanel=new JPanel();
	static final String START_PAGE=Messages.getString("DocSearch.startPage");
	static final String SEL_START_PAGE=Messages.getString("DocSearch.selStart");
	JLabel startLbl=new JLabel(START_PAGE);
	JButton selstart=new JButton(SEL_START_PAGE);
	JTextField startField=new JTextField(16);
	//
	JPanel helpPanel=new JPanel();
	static final String HELP_PAGE=Messages.getString("DocSearch.helpPage");
	static final String SEL_HELP_PAGE=Messages.getString("DocSearch.selHelp");
	JLabel helpLbl=new JLabel(HELP_PAGE);
	JButton selhelp=new JButton(SEL_HELP_PAGE);
	JTextField helpField=new JTextField(16);
	//
	JPanel copyPanel=new JPanel();
	static final String COPY_ALL=Messages.getString("DocSearch.copyAll");
	JCheckBox copyAllBx=new JCheckBox(COPY_ALL);
	//
	JPanel cdIdxsPanel=new JPanel();
	JPanel cdWHolePanel=new JPanel();
	JPanel idxsPanels [];
	static final String SEL_CD_IDXS=Messages.getString("DocSearch.selCdIdxs");
	JScrollPane cdIdxsPane;
	JCheckBox[] cdIdxs;
	JTabbedPane tabbedPane=new JTabbedPane();
    //
    JButton okButton = new JButton(OK);
    JButton cancelButton = new JButton(CANCEL);
    boolean returnBool = false;
	//
    int numPanels = 2;
    DocSearch monitor;

CdAssistantDialog(DocSearch monitor, String title, boolean modal) {
        super(monitor, title, modal);
        this.monitor = monitor;
	//
	bp.add(okButton);
	bp.add(cancelButton);
	//
        okButton.addActionListener(this);
        cancelButton.addActionListener(this);
	selhelp.addActionListener(this);
	selstart.addActionListener(this);
	selsplash.addActionListener(this);
	selCdRoot.addActionListener(this);
	//
	cdRootPanel.add(cdRootLbl);
	cdRootPanel.add(cdRootField);
	cdRootPanel.add(selCdRoot);
	//
	splashPanel.add(splashLbl);
	splashPanel.add(splashField);
	splashPanel.add(selsplash);
	//
	startPanel.add(startLbl);
	startPanel.add(startField);
	startPanel.add(selstart);
	//
	helpPanel.add(helpLbl);
	helpPanel.add(helpField);
	helpPanel.add(selhelp);
	//
	copyPanel.add(copyAllBx);
	//
	ArrayList cdIdxsArray=monitor.getCdArrayList();
	int numCDIdxs=cdIdxsArray.size();
	idxsPanels=new JPanel[numCDIdxs];
	cdIdxs=new JCheckBox[numCDIdxs];
	DocSearcherIndex di;
	//
        GridBagLayout gridbaglayout = new GridBagLayout();
        GridBagConstraints gridbagconstraints = new GridBagConstraints();
	//
	cdIdxsPanel.setLayout(new GridLayout(1, numCDIdxs));
	gridbaglayout = new GridBagLayout();
	gridbagconstraints = new GridBagConstraints();
	cdIdxsPanel.setLayout(gridbaglayout);
	//
	for (int i=0;i<numCDIdxs;i++) {
		di=(DocSearcherIndex)cdIdxsArray.get(i);
		cdIdxs[i]=new JCheckBox(di.getDesc());
		idxsPanels[i]=new JPanel();
		idxsPanels[i].add(cdIdxs[i]);
		//
		gridbagconstraints.fill = 1;
		gridbagconstraints.insets = new Insets(1, 1, 1, 1);
		gridbagconstraints.gridx = 0;
		gridbagconstraints.gridy = i;
		gridbagconstraints.gridwidth = 1;
		gridbagconstraints.gridheight = 1;
		gridbagconstraints.weightx = 0.0D;
		gridbagconstraints.weighty = 0.0D;
		gridbaglayout.setConstraints(idxsPanels[i], gridbagconstraints);
		cdIdxsPanel.add(idxsPanels[i]);
		}
	cdIdxsPane=new JScrollPane(cdIdxsPanel);
	cdIdxsPane.setPreferredSize(new Dimension(380,220));
	cdWHolePanel.setLayout(new BorderLayout());
	cdWHolePanel.setBorder(new TitledBorder(SEL_CD_IDXS));
	cdWHolePanel.add(cdIdxsPane, BorderLayout.CENTER);
	//
	basicPanel.setLayout(new BorderLayout());
	basicPanel.add(cdRootPanel, BorderLayout.NORTH);
	basicPanel.add(cdWHolePanel, BorderLayout.CENTER);
	basicPanel.add(copyPanel, BorderLayout.SOUTH);
	//
	advancedPanel.setLayout(new BorderLayout());
	advancedPanel.add(splashPanel, BorderLayout.NORTH);
	advancedPanel.add(startPanel, BorderLayout.CENTER);
	advancedPanel.add(helpPanel, BorderLayout.SOUTH);
	//
	JPanel advPW=new JPanel();
	advPW.add(advancedPanel);
	//
	tabbedPane.addTab(Messages.getString("DocSearch.basicCdOpts"), null,
                          basicPanel,
                          Messages.getString("DocSearch.basicCdOptsTip"));
	tabbedPane.addTab(Messages.getString("DocSearch.advancedCdOpts"), null,
                          advPW,
                          Messages.getString("DocSearch.advancedCdOptsTip"));
	//
        panels = new JPanel[numPanels];
        for (int i = 0; i < numPanels; i++) panels[i] = new JPanel();
        panels[0].add(tabbedPane);
	panels[1].add(bp);
               // now for the gridbag
        getContentPane().setLayout(new GridLayout(1, numPanels));
        gridbaglayout = new GridBagLayout();
        gridbagconstraints = new GridBagConstraints();
        getContentPane().setLayout(gridbaglayout);
        for (int i = 0; i < numPanels; i++) {
            //
            gridbagconstraints.fill = 1;
            gridbagconstraints.insets = new Insets(1, 1, 1, 1);
            gridbagconstraints.gridx = 0;
            gridbagconstraints.gridy = i;
            gridbagconstraints.gridwidth = 1;
            gridbagconstraints.gridheight = 1;
            gridbagconstraints.weightx = 0.0D;
            gridbagconstraints.weighty = 0.0D;
            gridbaglayout.setConstraints(panels[i], gridbagconstraints);
            getContentPane().add(panels[i]);
        }
    }

public void init() {
        pack();

        // center this dialog
        Rectangle frameSize = getBounds();
        Dimension screenD = Toolkit.getDefaultToolkit().getScreenSize();
        int screenWidth = screenD.width;
        int screenHeight = screenD.height;
        int newX = 0;
        int newY = 0;
        if (screenWidth > frameSize.width)
        {
            newX = (screenWidth - frameSize.width) / 2;
        }

        if (screenHeight > frameSize.height)
        {
            newY = (screenHeight - frameSize.height) / 2;
        }

        if ((newX != 0) || (newY != 0))
        {
            setLocation(newX, newY);
        }
	copyAllBx.setSelected(true);
    }

public void actionPerformed(ActionEvent actionevent) {
        String s = actionevent.getActionCommand();
        if (s.equals(OK)) {
	    if (getCDIdxList().isEmpty()) {
	    	monitor.showMessage(monitor.dsErr, Messages.getString("DocSearch.chooseAtLeastOneCDIdx"));
	    	}
	    else {
	    	returnBool = true;
            	this.setVisible(false);
		}
        }
	else if (s.equals(SEL_CD_ROOT_DIR)) {
	    JFileChooser fdo = new JFileChooser();
            fdo.setCurrentDirectory(new File(monitor.userHome));
	    fdo.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	    fdo.setFileFilter(new swingFolderFilter());
            int fileGotten = fdo.showDialog(this, SELECT);
            if (fileGotten == JFileChooser.APPROVE_OPTION) {
                File file = fdo.getSelectedFile();
                String fNa = file.toString();
                cdRootField.setText(fNa);
            		}
		}
	else if (s.equals(SEL_SPLASH_IMAGE)) {
	    JFileChooser fdo = new JFileChooser();
            fdo.setCurrentDirectory(new File(monitor.userHome));
	    fdo.setFileSelectionMode(JFileChooser.FILES_ONLY);
	    fdo.setFileFilter(new gifFilter());
            int fileGotten = fdo.showDialog(this, SELECT);
            if (fileGotten == JFileChooser.APPROVE_OPTION) {
                File file = fdo.getSelectedFile();
                String fNa = file.toString();
                splashField.setText(fNa);
            		}
		}
	else if (s.equals(SEL_START_PAGE)) {
	    JFileChooser fdo = new JFileChooser();
            fdo.setCurrentDirectory(new File(monitor.userHome));
	    fdo.setFileSelectionMode(JFileChooser.FILES_ONLY);
	    fdo.setFileFilter(new webFilter());
            int fileGotten = fdo.showDialog(this, SELECT);
            if (fileGotten == JFileChooser.APPROVE_OPTION) {
                File file = fdo.getSelectedFile();
                String fNa = file.toString();
                startField.setText(fNa);
            		}
		}
	else if (s.equals(SEL_HELP_PAGE)) {
	    JFileChooser fdo = new JFileChooser();
            fdo.setCurrentDirectory(new File(monitor.userHome));
	    fdo.setFileSelectionMode(JFileChooser.FILES_ONLY);
	    fdo.setFileFilter(new webFilter());
            int fileGotten = fdo.showDialog(this, SELECT);
            if (fileGotten == JFileChooser.APPROVE_OPTION) {
                File file = fdo.getSelectedFile();
                String fNa = file.toString();
                helpField.setText(fNa);
            		}
		}
        else if (s.equals(CANCEL)) {
            returnBool = false;
            this.setVisible(false);
        }
    }
    
public ArrayList getCDIdxList() {
   int numToCheck=cdIdxs.length;
   ArrayList returnArray=new ArrayList();
   ArrayList monIdxs=monitor.getCdArrayList();
   for (int i=0;i<numToCheck;i++) {
   	if (cdIdxs[i].isSelected()) {
		returnArray.add((DocSearcherIndex)monIdxs.get(i));
		}
   	}
   return returnArray;
}

public void setFields(String helpStr, String splashStr, String startStr, String cdRootDirName) {
	helpField.setText(helpStr);
	splashField.setText(splashStr);
	startField.setText(startStr);
	cdRootField.setText(cdRootDirName);
}

public boolean confirmed() { return returnBool; }
public boolean getCopyAllFiles() { return copyAllBx.isSelected(); }
public String getCdRootDirName() { return cdRootField.getText(); }
public String getSplashImageFileName() { return splashField.getText(); }
public String getStartPageFileName() { return startField.getText(); }
public String getHelpPageFileName() { return helpField.getText(); }

} // end for class
