import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.html.*;
import java.nio.*;
import java.nio.channels.*;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.DateFilter;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.Searcher;

public class DocSearch extends JFrame implements ActionListener {
	final static int osType =Utils.getOsType();
	String cdDir=Utils.getCdDir(osType);
	String USER_NAME=System.getProperty("user.name");
	final static String startDir = System.getProperty("user.dir");
	final static String userHome = Utils.getUserHome(osType, System.getProperty("user.home"));
	String cdRomDefaultHome = Utils.addFolder(System.getProperty("user.dir"), "cdrom_indexes");
	String cdRomIdxList = Utils.addFolder(cdRomDefaultHome, "cdrom_indexes_list.htm");
	String cdRomIdxDir = Utils.addFolder(cdRomDefaultHome, "indexes");
	String tempDir = System.getProperty("java.io.tmpdir");
	String cdRomTempIdxDir = Utils.addFolder(tempDir, "indexes");
	String lafChosen="";
	//
	boolean isCDSearchTool=isThisOnACd(cdRomDefaultHome);
	boolean currentlySearching=false;
	//
	String gateway="";
	String gatewayPwd="";
	String gatewayUser="";
	String emailFormat="text";
	String sendEmailNotice="";
	ArrayList adminEmails=new ArrayList();
	//
    ArrayList handlerList=new ArrayList();
    final static String[] searchOpts =
    { Messages.getString("DocSearch.titleAndDocBody"), 
    	Messages.getString("DocSearch.titleText"), 
	Messages.getString("DocSearch.summaryText"), 
	Messages.getString("DocSearch.bodyText"), 
	Messages.getString("DocSearch.keywordsText") };
    final static String[] fileTypesToFind =
    {
        Messages.getString("DocSearch.Web_Pages"),
        Messages.getString("DocSearch.Open/Star_Office_Files"),
        Messages.getString("DocSearch.MS_Office_Files"),
        Messages.getString("DocSearch.RTF_Files"),
        Messages.getString("DocSearch.PDF_Files"),
        Messages.getString("DocSearch.TEXT_Files"),
        Messages.getString("DocSearch.java_source_code")
    };
    final static String[] fileTypesToGet =
    { "htm", "sxc sxd sxi sxp sxw", "doc xls", "rtf", "pdf", "txt", "java" };
    final static String fileString = "file:///";
    final public static String pathSep = System.getProperty("file.separator");
    final static String searchTips = Messages.getString("DocSearch.searchTips");
    final static String aboutString =
        Messages.getString("DocSearch.aboutString");
    public final static GenericFilter wf = new GenericFilter();
    public final static FolderFilter ff = new FolderFilter();

    // printing vars
    private static final int kDefaultX = 740;
    private static final int kDefaultY = 480;
    private static final int prefScale = 0;
    private static final String kScale2Label =  Messages.getString("DocSearch.scale2X");
    private static final String kScaleFitLabel =  Messages.getString("DocSearch.scaleToFit");
    private static final String kScaleHalfLabel =  Messages.getString("DocSearch.scaleHalf");
    private static final String kScaleOffLabel = Messages.getString("DocSearch.scaleOff");
    private static final String kScaleXLabel = Messages.getString("DocSearch.scaleWidth");
    private static final String kScaleYLabel = Messages.getString("DocSearch.scaleLength");
    //
    String htmlTag;
    String wordTag;
    String excelTag;
    String pdfTag;
    String textTag;
    String rtfTag;
    String ooImpressTag;
    String ooWriterTag;
    String ooCalcTag;
    String ooDrawTag;
    boolean useGui = true;
    boolean loadExternal=false;
    String currentIndex = "";
    String defaultSaveFolder = ""; 
    String[] startA = { "" };
    public String workingDir = Utils.addFolder(userHome, ".docSearcher");
    public String lastSearchedText="";
    String userPrefs=Utils.addFolder(workingDir, "docSearch_prefs.txt");
    String indexFile = Utils.addFolder(workingDir, "index_list.htm");
    String indexDir = Utils.addFolder(workingDir, "indexes");
    String iconDir = Utils.addFolder(startDir, "icons");
    String bookmarksFile = Utils.addFolder(workingDir, "bookmarks.htm");
    String blankFile = "";
    String lastSearch = Messages.getString("DocSearch.lastSearch");
    boolean hasErr = false;
    boolean isLoading = true;
    boolean hasIcons = true;
    String errString = Messages.getString("DocSearch.unknownError");
    public String wordTextFile =  Utils.addFolder(tempDir, "temp_word_file_"+USER_NAME+".txt");
    public String excelTextFile = Utils.addFolder(tempDir, "temp_excel_file_"+USER_NAME+".txt");
    public String rtfTextFile = Utils.addFolder(tempDir, "temp_rtf_file_"+USER_NAME+".txt");
    public String pdfTextFile = Utils.addFolder(tempDir, "temp_pdf_file_"+USER_NAME+".txt");
    public String htmlTextFile = Utils.addFolder(tempDir, "temp_html_file_"+USER_NAME+".txt");
    public String ooTextFile = Utils.addFolder(tempDir, "temp_oo_file_"+USER_NAME+".xml");
    public String ooMetaTextFile = Utils.addFolder(tempDir, "temp_oo_meta_file_"+USER_NAME+".xml");
    public String ooTextOnlyFile = Utils.addFolder(tempDir, "temp_oo_text_file_"+USER_NAME+".txt");
    public String archiveDir = Utils.addFolder(workingDir, "archives");
    public String contentDir = Utils.addFolder(startDir, "content");

    // GUI items
    String curStatusString = Messages.getString("DocSearch.loading");
    JMenuBar menuBar;
    JMenu fileMenu;
    JMenu reportsMenu;
    JMenu helpMenu;
    JMenu bookMarkMenu;
    JMenu toolsMenu;
    JMenu indexMenu;
    JOptionPane pane;
    JMenuItem mi;
    JComboBox searchField;
    JLabel searchLabel;
	String dsDoSearch=Messages.getString("DocSearch.doSearch");
    JButton searchButton;
    JPanel[] panels;
    int numPanels = 1;
    java.util.List fileList;
    java.util.List results;
    Searcher searcher;
    Hits hits;
    Query query;
    Hyperactive hl = new Hyperactive();
    String[] colors;
    JScrollPane scrollPane;
    JEditorPane editorPane;
    JToolBar toolbar;
    JButton[] iconButtons;
    boolean hasStartPage = false;
    String startPageString = "";
    String helpPageString = "";
    private JComponentVista vista;
    private JMenu prefMenu =
        new JMenu(Messages.getString("DocSearch.printPreferences"), true);
    private JRadioButtonMenuItem scale2RadioBut =
        new JRadioButtonMenuItem(kScale2Label);
    private JRadioButtonMenuItem scaleFitRadioBut =
        new JRadioButtonMenuItem(kScaleFitLabel);
    private JRadioButtonMenuItem scaleHalfRadioBut =
        new JRadioButtonMenuItem(kScaleHalfLabel);
    private JRadioButtonMenuItem scaleOffRadioBut =
        new JRadioButtonMenuItem(kScaleOffLabel, true);
    private JRadioButtonMenuItem scaleXRadioBut =
        new JRadioButtonMenuItem(kScaleXLabel);
    private JRadioButtonMenuItem scaleYRadioBut =
        new JRadioButtonMenuItem(kScaleYLabel);

	String dsKwds=Messages.getString("DocSearch.keywords");

    printMIListener pml = new printMIListener();
    JRadioButton keywords;
    JRadioButton phrase;
    JLabel searchInLabel;
    JLabel searchTypeLabel;
    JComboBox searchIn;
    JPanel sizeAndTypePanel;
    JPanel fileTypePanel;
    JCheckBox useType;
    JComboBox fileType;
    JLabel fileTypeLabel;
    JPanel sizePanel;
    JCheckBox useSize;
    JLabel sizeFromLabel;
    JLabel sizeToLabel;
    JTextField sizeToField;
    JTextField sizeFromField;
    ButtonGroup bg;
    LinkedList backList = new LinkedList();
    LinkedList forwardList = new LinkedList();
    long maxFileSizeInt=1000000;
    int forwardPos = -1;
    int backwardPos = -1;
	String dsHome=Messages.getString("DocSearch.home");
	String dsHomeTip=Messages.getString("DocSearch.homeTip");
    public String curPage = dsHome; // home always means the last searchresults
    ArrayList indexes = new ArrayList();
    ArrayList bookmarksList = new ArrayList();
    JLabel dirLabel = new JLabel(Messages.getString("DocSearch.statusUp"));
    WordProps wp; // object to retrieve MS Word Document Properties
    ExcelProps ep; // MS Excel object
    PdfToText pp;
    RtfToText rp;
    OoToText op;

    // GUI items for advanced searching
    JPanel metaPanel;
    JPanel datePanel;
    JCheckBox useDate;
    JTextField fromField;
    JLabel fromLabel;
    JLabel toLabel;
    JTextField toField;
    CheckBoxListener cbl;
    JPanel authorPanel;
    JCheckBox useAuthor;
    JTextField authorField;
    JLabel authorLabel;
    JTabbedPane tabbedPane;
    int maxNumHitsShown = 250;
    Index idx;
	
	// STRING CONSTANTS
	static final String CREATE_SEARCHABLE_CD=Messages.getString("DocSearch.makeCD");
	static final String TOOLS=Messages.getString("DocSearch.tools");
	static final String EML_SUBJ=Messages.getString("DocSearch.emailSubject");
	static final String FROM_ADDR=Messages.getString("DocSearch.fromAddr");
	static final String dsDoHndler=Messages.getString("DocSearch.doHndlr");
	static final String dsNotIdxdMeta=Messages.getString("DocSearch.nonMetaSpiders");
	static final String dsKeywordTip=Messages.getString("DocSearch.keywordsTip");
	static final String dsPhraseTip=Messages.getString("DocSearch.phraseTip");
	static final String dsOpen=Messages.getString("DocSearch.open");
	static final String ERROR_CREATING_FOLDER=Messages.getString("DocSearch.errCreatingFold");
	static final String dsOpenTip=Messages.getString("DocSearch.openTip");
	static final String dsTitleAndDocBody=Messages.getString("DocSearch.titleAndDocBody");
	static final String dsTitle=Messages.getString("DocSearch.title");
	static final String dsSummary=Messages.getString("DocSearch.summary");
	static final String dsDocBody=Messages.getString("DocSearch.docBody");
	static final String dsSave=Messages.getString("DocSearch.dsSave");
	static final String dsSavePageTip=Messages.getString("DocSearch.dsSavePageTip");
	static final String dsOpenInBrowse=Messages.getString("DocSearch.openInBrowser");
	static final String dsOpenInBrowseTip=Messages.getString("DocSearch.openInBrowseTip");
	static final String dsBack=Messages.getString("DocSearch.back");
	static final String dsBackTip=Messages.getString("DocSearch.backTip");
	static final String DO_CD_QUEST=Messages.getString("DocSearch.doCdBld");
	static final String dsFwd=Messages.getString("DocSearch.fwd");
	static final String dsFwdTip=Messages.getString("DocSearch.fwdTip");
	static final String dsRefresh=Messages.getString("DocSearch.refresh");
	static final String dsRefreshTip=Messages.getString("DocSearch.refreshTip");
	static final String dsResults=Messages.getString("DocSearch.results");
	static final String dsResultsTip=Messages.getString("DocSearch.resultsTip");
	static final String dsBookmark=Messages.getString("DocSearch.bookmark");
	static final String dsBookmarkTip=Messages.getString("DocSearch.bookmarkTip");
	static final String dsPrint=Messages.getString("DocSearch.print");
	static final String dsPrintTip=Messages.getString("DocSearch.printTip");
	static final String dsExit=Messages.getString("DocSearch.exit");
	static final String dsExitTip=Messages.getString("DocSearch.exitTip");
	static final String SEARCH_COMPLETE=Messages.getString("DocSearch.searchComp");
	static final String dsSearchTips=Messages.getString("DocSearch.searchSuggestions");
	static final String FINISHED_COPYING=Messages.getString("DocSearch.finishedCopying");
	static final String dsHelp=Messages.getString("DocSearch.help");
	static final String dsAbout=Messages.getString("DocSearch.about");
	static final String dsReports=Messages.getString("DocSearch.reports");
	static final String dsDoMetaReport=Messages.getString("DocSearch.doMetaReport");
	static final String dsDoServletLogReport=Messages.getString("DocSearch.doServletLogReport");
	static final String dsDoNewIndex=Messages.getString("DocSearch.doNewIndex");
	static final String dsDoManageIndex=Messages.getString("DocSearch.doManageIndex");
	static final String dsReIndex=Messages.getString("DocSearch.reIndex");
	static final String dsImportIndex=Messages.getString("DocSearch.importIndex");
	static final String dsIndex=Messages.getString("DocSearch.index");
	static final String dsBookmarks=Messages.getString("DocSearch.bookmarks");
	static final String dsCkgFoUpdtsToDoc=Messages.getString("DocSearch.ckgFoUpdts");
	static final String dsClearBookmarks=Messages.getString("DocSearch.clearBookmarks");
	static final String dsAddBookmark=Messages.getString("DocSearch.addBookmark");
	static final String errLoadPage=Messages.getString("DocSearch.errorLoadingPage");
	static final String errReported=Messages.getString("DocSearch.errorReported");
	static final String loadingP=Messages.getString("DocSearch.loadingPage");
	static final String cmdUsage=Messages.getString("DocSearch.cmdUsage");
	static final String plsWait=Messages.getString("DocSearch.plsWait");
	static final String dsFileTooBig=Messages.getString("DocSearch.skippingFileTooBig");
	static final String waitForIndexUpDate=Messages.getString("DocSearch.idxUpdating");
	static final String ckFoUpdaTo=Messages.getString("DocSearch.ckForUpdatesTo");
	static final String updComp=Messages.getString("DocSearch.upDaComp");
	static final String dsTpx=Messages.getString("DocSearch.topics");
	static final String dsErrPrint=Messages.getString("DocSearch.errPrinting");
	static final String dsErrIdxg=Messages.getString("DocSearch.errIdxg");
	static final String dsErrObtSi=Messages.getString("DocSearch.errObtSize");
	static final String dsErr=Messages.getString("DocSearch.err");
	static final String dsSchin=Messages.getString("DocSearch.Searching");
	static final String dsUpdts=Messages.getString("DocSearch.updates");
	static final String idxFldr=Messages.getString("DocSearch.idxFldr");
	static final String dsExists=Messages.getString("DocSearch.exists");
	static final String dsErrLower=Messages.getString("DocSearch.errLowerCase");
	static final String dsFSE=Messages.getString("DocSearch.errFilSave");
	static final String dsWasSaved=Messages.getString("DocSearch.wasSaved");
	static final String dsNone=Messages.getString("DocSearch.none");
	static final String dsRsltsFoSch=Messages.getString("DocSearch.rsltsForSrch");
	static final String dsErrParseNums=Messages.getString("DocSearch.errParseNumFs");
	static final String dsSrchStr=Messages.getString("DocSearch.srchStr");
	static final String dsDocsFndInIndx=Messages.getString("DocSearch.docFndInIndx");
	static final String dsNumNewFiles=Messages.getString("DocSearch.newFiles");
	static final String dsNumDelFiles=Messages.getString("DocSearch.deletedFiles");
	static final String dsNumUnchangedFiles=Messages.getString("DocSearch.unchangedFiles");
	static final String dsNumchangedFiles=Messages.getString("DocSearch.changedFiles");  
	static final String dsDox=Messages.getString("DocSearch.dox");
	static final String dsMxNumHits=Messages.getString("DocSearch.maxNumHits");
	static final String dsExceeded=Messages.getString("DocSearch.exceeded");
	static final String dsUnk=Messages.getString("DocSearch.unk");
	static final String dsFailIdxDocs=Messages.getString("DocSearch.fldUpdates");
	static final String dsTtlDxInIdx=Messages.getString("DocSearch.ttlDox");
	static final String dsErrParseScore=Messages.getString("DocSearch.errParseScore");
	static final String dsWasNotSearched=Messages.getString("DocSearch.wns");
	static final String dsOpt=Messages.getString("DocSearch.dsOpt");
	static final String dsTotalDocsFndIndx=Messages.getString("DocSearch.tdfi");
	static final String dsTotHits=Messages.getString("DocSearch.totHits");
	static final String dsErrPrfSrch=Messages.getString("DocSearch.errPerfSrch");
	static final String dsCrptdIdx=Messages.getString("DocSearch.crptdIdx");
	static final String dsMkIdx=Messages.getString("DocSearch.makeIdx");
	static final String FOLDER_ALREADY_EXISTS=Messages.getString("DocSearch.foldAlreadyMade");
	static final String dsErrLdgFi=Messages.getString("DocSearch.errLdgFi");
	static final String dsErrSetPa=Messages.getString("DocSearch.errSetPa");
	static final String dsErrLdgPa=Messages.getString("DocSearch.errLdgPa");
	static final String PROVIDE_TEXT=Messages.getString("DocSearch.errNoText");
	static final String dsErrSaFi=Messages.getString("DocSearch.errSaveFi");
	static final String dsIdxg=Messages.getString("DocSearch.idxg");
	static final String dsLdg=Messages.getString("DocSearch.ldg");
	static final String dsLoaded=Messages.getString("DocSearch.loaded");
	static final String dsDaysOld=Messages.getString("DocSearch.daysOld");
	static final String dsNotExist=Messages.getString("DocSearch.errDoesntExist");
	static final String dsErrIdxgFi=Messages.getString("DocSearch.errIdxng");
	static final String dsMetaFiles=Messages.getString("DocSearch.metaF");
	static final String dsFndFldr=Messages.getString("DocSearch.foundFldr");
	static final String dsIdxCrtd=Messages.getString("DocSearch.idxCreated");
	static final String dsIdxsRblt=Messages.getString("DocSearch.idxsReblt");
	static final String dsBknLink=Messages.getString("DocSearch.bknLink");
	static final String lnkNoChanges=Messages.getString("DocSearch.nonCHangedLink");
	static final String dsReIdxgLnk=Messages.getString("DocSearch.reIdxgLnk");
	static final String dsSpdrUpdteComp=Messages.getString("DocSearch.dsSpiderUpdtComp");
	static final String dsLkngFoLnx=Messages.getString("DocSearch.lookingForLinks");
	static final String dsSpiderNewUrl=Messages.getString("DocSearch.dsSpiderNewUrl");
	static final String dsRmvgIdxFis=Messages.getString("DocSearch.rmvgIdxFis");
	static final String dsDeleting=Messages.getString("DocSearch.deleting");
	static final String CREATE_NEW_SPIDER_IDX=Messages.getString("DocSearch.createSpideredIdx");
	static final String dsIdxRemoved=Messages.getString("DocSearch.idxRemoved");
	static final String dsUnZipn=Messages.getString("DocSearch.unzippn");
	static final String dsUnZipD=Messages.getString("DocSearch.unzipd");
	static final String dsUpdtArchTbl=Messages.getString("DocSearch.updtgArchTbl");
	static final String dsArchTblUpdtd=Messages.getString("DocSearch.archTblUpdtd");
	static final String dsPcntDnld=Messages.getString("DocSearch.pcntDnld");
	static final String dsOfFile=Messages.getString("DocSearch.ofFile");
	static final String dsBytsTot=Messages.getString("DocSearch.totalBytes");
	static final String dsDnLdErr=Messages.getString("DocSearch.errDnLd");
	static final String dsImptg=Messages.getString("DocSearch.importing");
	static final String dsImprtDn=Messages.getString("DocSearch.imprtDone");
	static final String dsImprtSuccess=Messages.getString("DocSearch.imprtSuccess");
	static final String dsWasImprtd=Messages.getString("DocSearch.wasImprtd");
	static final String dsErrImptg=Messages.getString("DocSearch.errImprtg");
	static final String dsArchDescFnd=Messages.getString("DocSearch.archDescFnd");
	static final String dsErrParseMnfst=Messages.getString("DocSearch.errParseMnfst");
	static final String COPY_FILE=Messages.getString("DocSearch.copyFile");
	static final String COPYING_FILE=Messages.getString("DocSearch.copyingFile");
	String defaultHndlr="";
	
DocSearch()  {
      super(Messages.getString("DocSearch.appTitle"));
	//
	File testCDFi=new File(cdRomDefaultHome);
	Properties sys = new Properties(System.getProperties());
	if (testCDFi.exists()) {
		sys.setProperty("disableLuceneLocks", "true");
		System.out.println(Messages.getString("DocSearch.disableLocks"));
		}
	else sys.setProperty("disableLuceneLocks", "false");
	//
	checkCdDir();
	defaultHndlr=getBrowserFile();
	loadPrefs();
	//
	phrase = new JRadioButton(Messages.getString("DocSearch.phrase"));
	searchField = new JComboBox();
	searchField.addActionListener(new comboListener());
	searchIn = new JComboBox(searchOpts);
	searchTypeLabel = new JLabel(Messages.getString("DocSearch.searchType"));
	searchInLabel = new JLabel(Messages.getString("DocSearch.searchIn"));
	keywords = new JRadioButton(dsKwds);
	//
	searchLabel = new JLabel(Messages.getString("DocSearch.searchFor"));
	searchButton = new JButton(dsDoSearch);
	//
    	htmlTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "htm.gif")+"\" border = \"0\" alt = \"Web Page Document\">";
    	wordTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "doc.gif")+"\" border = \"0\" alt = \"MS Word Document\">";
    	excelTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "xls.gif")+"\" border = \"0\" alt = \"MS Excel Document\">";
    	pdfTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "pdf.gif")+"\" border = \"0\" alt = \"PDF Document\">";
    	textTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "txt.gif")+"\" border = \"0\" alt = \"Text Document\">";
    	rtfTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "rtf.gif")+"\" border = \"0\" alt = \"RTF Document\">";
    	ooImpressTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "ooimpress-32x32.png")+"\" border = \"0\" alt = \"Open Office Impress Document\">";
    	ooWriterTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "oowriter-32x32.png")+"\" border = \"0\" alt = \"Open Office Writer Document\">";
    	ooCalcTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "oocalc-32x32.png")+"\" border = \"0\" alt = \"Open Office Calc Document\">";
    	ooDrawTag = "<img src = \""+fileString+Utils.addFolder(iconDir, "oo.gif")+"\" border = \"0\" alt = \"Open Office Draw Document\">";
		//
        idx = new Index(this);
        colors = new String[2];  colors[0] = "ffeffa";    colors[1] = "fdffda";
        startPageString = Utils.addFolder(startDir, "start_page.htm");
	helpPageString = Utils.addFolder(startDir, "help_page.htm");
        File startPageFile = new File(startPageString);
        if (startPageFile.exists()) {
		System.out.println("Start Page is: "+startPageString);
		hasStartPage = true;
		}
	  else {
		System.out.println("Start Page NOT FOUND where expected: "+startPageString);
		}
        defaultSaveFolder = Utils.addFolder(workingDir, "saved_searches");
        iconDir = Utils.addFolder(startDir, "icons");
        File iconFolder = new File(iconDir);
        searchField.setEditable(true);
        searchField.addItem("");

        bg = new ButtonGroup();
        bg.add(phrase);
        bg.add(keywords);
        keywords.setSelected(true);
        
        keywords.setToolTipText(dsKeywordTip);
        phrase.setToolTipText(dsPhraseTip);

        int iconInt = 2;
        searchIn.setSelectedIndex(3);
        searchField.setPreferredSize(new Dimension(370, 22));

        if (iconFolder.exists())  {
            int numIcons = 12;
            toolbar = new JToolBar();
            iconButtons = new JButton[numIcons];

            iconButtons[0] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir, "open.gif")));
            iconButtons[0].setToolTipText(dsOpenTip);
            iconButtons[0].setActionCommand(dsOpen);
            iconButtons[0].addActionListener(this);
            iconButtons[0].setMnemonic(KeyEvent.VK_O);

            iconButtons[1] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir, "save.gif")));
            iconButtons[1].setToolTipText(dsSavePageTip);
            iconButtons[1].setActionCommand(dsSave);
            iconButtons[1].addActionListener(this);
            iconButtons[1].setMnemonic(KeyEvent.VK_S);

            iconButtons[2] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir,
                                                          "open_in_browser.gif")));
            iconButtons[2].setToolTipText(dsOpenInBrowseTip);
            iconButtons[2].setActionCommand(dsOpenInBrowse);
            iconButtons[2].addActionListener(this);
            iconButtons[2].setMnemonic(KeyEvent.VK_E);

            iconButtons[3] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir, "back.gif")));
            iconButtons[3].setToolTipText(dsBackTip);
            iconButtons[3].setActionCommand(dsBack);
            iconButtons[3].addActionListener(this);
            iconButtons[3].setMnemonic(KeyEvent.VK_B);

            iconButtons[4] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir, "home.gif")));
            iconButtons[4].setToolTipText(dsHome);
            iconButtons[4].setActionCommand(dsHomeTip);
            iconButtons[4].addActionListener(this);
            iconButtons[4].setMnemonic(KeyEvent.VK_H);

            iconButtons[5] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir, "forward.gif")));
            iconButtons[5].setToolTipText(dsFwdTip);
            iconButtons[5].setActionCommand(dsFwd);
            iconButtons[5].addActionListener(this);
            iconButtons[5].setMnemonic(KeyEvent.VK_F);

            iconButtons[6] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir, "refresh.gif")));
            iconButtons[6].setToolTipText(dsRefreshTip);
            iconButtons[6].setActionCommand(dsRefresh);
            iconButtons[6].addActionListener(this);
            iconButtons[6].setMnemonic(KeyEvent.VK_L);

            iconButtons[7] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir,
                                                          "search_results.gif")));
            iconButtons[7].setToolTipText(dsResultsTip);
            iconButtons[7].setActionCommand(dsResults);
            iconButtons[7].addActionListener(this);
            iconButtons[7].setMnemonic(KeyEvent.VK_R);

            iconButtons[8] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir,
                                                          "bookmark.gif")));
            iconButtons[8].setToolTipText(dsBookmarkTip);
            iconButtons[8].setActionCommand(dsBookmark);
            iconButtons[8].addActionListener(this);
            iconButtons[8].setMnemonic(KeyEvent.VK_M);

            iconButtons[9] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir, "print.gif")));
            iconButtons[9].setToolTipText(dsPrintTip);
            iconButtons[9].setActionCommand(dsPrint);
            iconButtons[9].addActionListener(pml);
            iconButtons[9].setMnemonic(KeyEvent.VK_P);
	    
            iconButtons[10] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir, "options.gif")));
            iconButtons[10].setToolTipText(dsOpt);
            iconButtons[10].setActionCommand(dsOpt);
            iconButtons[10].addActionListener(this);
            iconButtons[10].setMnemonic(KeyEvent.VK_HOME);
	    
            iconButtons[numIcons - 1] =
                new JButton(new ImageIcon(Utils.addFolder(iconDir, "quite.gif")));
            iconButtons[numIcons - 1].setToolTipText(dsExitTip);
            iconButtons[numIcons - 1].setActionCommand(dsExit);
            iconButtons[numIcons - 1].addActionListener(this);
            iconButtons[numIcons - 1].setMnemonic(KeyEvent.VK_X);

            for (int i = 0; i < numIcons; i++)
            {
                // add the icons to the toolbar
                toolbar.add(iconButtons[i]);
                if ((i == 1) || (i == 2) || (i == 5) || (i >= 7))
                {
                    toolbar.addSeparator();
                }

                toolbar.setFloatable(false);
            }

            iconButtons[5].setEnabled(false); // forward
            iconButtons[3].setEnabled(false); // back

            Image iconImage =
                Toolkit.getDefaultToolkit().getImage(Utils.addFolder(iconDir,
                                                                     "ds.gif"));
            this.setIconImage(iconImage);
        }
        else
        {
            hasIcons = false;
            iconInt = 1;
        }

        menuBar = new JMenuBar();
        fileMenu = new JMenu(Messages.getString("DocSearch.File"));

        // print gui items
        JMenuItem printMI = new JMenuItem(dsPrint);
        printMI.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,
                                                      Event.CTRL_MASK));
        scale2RadioBut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D,
                                                             Event.CTRL_MASK));
        scaleFitRadioBut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F,
                                                               Event.CTRL_MASK));
        scaleHalfRadioBut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H,
                                                                Event.CTRL_MASK));
        scaleOffRadioBut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
                                                               Event.CTRL_MASK));
        scaleXRadioBut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W,
                                                             Event.CTRL_MASK));
        scaleYRadioBut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L,
                                                             Event.CTRL_MASK));
        printMI.addActionListener(pml);

        scaleXRadioBut.addActionListener(new scaleXListener());
        scaleYRadioBut.addActionListener(new scaleYListener());
        scaleFitRadioBut.addActionListener(new scaleFitListener());
        scaleHalfRadioBut.addActionListener(new scaleHalfListener());
        scale2RadioBut.addActionListener(new scale2Listener());

        ButtonGroup scaleSetGroup = new ButtonGroup();
        scaleSetGroup.add(scale2RadioBut);
        scaleSetGroup.add(scaleFitRadioBut);
        scaleSetGroup.add(scaleHalfRadioBut);
        scaleSetGroup.add(scaleOffRadioBut);
        scaleSetGroup.add(scaleXRadioBut);
        scaleSetGroup.add(scaleYRadioBut);
        prefMenu.add(scaleXRadioBut);
        prefMenu.add(scaleYRadioBut);
        prefMenu.add(scaleFitRadioBut);
        prefMenu.add(scaleHalfRadioBut);
        prefMenu.add(scale2RadioBut);
        prefMenu.addSeparator();
        prefMenu.add(scaleOffRadioBut);
        fileMenu.add(prefMenu);
        fileMenu.add(printMI);
	//
        bookMarkMenu = new JMenu(dsBookmarks);
        mi = new JMenuItem(dsAddBookmark);
        mi.addActionListener(this);
        bookMarkMenu.add(mi);
	//
	toolsMenu=new JMenu(TOOLS);
	mi = new JMenuItem(CREATE_SEARCHABLE_CD);
        mi.addActionListener(this);
        toolsMenu.add(mi);
	toolsMenu.addSeparator();
	mi = new JMenuItem(dsOpt);
        mi.addActionListener(this);
        toolsMenu.add(mi);
	//
        mi = new JMenuItem(dsClearBookmarks);
        mi.addActionListener(this);
        bookMarkMenu.add(mi);

        bookMarkMenu.addSeparator();

        // add and loaded bookmarks
        indexMenu = new JMenu(dsIndex);
        mi = new JMenuItem(dsDoNewIndex);
        mi.addActionListener(this);
        indexMenu.add(mi);
	//
	mi = new JMenuItem(CREATE_NEW_SPIDER_IDX);
        mi.addActionListener(this);
        indexMenu.add(mi);
	//
        mi = new JMenuItem(dsDoManageIndex);
        mi.addActionListener(this);
        indexMenu.add(mi);

        mi = new JMenuItem(dsReIndex);
        mi.addActionListener(this);
        indexMenu.add(mi);

        indexMenu.addSeparator();
        mi = new JMenuItem(dsImportIndex);
        mi.addActionListener(this);
        indexMenu.add(mi);

        fileMenu.addSeparator();
        mi = new JMenuItem(dsExit);
        mi.addActionListener(this);
        fileMenu.add(mi);

        helpMenu = new JMenu(dsHelp);
        mi = new JMenuItem(dsSearchTips);
        mi.addActionListener(this);
        helpMenu.add(mi);
        mi = new JMenuItem(dsAbout);
        mi.addActionListener(this);
        helpMenu.add(mi);
	// dsTpx
        mi = new JMenuItem(dsTpx);
        mi.addActionListener(this);
        helpMenu.add(mi);
	//
        reportsMenu = new JMenu(dsReports);
        mi = new JMenuItem(dsDoMetaReport);
        mi.addActionListener(this);
        reportsMenu.add(mi);
        mi = new JMenuItem(dsDoServletLogReport);
        mi.addActionListener(this);
        reportsMenu.add(mi);
        menuBar.add(fileMenu);
        menuBar.add(indexMenu);
        menuBar.add(bookMarkMenu);
        menuBar.add(reportsMenu);
	menuBar.add(toolsMenu);
        menuBar.add(helpMenu);
        setJMenuBar(menuBar);

        results = new ArrayList();

        editorPane = new JEditorPane("text/html", lastSearch);
        editorPane.setEditable(false);
        editorPane.addHyperlinkListener(hl);
        if (hasStartPage) {
            try {
			editorPane.setContentType("text/html");
                  if (setPage("home")) System.out.println("LOADED START PAGE: "+startPageString);
            }
            catch (Exception eL) {
                editorPane.setText(lastSearch);
            }
        }
		else {
			System.out.println("NO START PAGE LOADED.");
			}

        scrollPane = new JScrollPane(editorPane);
        scrollPane.setPreferredSize(new Dimension(1024, 720));
        scrollPane.setMinimumSize(new Dimension(900, 670));
        scrollPane.setMaximumSize(new Dimension(1980, 1980));

        // create panels
        // add printing stuff
        vista = new JComponentVista(editorPane, new PageFormat());

        JPanel topPanel = new JPanel();
        JPanel bottomPanel = new JPanel();
        topPanel.add(searchLabel);
        topPanel.add(searchField);
        topPanel.add(searchButton);
        bottomPanel.add(searchTypeLabel);
        bottomPanel.add(keywords);
        bottomPanel.add(phrase);
        bottomPanel.add(searchInLabel);
        bottomPanel.add(searchIn);

        searchButton.setMnemonic(KeyEvent.VK_A);

        // GUI items for advanced searching
        metaPanel = new JPanel();
        datePanel = new JPanel();
        useDate = new JCheckBox(Messages.getString("DocSearch.useDateProps"));
        fromField = new JTextField(11);
        fromLabel = new JLabel(Messages.getString("DocSearch.from"));
        toLabel = new JLabel(Messages.getString("DocSearch.to"));
        toField = new JTextField(11);
        cbl = new CheckBoxListener();
        authorPanel = new JPanel();
        useAuthor = new JCheckBox(Messages.getString("DocSearch.useAuthProps"));
        authorField = new JTextField(31);
        authorLabel = new JLabel(Messages.getString("DocSearch.author"));
        tabbedPane = new JTabbedPane();
        authorPanel.add(useAuthor);
        authorPanel.add(authorLabel);
        authorPanel.add(authorField);

        // combine stuff
        datePanel.add(useDate);
        datePanel.add(fromLabel);
        datePanel.add(fromField);
        datePanel.add(toLabel);
        datePanel.add(toField);

        metaPanel.setLayout(new BorderLayout());
        metaPanel.setBorder(new TitledBorder(Messages.getString("DocSearch.dateAndAuthor")));
        metaPanel.add(datePanel, BorderLayout.NORTH);
        metaPanel.add(authorPanel, BorderLayout.SOUTH);

        useDate.addActionListener(cbl);
        useAuthor.addActionListener(cbl);

        fromField.setText(DateTimeUtils.getLastYear());
        toField.setText(DateTimeUtils.getToday());
        authorField.setText(System.getProperty("user.name"));

        panels = new JPanel[numPanels];
        for (int i = 0; i < numPanels; i++)
        {
            panels[i] = new JPanel();
        }

        // add giu to panels
        panels[0].setLayout(new BorderLayout());
        panels[0].add(topPanel, BorderLayout.NORTH);
        panels[0].add(bottomPanel, BorderLayout.SOUTH);
        panels[0].setBorder(new TitledBorder(Messages.getString("DocSearch.searchCritera")));
        searchButton.addActionListener(this);

        sizeAndTypePanel = new JPanel();
        fileTypePanel = new JPanel();
        useType = new JCheckBox(Messages.getString("DocSearch.useFileCritera"));
        useType.addActionListener(cbl);
        fileType = new JComboBox(fileTypesToFind);
        fileTypeLabel = new JLabel(Messages.getString("DocSearch.findOnlyTheseFileTypes"));
        fileTypePanel.add(useType);
        fileTypePanel.add(fileTypeLabel);
        fileTypePanel.add(fileType);

        sizePanel = new JPanel();
        useSize = new JCheckBox(Messages.getString("DocSearch.useFileSizeCriteria"));
        useSize.addActionListener(cbl);
        sizeFromLabel = new JLabel(Messages.getString("DocSearch.fromK"));
        sizeToLabel = new JLabel(Messages.getString("DocSearch.toK"));
        sizeFromField = new JTextField(10);
        sizeFromField.setText("0");
        sizeToField = new JTextField(10);
        sizeToField.setText("100");
        sizePanel.add(useSize);
        sizePanel.add(sizeFromLabel);
        sizePanel.add(sizeFromField);
        sizePanel.add(sizeToLabel);
        sizePanel.add(sizeToField);

        sizeAndTypePanel.setLayout(new BorderLayout());
        sizeAndTypePanel.setBorder(new TitledBorder(Messages.getString("DocSearch.typeAndSize")));
        sizeAndTypePanel.add(fileTypePanel, BorderLayout.NORTH);
        sizeAndTypePanel.add(sizePanel, BorderLayout.SOUTH);

        // set up the tabbed pane
        tabbedPane.addTab(Messages.getString("DocSearch.genOpts"), null, panels[0],
                          Messages.getString("DocSearch.genSeCri"));
        tabbedPane.addTab(Messages.getString("DocSearch.dateAndAuthor"), null, metaPanel,
                          Messages.getString("DocSearch.dateAuthProp"));
        tabbedPane.addTab(Messages.getString("DocSearch.typeAndSize"), null, sizeAndTypePanel,
                          Messages.getString("DocSearch.typeAndSizeOpt"));

        // gridbag
        getContentPane().setLayout(new GridLayout(1, numPanels + iconInt + 1));
        GridBagLayout gridbaglayout = new GridBagLayout();
        GridBagConstraints gridbagconstraints = new GridBagConstraints();
        getContentPane().setLayout(gridbaglayout);
        int start = 0;
        if (hasIcons)
        {
            gridbagconstraints.fill = GridBagConstraints.HORIZONTAL;
            gridbagconstraints.insets = new Insets(1, 1, 1, 1);
            gridbagconstraints.gridx = 0;
            gridbagconstraints.gridy = 0;
            gridbagconstraints.gridwidth = 1;
            gridbagconstraints.gridheight = 1;
            gridbagconstraints.weightx = 1.0D;
            gridbagconstraints.weighty = 0.0D;
            gridbaglayout.setConstraints(toolbar, gridbagconstraints);
            getContentPane().add(toolbar);
            start++;
        }

        for (int i = 0; i < numPanels; i++)
        {
            if (i == 0)
            {
                gridbagconstraints.fill = GridBagConstraints.HORIZONTAL;
                gridbagconstraints.insets = new Insets(1, 1, 1, 1);
                gridbagconstraints.gridx = 0;
                gridbagconstraints.gridy = i + start;
                gridbagconstraints.gridwidth = 1;
                gridbagconstraints.gridheight = 1;
                gridbagconstraints.weightx = 1.0D;
                gridbagconstraints.weighty = 0.0D;
                gridbaglayout.setConstraints(tabbedPane, gridbagconstraints);
                getContentPane().add(tabbedPane);
            }
            else
            {
                gridbagconstraints.fill = GridBagConstraints.HORIZONTAL;
                gridbagconstraints.insets = new Insets(1, 1, 1, 1);
                gridbagconstraints.gridx = 0;
                gridbagconstraints.gridy = i + start;
                gridbagconstraints.gridwidth = 1;
                gridbagconstraints.gridheight = 1;
                gridbagconstraints.weightx = 1.0D;
                gridbagconstraints.weighty = 0.0D;
                gridbaglayout.setConstraints(panels[i], gridbagconstraints);
                getContentPane().add(panels[i]);
            }
        }

        // now add the results area
        gridbagconstraints.fill = GridBagConstraints.HORIZONTAL;
        gridbagconstraints.insets = new Insets(1, 1, 1, 1);
        gridbagconstraints.gridx = 0;
        gridbagconstraints.gridy = iconInt;
        gridbagconstraints.gridwidth = 1;
        gridbagconstraints.gridheight = 1;
        gridbagconstraints.weightx = 1.0D;
        gridbagconstraints.weighty = 1.0D;
        gridbaglayout.setConstraints(scrollPane, gridbagconstraints);
        getContentPane().add(scrollPane);
        JPanel statusP = new JPanel();
        statusP.add(dirLabel);

        // now add the status label
        gridbagconstraints.fill = GridBagConstraints.HORIZONTAL;
        gridbagconstraints.insets = new Insets(1, 1, 1, 1);
        gridbagconstraints.gridx = 0;
        gridbagconstraints.gridy = numPanels + iconInt;
        gridbagconstraints.gridwidth = 1;
        gridbagconstraints.gridheight = 1;
        gridbagconstraints.weightx = 1.0D;
        gridbagconstraints.weighty = 0.0D;
        gridbaglayout.setConstraints(statusP, gridbagconstraints);
        getContentPane().add(statusP);

        //
        File testArchDir = new File(archiveDir);
        if (!testArchDir.exists()) {
            boolean madeDir = testArchDir.mkdir();
            if (!madeDir) System.out.println(Messages.getString("DocSearch.errCreateDir"));
            else System.out.println(Messages.getString("DocSearch.dirCreated") + archiveDir);
        }
        loadIndexes();
	String handlersFiName;
	if (!isCDSearchTool) handlersFiName=Utils.addFolder(workingDir, "handlers_list.htm");
	else handlersFiName=handlersFiName=Utils.addFolder(cdRomDefaultHome, "handlers_list.htm");
	if (!Utils.exists(handlersFiName)) {
		System.out.println("Handlers file not found at: "+handlersFiName);
		getHandlers();
		}
	else doObjectLoad(0, handlersFiName);
		//
    }


public void init() {
	//
        // GUI BUILDING
        // close window item
        this.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent windowevent) {
                    doExit();
                }
            });

        // center on the screen
        Dimension screenD = Toolkit.getDefaultToolkit().getScreenSize();
        int screenWidth = screenD.width;
        int screenHeight = screenD.height;
        setSize(kDefaultX, kDefaultY);
        int newX = 0;
        int newY = 0;
        if (screenWidth > kDefaultX)
        {
            newX = (screenWidth - kDefaultX) / 2;
        }

        if (screenHeight > kDefaultY)
        {
            newY = (screenHeight - kDefaultY) / 2;
        }

        if ((newX != 0) || (newY != 0))
        {
            setLocation(newX, newY);
        }

        // now determine if we need to create an index
        if ((!hasIndex()) && (!isCDSearchTool)) {
            curStatusString = Messages.getString("DocSearch.initIndex");
            String contentFolderS = Utils.addFolder(startDir, "content");
            File testCF = new File(contentFolderS);
            if (testCF.exists())
            {
                try
                {
                    DocSearcherIndex di =
                        new DocSearcherIndex(contentFolderS, "default index",
                                             true, 20,
                                             Utils.addFolder(indexDir, "default"),
                                             false, "", "", 0, archiveDir);
                    createNewIndex(di, false);
                }
                catch (Exception eS)
                {
                    showMessage(Messages.getString("DocSearch.errCreatingIdx"), eS.toString());
                }
            }
        }

        // HANDLE ERRORS
        isLoading = false;
        if (hasErr) showMessage(Messages.getString("DocSearch.initErr"), errString);
        // ensure that the word and excel scratch files are saved as blanks
        StringBuffer blankBuf = new StringBuffer();
        blankBuf.append("      ");
        saveFile(excelTextFile, blankBuf);
        saveFile(wordTextFile, blankBuf);
        // set up our fields;
        cb();
    }

    public void checkUpdates() {
        int numDis = indexes.size();
        if (numDis > 0) {
            setStatus(plsWait+waitForIndexUpDate);
            Iterator it = indexes.iterator();
            DocSearcherIndex di;
            int curDays = 0;
            while (it.hasNext()) {
                di = (DocSearcherIndex)it.next();
                curDays = DateTimeUtils.getDaysOld(di);
                setStatus(ckFoUpdaTo + di.desc);
                switch (di.indexPolicy) {
                case 0: // When I say so
                    break;
                case 1: // During Startup
                    idx.updateIndex(di);
                    break;
                case 2: // When Index > 1 Day Old
                    if (curDays > 1) idx.updateIndex(di);
                    break;
                case 3: // When Index > 5 Days old
                    if (curDays > 5) idx.updateIndex(di);
                    break;
                case 4: // When Index > 30 Days Old
                    if (curDays > 30) idx.updateIndex(di);
                    break;
                case 5: // When Index > 60 Days Old
                    if (curDays > 60) idx.updateIndex(di);
                    break;
                case 6: // When Index > 90 Days Old
                    if (curDays > 90) idx.updateIndex(di);
                    break;
                case 7: // When Index > 180 Days Old
                    if (curDays > 180) idx.updateIndex(di);
                    break;
                case 8: // When Index > 365 Days Old
                    if (curDays > 365) idx.updateIndex(di);
                    break;
                default: // whatever
                    break;
                }
            }
        }
        setStatus(updComp);
    }

public void handleEventCommand(String s) {
        try {
            // we run validation in a thread so as not to interfere
            // with repaints of GUI
            if (s.equals(dsExit)) doExit();
	    else if (s.equals(CREATE_SEARCHABLE_CD)) doSearchableCdWiz();
	    else if (s.equals(dsOpt)) doHandlers();
	    else if (s.equals(CREATE_NEW_SPIDER_IDX)) doNewSpiderIdx();
            else if (s.equals(dsRefresh)) setPage(curPage);
            else if (s.equals(dsDoMetaReport)) doMetaReport();
            else if (s.equals(dsDoServletLogReport)) getSeachLogReport();
            else if (s.equals(dsFwd)) doForward();
            else if (s.equals(dsAbout))  showMessage(dsAbout, Messages.getString("DocSearch.versionText")+" "+Messages.getString("DocSearch.version")+"\n\n"+aboutString);
            else if (s.equals(dsOpen)) doOpen();
            else if (s.equals(dsSave)) doSave();
            else if (s.equals(dsSearchTips))  showMessage(dsSearchTips, searchTips);
            else if (s.equals(dsOpenInBrowse)) doExternal(curPage);
            else if (s.equals(dsBack)) doBack();
            else if (s.equals(dsDoNewIndex)) doNewIndex();
            else if (s.equals(dsReIndex))  rebuildIndexes();
	    else if (s.equals(dsDoSearch)) {
	    	doThreadedSearch();
		}
            else if (s.equals(dsDoManageIndex)) { doManageIndexes(); lastSearchedText=""; }
            else if (s.equals(dsImportIndex)) getImportInfo();
            else if ((s.equals(dsBookmark)) || (s.equals(dsAddBookmark))) doBookmark();
            else if (s.equals(dsClearBookmarks)) {
                bookmarksList.clear();
                File bmf = new File(bookmarksFile);
                boolean wasCleared = true;
                String errString = "";
                if (bmf.exists())
                {
                    try
                    {
                        bmf.delete();
                    }
                    catch (Exception eF)
                    {
                        wasCleared = false;
                        errString = eF.toString();
                    }
                }

                if (!wasCleared) showMessage(Messages.getString("DocSearch.errRemoBkMks"), errString);
                else showMessage(Messages.getString("DocSearch.bmClrd"),
                                Messages.getString("DocSearch.bmClrdMsg"));
            }
            else if (s.equals(dsTpx)) {
                    try {
                        setPage(fileString + helpPageString);
                    }
                    catch (Exception eL) {
                        // error message
                        editorPane.setText(lastSearch);
                    }
            }

            else if (s.equals(dsResults)) {
                editorPane.setContentType("text/html");
                editorPane.setText(lastSearch);
                editorPane.select(0, 0);
                iconButtons[5].setEnabled(false); // forward
                iconButtons[3].setEnabled(false); // back

                backList = new LinkedList();
                forwardList = new LinkedList();
                forwardPos = -1;
                backwardPos = -1;
                curPage = "results";
            }
            else if (s.equals(dsHome))  {
                editorPane.setContentType("text/html");
                if (hasStartPage)
                {
                    try
                    {
                        setPage(fileString + startPageString);
                    }
                    catch (Exception eL)
                    {
                        // error message
                        editorPane.setText(lastSearch);
                    }

                    curPage = dsHome;
                }
                else
                {
                    editorPane.setText(lastSearch);
                    editorPane.select(0, 0);
                    curPage = "results";
                }

                iconButtons[5].setEnabled(false); // forward
                iconButtons[3].setEnabled(false); // back

                backList = new LinkedList();
                forwardList = new LinkedList();
                forwardPos = -1;
                backwardPos = -1;
            }
            else  {
                if ((s.startsWith("file:/")) || (s.startsWith("http")))
                {
                    setPage(s);
                    forwardPos = -1;
                    backwardPos = -1;
                    backList = new LinkedList();
                    forwardList = new LinkedList();
                    iconButtons[5].setEnabled(false); // forward
                    iconButtons[3].setEnabled(false); // back
                }
            }
        }
        catch (Exception eF)
        {
            System.out.println("Action thread was stopped!\n" + eF.toString());
            eF.printStackTrace();
        }
    }


    public void actionPerformed(ActionEvent actionevent)  {
        String a = actionevent.getActionCommand();
	GuiThread g=new GuiThread(this, a);
	g.start();
    }

    public boolean hasIndex()  {
        boolean returnBool = true;
        File indexFolder = new File(indexDir);
        if (!indexFolder.exists()) {
            returnBool = false;
        }
        else if (useGui) setStatus(idxFldr +" "+ indexDir +" "+ dsExists);
        return returnBool;
    }

    public void setStatus(String toSet) {
        if ((!isLoading) && (useGui)) {
            dirLabel.setText(toSet);
            //System.out.println(toSet);
        }
        else System.out.println(toSet);
    }

public int getConfirmation(String details, String title) {
	int n = JOptionPane.showConfirmDialog(this, 
		title, 
		details, 
		JOptionPane.YES_NO_OPTION); 
	return n;
}

public boolean getConfirmationMessage(String title, String details) {
	boolean returnBool=false;
	MessageConfirmRunner mct = new MessageConfirmRunner (title, details, this);
	try {
		SwingUtilities.invokeAndWait(mct);
		int returnedInt=mct.returnInt;
		if (returnedInt==JOptionPane.YES_OPTION) returnBool=true;
		return returnBool;
		}
	catch (Exception eM) {
		eM.printStackTrace();
		return returnBool;
		}
} // end for getConfirmationMessage


public void showMessage(String title, String details) {
        MessageRunner mesThread = new MessageRunner(title, details, this);
        try {
            SwingUtilities.invokeLater(mesThread);
        }
        catch (Exception eM) {
            eM.printStackTrace();
        }
 }

public void showMessageDialog(String title, String body) {
        if ((!isLoading) && (useGui)) {
            int messageType = JOptionPane.INFORMATION_MESSAGE;
            if (title.toLowerCase().indexOf(dsErrLower) != -1) {
                messageType = JOptionPane.ERROR_MESSAGE;
            }

            pane = new JOptionPane((Object)body, messageType);
            JDialog dialog = pane.createDialog(this, title);
            dialog.setVisible(true);
        }
        else System.out.println(" * * * " + title + " * * *\n\t" + body);
    }

    public void saveFile(String fileName,
                         StringBuffer content) {
        String saveStr = "";
        boolean error = false;
        try {
            File saveFile;
            saveFile = new File(fileName);
            FileWriter writer = new FileWriter(saveFile);
            saveStr = content.toString();
            int saveStrLen = saveStr.length();
            for (int i = 0; i < saveStrLen; i++) writer.write((int)saveStr.charAt(i));
            writer.close();
        }
        catch (Exception eF) {
            setStatus(dsFSE+" " + eF.toString() + " " + fileName);
            error = true;
        }

        if (!error) {
            if (useGui)  setStatus(fileName +" "+ dsWasSaved);
        }
    }

    public void saveFile(String fileName,
                         String savePath,
                         StringBuffer content)
    {
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        String saveStr = "";
        boolean error = false;
        try
        {
            File saveFile;
            if (!savePath.equals(""))
            {
                saveFile = new File(savePath, fileName);
            }
            else
            {
                saveFile = new File(fileName);
            }

            FileWriter writer = new FileWriter(saveFile);
            saveStr = content.toString();
            int saveStrLen = saveStr.length();
            for (int i = 0; i < saveStrLen; i++)
            {
                writer.write((int)saveStr.charAt(i));
            }

            writer.close();
        }
        catch (Exception eF) {
            setStatus(dsFSE+" " + eF.toString() + " " + fileName);
            error = true;
        }

        if (!error) setStatus(fileName + " " + dsWasSaved);
        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }

    /********************************************************
     *  PRINTER CLASSES
     ********************************************************/
    public String getChangeFromFloat(double aDouble)
    {
        String returnString = "";
        String tempString = "" + aDouble;
        int tempLen = tempString.length();
        StringBuffer newSb = new StringBuffer();
        char curChar = ' ';
        int pastDot = 0;
        boolean foundDot = false;
        for (int i = 0; i < tempLen; i++)
        {
            curChar = tempString.charAt(i);
            if (curChar == '.')
            {
                foundDot = true;
            }
            else if (foundDot)
            {
                pastDot++;
            }

            newSb.append(curChar);
            if (pastDot >= 1)
            {
                break;
            }
        }

        returnString = newSb.toString();

        return returnString;
    }

    public String getPercentFromFloat(double aDouble)
    {
        String returnString = "";
        double newDouble = 100.0 * aDouble;
        String tempString = "" + newDouble;
        int tempLen = tempString.length();
        StringBuffer newSb = new StringBuffer();
        char curChar = ' ';
        int pastDot = 0;
        boolean foundDot = false;
        for (int i = 0; i < tempLen; i++)
        {
            curChar = tempString.charAt(i);
            if (curChar == '.')
            {
                foundDot = true;
            }
            else if (foundDot)
            {
                pastDot++;
            }

            newSb.append(curChar);
            if (pastDot >= 1)
            {
                newSb.append(" %");

                break;
            }
        }

        returnString = newSb.toString();

        return returnString;
    }

    public String getKStyle(String toGet)
    {
        String returnString = "";
        try
        {
            double l = Double.parseDouble(toGet);
            double newD = l / 1024.0;
            returnString = getChangeFromFloat(newD) + " k";
        }
        catch (Exception eN)
        {
            returnString = toGet;
        }

        return returnString;
    }

    public String getSearchedIndexes() {
        StringBuffer rb = new StringBuffer();

        // iterate over the di s
        int numIndexes = 0;
        if (!indexes.isEmpty())
        {
            numIndexes = indexes.size();

            // add the items
            Iterator iterator = indexes.iterator();
            DocSearcherIndex curI;
            if (numIndexes > 0)
            {
                rb.append("<ul>");
            }
            while (iterator.hasNext())
            {
                curI = ((DocSearcherIndex)iterator.next());
                if (curI.shouldBeSearched)
                {
                    rb.append("<li><font color = blue>");
                    rb.append(curI.desc);
                    rb.append("</font></li>");
                }
            }

            if (numIndexes > 0) rb.append("</ul>");
        }

        if (numIndexes == 0) return "<p align = left><b>"+dsNone+"</b></p>";
        else return rb.toString();
    }

    public ArrayList[] screenForSize(Hits hits,
                                     int lowerSize,
                                     int upperSize)
    {
        ArrayList[] returnList = new ArrayList[2];
        returnList[0] = new ArrayList();
        returnList[1] = new ArrayList();
        int tempSize = 0;
        for (int i = 0; i < hits.length(); i++)
        {
            try
            {
                tempSize = Integer.parseInt(hits.doc(i).get("size"));
                if ((tempSize >= lowerSize) && (tempSize <= upperSize))
                {
                    returnList[0].add(hits.doc(i));
                    returnList[1].add(("" + hits.score(i)));
                }
            }
            catch (Exception eR)
            {
                setStatus(dsErrObtSi+" "+eR.toString());
            }
        }

        return returnList;
    }

    public class printMIListener implements ActionListener {
        public void actionPerformed(ActionEvent evt) {
            PrinterJob pj = PrinterJob.getPrinterJob();
            pj.setJobName("docSearcher");
            pj.setPageable(vista);
            try
            {
                if (pj.printDialog())
                {
                    pj.print();
                }
            }
            catch (PrinterException e)
            {
                showMessage(dsErrPrint, e.toString());
                e.printStackTrace();
            }
        }
    }

    public class scale2Listener
        implements ActionListener
    {
        public void actionPerformed(ActionEvent evt)
        {
            vista = new JComponentVista(editorPane, new PageFormat());
            vista.setScale(2.0, 2.0);
        }
    }

    public class scaleFitListener
        implements ActionListener
    {
        public void actionPerformed(ActionEvent evt)
        {
            vista = new JComponentVista(editorPane, new PageFormat());
            vista.scaleToFit(false);
        }
    }

    public class scaleHalfListener
        implements ActionListener
    {
        public void actionPerformed(ActionEvent evt)
        {
            vista = new JComponentVista(editorPane, new PageFormat());
            vista.setScale(0.5, 0.5);
        }
    }

    public class scaleOffListener
        implements ActionListener
    {
        public void actionPerformed(ActionEvent evt)
        {
            vista = new JComponentVista(editorPane, new PageFormat());
        }
    }

    public class scaleXListener
        implements ActionListener
    {
        public void actionPerformed(ActionEvent evt)
        {
            vista = new JComponentVista(editorPane, new PageFormat());
            vista.scaleToFitX();
        }
    }

    public class scaleYListener
        implements ActionListener
    {
        public void actionPerformed(ActionEvent evt)
        {
            vista = new JComponentVista(editorPane, new PageFormat());
            vista.scaleToFitY();
        }
    }

public void setSearching(boolean toSet) { currentlySearching=toSet; }
    
public void doSearch(String searchText) {
	setStatus(plsWait+" "+dsSchin+" --> "+searchText);
	setSearching(true);
        synchronized (this) {
        	ArrayList[] sizeList = new ArrayList[2];
        	sizeList[0] = new ArrayList();
        	sizeList[1] = new ArrayList();
        	String findText = "";
        	if (phrase.isSelected()) {
            		if (searchText.indexOf("\"") == -1) searchText = "\""+searchText+"\"";
        		}
        	// for each di - search and add the results
        	int grandTotalHits = 0;
        	int selectedFields = searchIn.getSelectedIndex();
        	String sField = searchOpts[selectedFields];
        	String tempSearchText = searchText;
        	StringBuffer searchedIndexes = new StringBuffer();
        	searchedIndexes.append("<ul>");
        	StringBuffer hitBuf;
        	StringBuffer tempBuf = new StringBuffer();
        	StringBuffer bodyBuf = new StringBuffer();
        	String curTitle = "";
        	String curSize = "";
        	String curAuthor = "";
        	String curDate = "";
        	String curFile = "";
		boolean isCdRomIdx=false;
        	String curType = "";
        	String curSummary = "";
        	int numHits = 0;
        	hitBuf = new StringBuffer();
        	hitBuf.append("<html><head><title>");
		hitBuf.append(dsRsltsFoSch);
		hitBuf.append(" ");
        	hitBuf.append(searchText);
        	hitBuf.append("</title><body><h1 align = center>");
		hitBuf.append(dsRsltsFoSch);
		hitBuf.append(" ");
		hitBuf.append("<strong><font color = blue>");
        	hitBuf.append(searchText);
        	hitBuf.append("</font></strong></h1>");
        	if (!useGui) System.out.println(dsRsltsFoSch+" "+searchText);
        	int curColor = 0;
        	int curTypeInt = 0;
        	int numIndexes = 0;
        	if (!indexes.isEmpty())  {
	  	try {
            	numIndexes = indexes.size();
            	// add the items
            	Iterator iterator  =  indexes.iterator();
            	DocSearcherIndex curI;
            	while (iterator.hasNext()) {
	                curI = ((DocSearcherIndex)iterator.next());
		    	isCdRomIdx = curI.isCdrom();
                	tempBuf = new StringBuffer();
                	if (curI.getSearched()) {
                    		searcher = new IndexSearcher(curI.indexerPath);
                    		if ((searchText.indexOf("(")!= -1) ||
		                        (searchText.indexOf("[")!= -1)) findText = searchText;
        	            	else {
	        	                if (selectedFields == 0) {
                        	    		findText = "+(+body:("+tempSearchText+") OR +title:("+tempSearchText+"))";
                        			} // body and title
                        		else findText = "+"+sField+":("+searchText+")";
                        		if (useAuthor.isSelected()) {
                            		findText += " AND +author:("+authorField.getText()+")";
                        		}
                        		if (useType.isSelected()) {
                            		findText += " AND +type:("+fileTypesToGet[fileType.getSelectedIndex()]+")";
                        		}
                    		} // end for a regular search
                    	setStatus(dsSrchStr+": "+findText+"...");
                    	query = QueryParser.parse(findText, sField, new StandardAnalyzer());
                    	if (useDate.isSelected()) {
	                        DateFilter df = new DateFilter("mod_date",
                                                       	DateTimeUtils.getJDateFromString(fromField.getText()),
                                                       	DateTimeUtils.getJDateFromString(toField.getText()));
                        	hits = searcher.search(query, df);
                    	}
                    	else hits = searcher.search(query);
                    	if (useSize.isSelected()) {
	                        int fromInt = 1;
                        	int toInt = 2;
                        	try {
                            	fromInt = Integer.parseInt(sizeFromField.getText())*1024;
                            	toInt = Integer.parseInt(sizeToField.getText())*1024;
                        	}
                        	catch (Exception eN) {
                            	setStatus(dsErrParseNums+" "+eN.toString());
                        	}
                        	sizeList = screenForSize(hits, fromInt, toInt);
                        	numHits = sizeList[0].size();
                    		}
                    	else numHits = hits.length();     // NOT A SIZE QUERY
                    	searchedIndexes.append("<li> <font color = blue>");
                    	searchedIndexes.append(curI.getDesc());
                    	searchedIndexes.append("</font> (<b>");
                    	searchedIndexes.append(numHits);
                    	searchedIndexes.append("</b>  &nbsp; ");
		    	searchedIndexes.append(dsDox);
		    	searchedIndexes.append(")</li>");
                    	if (!useGui) System.out.println(dsIndex+": "+curI.getDesc());
                    	float curScore;
                    	grandTotalHits += numHits;
                    	tempBuf.append("<p align = center><b>");
                    	tempBuf.append(numHits);
                    	tempBuf.append("</b> &nbsp; ");
		    	tempBuf.append(dsDocsFndInIndx);
		    	tempBuf.append("<b>  &nbsp; ");
                    	tempBuf.append(curI.getDesc());
                    	tempBuf.append("</b></p>");
                    	curColor = 0;
                    	curTypeInt = 0;
                    	for (int i = 0;i<numHits;i++) {
	                        if (i>maxNumHitsShown) {
                            	setStatus(dsMxNumHits+" ("+maxNumHitsShown+") "+dsExceeded+" ("+numHits+").");
                            	break;
                        	}
                        	//
                        	if (!useSize.isSelected()) {
                            	curTitle = convertTextToHTML(hits.doc(i).get("title"));
                            	curSize = hits.doc(i).get("size");
                            	if (!curI.isWeb) {
							if (!isCdRomIdx) curFile = hits.doc(i).get("path");
							else {
								curFile = hits.doc(i).get("URL");
								curFile = getCdPath(curFile);
								}
							}
                            else curFile = hits.doc(i).get("URL");
	                            	curType = hits.doc(i).get("type");
                            curAuthor = hits.doc(i).get("author");
                            	if (curAuthor.equals("")) curAuthor = dsUnk;
	                            	curDate = hits.doc(i).get("mod_date");
                            	if (curDate.equals("")) curDate = dsUnk;
                            	else curDate = DateTimeUtils.getDateFormatNormal(curDate);
                            	curTypeInt = Utils.getTypeInt(curType);
                            	curScore = hits.score(i);
                            	curSummary = convertTextToHTML(hits.doc(i).get("summary"));
                        	}
                        	else {
                            	curTitle = convertTextToHTML(((Document)sizeList[0].get(i)).get("title"));
                            	curSize = ((Document)sizeList[0].get(i)).get("size");
                            	if (!curI.isWeb) curFile = ((Document)sizeList[0].get(i)).get("path");
                            	else curFile = ((Document)sizeList[0].get(i)).get("URL");
                            	curType = ((Document)sizeList[0].get(i)).get("type");
                            	curAuthor = ((Document)sizeList[0].get(i)).get("author");
                            	if (curAuthor.equals("")) curAuthor = dsUnk;
                            	curDate = ((Document)sizeList[0].get(i)).get("mod_date");
                            	if (curDate.equals("")) curDate = dsUnk;
                            	else curDate = DateTimeUtils.getDateFormatNormal(curDate);
                            	curTypeInt = Utils.getTypeInt(curType);
                            	curScore = 1;
                            	try {
	                                curScore = Float.parseFloat(((String)sizeList[1].get(i)));
                            	}
                            	catch (Exception eF) {
	                                setStatus(dsErrParseScore+" "+eF.toString());
                            	}
                            	curSummary = ((Document)sizeList[0].get(i)).get("summary");
                        	}
                        	//
                        	// add it to our page - doc size title score
                        	tempBuf.append("<p align = left>");
                        	if (!curI.isWeb) {
                            	tempBuf.append("<a href = \"");
			    	tempBuf.append(fileString);
                            	tempBuf.append(curFile);
                            	tempBuf.append("\">");
                        	}
                        	else {
                            	tempBuf.append("<a href = \"");
                            	tempBuf.append(curFile);
                            	tempBuf.append("\">");
                        	}
                        	if (hasIcons) {
                            	switch (curTypeInt) {
                            	case 0: // html
	                                tempBuf.append(htmlTag);
                                	break;
                            	case 2: // ms word
	                                tempBuf.append(wordTag);
                                	break;
                            	case 3: // ms excell
	                                tempBuf.append(excelTag);
                                	break;
                            	case 4: // pdf
	                                tempBuf.append(pdfTag);
                                	break;
                            	case 5: // rtf
	                                tempBuf.append(rtfTag);
                                	break;
                            	case 6: // open office writer
	                                tempBuf.append(ooWriterTag);
                                	break;
                            	case 7: // open office impress
	                                tempBuf.append(ooImpressTag);
                                	break;
                            	case 8: // open office calc
	                                tempBuf.append(ooCalcTag);
                                	break;
                            	case 9: // open office draw
	                                tempBuf.append(ooDrawTag);
                                break;
                            	default: // text
	                                tempBuf.append(textTag);
                                	break;
                            	}
                        	}
                        	else tempBuf.append(curType);
                        	tempBuf.append(" ");
                        	tempBuf.append(curTitle);
                        	tempBuf.append("</a><br>");
	                        tempBuf.append(curSummary);
                        	tempBuf.append("<font color = green><br><em>");
        	                tempBuf.append(curDate);
                	        tempBuf.append(", ");
                       		tempBuf.append(getKStyle(curSize));
                        	tempBuf.append(" K bytes, ");
                        	tempBuf.append(curAuthor);
                        	tempBuf.append(", <b>");
                        	tempBuf.append(getPercentFromFloat(curScore));
                        	tempBuf.append("</b></em></font><br><font color = gray>");
                        	tempBuf.append(curFile);
                        	tempBuf.append("</font>");
                        	tempBuf.append("</p>");
                        	if (!useGui) {
                            	System.out.println("\n\n* "+curTitle+"\n"+
                                               	curSummary+"\n"+curDate+", "+getKStyle(curSize)+
                                               	" K bytes, "+curAuthor+", "+getPercentFromFloat(curScore)+
                                               	"\n"+curFile);
                        	}
                    	} // end for hits
                    	// now add our results
                    	// add the footer
                    	bodyBuf.append(tempBuf.toString());
                	} // end if shouldbesearched
                	else {
                    	tempBuf.append("<p align = left>");
		    	tempBuf.append(dsIndex);
		    	tempBuf.append("  &nbsp; <b>");
                    	tempBuf.append(curI.getDesc());
                    	tempBuf.append("</b>  &nbsp; ");
		    	tempBuf.append(dsWasNotSearched);
		    	tempBuf.append("</p>");
                    	bodyBuf.append(tempBuf.toString());
                	}
		if (curI.getSearched()) searcher.close();
            	} // end while hasmore indexes
            	// finish up the page
            	searchedIndexes.append("</ul>");
            	hitBuf.append("<p align = left><strong>");
            	hitBuf.append(grandTotalHits);
            	hitBuf.append("</strong>  &nbsp; ");
	    	hitBuf.append(dsTotalDocsFndIndx);
	    	hitBuf.append(":</p>");
            	hitBuf.append(searchedIndexes.toString());
            	hitBuf.append(bodyBuf);
            	hitBuf.append("</body></html>");
            	if (!useGui) System.out.println("\n"+dsTotHits+": "+grandTotalHits);
            	lastSearch = hitBuf.toString();
            	if (useGui) {
	                editorPane.setText(lastSearch);
                	editorPane.select(0,0);
                	int numS = searchField.getItemCount();
                	boolean inThere = false;
			String tmpSrchTxt="";
                	if (numS>0) {
				for (int i = 1;i<numS;i++) {
					tmpSrchTxt=(String)searchField.getItemAt(i);
					if (tmpSrchTxt!=null) {
						if (tmpSrchTxt.equals(searchText)) inThere = true;
						}
					}
				}
                	if (!inThere) searchField.addItem(searchText);
                	searchField.setSelectedIndex(searchField.getItemCount()-1);
                	vista  =  new JComponentVista(editorPane, new PageFormat());
                	forwardPos = -1;
                	backwardPos = -1;
                	backList = new LinkedList();
                	addToBackList(curPage);
                	curPage = "results";
                	forwardList = new LinkedList();
            		} // end if useGui
        	} // end for try
        	catch (IOException ie) {
            	showMessage(dsErrPrfSrch, dsCrptdIdx+" :\n"+ie.toString());
            	ie.printStackTrace();
        	}
        	catch (NullPointerException ne) {
            	showMessage(dsErrPrfSrch, dsCrptdIdx+" :\n"+ne.toString());
            	ne.printStackTrace();
        	}
        	catch (Exception eS) {
            	showMessage(dsErrPrfSrch, eS.toString());
            	eS.printStackTrace();
         	}
		finally {
			setStatus(SEARCH_COMPLETE);
			setSearching(false);
			}
		} // end for no indexes
        	else showMessage(dsErrPrfSrch, dsMkIdx);
	} // end for synch
} // end for doSearch

    public String convertTextToHTML(String conv) {
        String returnString = conv;
        // lowerCase
        returnString = Utils.replaceAll("& ", returnString, "&amp; "); // and symbol
        returnString = Utils.replaceAll("\n", returnString, "&nbsp;"); // spacer
        returnString = Utils.replaceAll("<", returnString, "&lt;"); // less than
        returnString = Utils.replaceAll(">", returnString, "&gt;"); // greater than
        returnString = Utils.replaceAll("\"", returnString, "&quot;"); // quot
        return returnString;
    }

    public StringBuffer loadFile(String fileToLoad) {
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        StringBuffer returnBuffer = new StringBuffer();
        try {
            //System.out.println("Loading text from file"+fileToLoad);
            File readFile = new File(fileToLoad);
            if ((readFile.exists()) && (!readFile.isDirectory()))
            {
                FileReader filereader = new FileReader(fileToLoad);
                int i;
                while ((i = filereader.read()) != -1) {
                    if (i == -1) break;
                    else returnBuffer.append((char)i);
                }

                filereader.close();
            }
            else  {
                returnBuffer.append(" ** FILE NOT FOUND OR FILE IS A DIRECTORY ["
                                    + fileToLoad + "] **\n");
            }
        }
        catch (Exception eF)
        {
            showMessage(dsErrLdgFi,
                        "\n" + fileToLoad
                        + "\n\n : " + eF.toString());
            eF.printStackTrace();
        }

        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));

        return returnBuffer;
    }

    public boolean setPage(String pageToSet) {
        String lowerLink = pageToSet.toLowerCase();
        try {
	    if ((Utils.isHtml(lowerLink)) || (Utils.isText(lowerLink))) {
		editorPane.setContentType("text/html");
            	editorPane.setPage(fileString + blankFile);
	    	}
        }
        catch (Exception eR) {
            setStatus(dsErrSetPa+" : " + eR.toString()+"\n"+pageToSet);
		eR.printStackTrace();
        }
        boolean returnBool = true;
        String loadString = pageToSet;
        if (pageToSet.equals("home")) {
            setStatus(dsLdg+" : *" + pageToSet + "*");
            editorPane.setContentType("text/html");
            if (hasStartPage) {
                try {
                    editorPane.setPage(fileString + startPageString);
                }
                catch (Exception eL) {
                    // error message
                    editorPane.setText(lastSearch);
                }
            }
            else editorPane.setText(lastSearch);
            editorPane.select(0, 0);
            curPage = "home";
        }
        else if (pageToSet.equals("results"))  {
            setStatus(dsLdg+" : *" + pageToSet + "*");
            editorPane.setContentType("text/html");
            editorPane.setText(lastSearch);
            editorPane.select(0, 0);
            curPage = "results";
        }
        else {
            if ((Utils.isHtml(lowerLink)) || (Utils.isText(lowerLink))) {
	    	if (Utils.isHtml(lowerLink)) editorPane.setContentType("text/html");
            	else if (Utils.isText(lowerLink)) editorPane.setContentType("text/plain");
            	try {
	                // set the page
			if (pageToSet.startsWith("file:/")) {
			        pageToSet=pageToSet.substring(6, pageToSet.length());
				editorPane.setPage(fileString + pageToSet);
				}
			else if (pageToSet.startsWith("http:")) editorPane.setPage(pageToSet);
			else if (pageToSet.startsWith("ftp")) editorPane.setPage(pageToSet);
			else editorPane.setPage(fileString + pageToSet);
                	setStatus(dsLoaded+" " + pageToSet);
                	curPage = pageToSet;
            	}
             	// end for try
            	catch (Exception eP) {
	                returnBool = false;
                	showMessage(dsErrLdgPa,
                            	"\n" + pageToSet
                            	+ eP.toString());
                	eP.printStackTrace();
            		} // end for catch
        	} // end for isHTML
	    else doExternal(pageToSet);
	} // end for actual link

        if (returnBool) curPage = pageToSet;
        return returnBool;
    }

    public void doBack() {
        int backSize = backList.size();
        String oldPage = curPage;
        String reopenPage = "";
        if (backwardPos < (backSize - 1)) {
            // go back
            backwardPos++;
            reopenPage = (String)backList.get(backwardPos);
            if (setPage(reopenPage)) {
                addToForwardList(oldPage);
                if (forwardPos > -1) forwardPos--;
            }
            else backwardPos--;

            if (backwardPos == (backSize - 1)) iconButtons[3].setEnabled(false);
        }
        else iconButtons[3].setEnabled(false); // back button
    }

    public void doForward() {
        int fwdSize = forwardList.size();
        String oldPage = curPage;
        String reopenPage = "";
        if (forwardPos < (fwdSize - 1)) {
            // go back
            forwardPos++;
            reopenPage = (String)forwardList.get(forwardPos);
            if (setPage(reopenPage)) {
                //addToBackList(oldPage);
                if (backwardPos > -1) backwardPos--;
                //addToBackList(oldPage);
            }
            else forwardPos--;
            if ((forwardPos == (fwdSize - 1))) iconButtons[5].setEnabled(false);
        }
        else iconButtons[5].setEnabled(false); // forward button
    }

    public void addToForwardList(String toAdd) {
        forwardList.add(0, toAdd);
        iconButtons[5].setEnabled(true); // forward button
    }

    public void addToBackList(String toAdd) {
        if ((toAdd.startsWith("file://")) && (!toAdd.startsWith("file:///"))) {
            toAdd = "file:///" + toAdd.substring(6, toAdd.length());
        }
        backList.add(0, toAdd);
	if (hasIcons) {
        	iconButtons[3].setEnabled(true); // backward button
        	iconButtons[5].setEnabled(false); // forward button
		}
    }

    public void doOpen() {
        JFileChooser fdo = new JFileChooser();
        fdo.setCurrentDirectory(new File(defaultSaveFolder));
        int fileGotten = fdo.showDialog(this, dsOpen);
        if (fileGotten == JFileChooser.APPROVE_OPTION) {
            File file = fdo.getSelectedFile();
            String fileName = file.toString();
            // get document stream and save it
            if (!fileName.startsWith("http")) {
                setPage(fileString + fileName);
            }
            else setPage(fileName);
        }
         // end if approved
    }

    public void doSave() {
        setStatus(dsSave);
        //defaultSaveFolder
        JFileChooser fds = new JFileChooser();
        fds.setDialogTitle(dsSave);
        boolean aWebPage = false;
        String saveName = "";
        if (curPage.equals("results"))  saveName = "results.htm";
        else if (curPage.equals("home")) saveName = "home.htm";
        else {
            if (Utils.isHtml(curPage)) aWebPage = true;
            saveName = Utils.getNameOnly(curPage);
        }
        saveName = Utils.addFolder(defaultSaveFolder, saveName);
        fds.setCurrentDirectory(new File(defaultSaveFolder));
        fds.setSelectedFile(new File(saveName));
        int fileGotten = fds.showDialog(this, dsSave);
        if (fileGotten == JFileChooser.APPROVE_OPTION)
        {
            File file = fds.getSelectedFile();
            String fileName = file.toString();
            setStatus(dsSave + fileName);

            // get document stream and save it
            String saveText = editorPane.getText();
            int textLen = saveText.length();
            char curChar = ' ';
            try
            {
                File saveFile = new File(fileName);
                FileWriter filewriter = new FileWriter(saveFile);
                PrintWriter pw = new PrintWriter(filewriter);
                for (int i = 0; i < textLen; i++)
                {
                    curChar = saveText.charAt(i);
                    pw.print(curChar);
                }
                 // end for writing text

                filewriter.close();
                pw.close();
            }
            catch (Exception eR)
            {
                showMessage(dsErrSaFi, "\n" + fileName);
            }
        }
         // end if approved
    }

 public void doExit() {
        try {
            if (!isCDSearchTool) {
			 saveIndexes();
	   	       saveHandlers();
		       saveSettings();
			}
        }
        catch (Exception eR) {
            showMessage(dsErrSaFi, eR.toString());
        }
        finally {
            System.exit(0);
        }
    }
    
 public void saveHandlers() {
    	// saves handler info into html table
	if (!handlerList.isEmpty()) {
		int numHndlrs = handlerList.size();
            	StringBuffer sB = new StringBuffer();
            	sB.append("<html><head><title>DocSearcher File Handler Type Listing</title>");
            	sB.append("<body><h1>DocSearcher File Handler Type Listing</h1><p align = left>");
            	sB.append("Listed below are the file type handlers used to open various links by DocSearcher.</p>");
            	sB.append("<table border = 1>");
            	// add the items
            	Iterator iterator = handlerList.iterator();
            	docTypeHandler dh;
            	while (iterator.hasNext()) {
                	dh = ((docTypeHandler)iterator.next());
			sB.append("<tr>");
                	sB.append("<td>");
                	sB.append(dh.extension);
                	sB.append("</td>");
                	sB.append("<td>");
                	sB.append(dh.desc);
                	sB.append("</td>");
                	sB.append("<td>");
			sB.append(dh.app);
			sB.append("</td>");
			sB.append("</tr>");
			}
		sB.append("</table></body></html>");
		saveFile("handlers_list.htm", workingDir, sB);
		} // has items to save
    } // end for saveHandlers

 public void saveIndexes() {
        if (!indexes.isEmpty()) {
            int numIndexes = indexes.size();
            StringBuffer sB = new StringBuffer();
            sB.append("<html><head><title>DocSearcher Index Listing</title>");
            sB.append("<body><h1>DocSearcher Index Listing</h1><p align = left>");
            sB.append("Listed below are the paths and whether they are to be searched by default.</p>");
            sB.append("\n<table border = 1>\n");
            // add the items
            Iterator iterator = indexes.iterator();
            DocSearcherIndex curI;
            while (iterator.hasNext()) {
                curI = ((DocSearcherIndex)iterator.next());
                sB.append("\n<tr>");
                sB.append("\n<td>");
                sB.append(curI.desc);
                sB.append("</td>");
                sB.append("\n<td>");
                sB.append(curI.path);
                sB.append("</td>");
                sB.append("\n<td>");
                if (curI.shouldBeSearched) sB.append("0");
                else sB.append("1");
                sB.append("</td>");
                sB.append("\n<td>");
                sB.append(curI.depth + "");
                sB.append("</td>");
                sB.append("\n<td>");
                sB.append(curI.indexerPath + "");
                sB.append("</td>");
                // now the isWeb stuff and date
                sB.append("\n<td>");
                if (curI.isWeb) sB.append("true");
                else sB.append("false");

                sB.append("</td>");
                sB.append("\n<td>");
                sB.append(curI.match);
                sB.append("</td>");
                sB.append("\n<td>");
                sB.append(curI.replace);
                sB.append("</td>");
                sB.append("\n<td>");
                sB.append(curI.lastIndexed);
                sB.append("</td>");
                sB.append("\n<td>");
                sB.append(curI.indexPolicy + "");
                sB.append("</td>");
                sB.append("\n<td>");
                sB.append(curI.archiveDir);
                sB.append("</td>");
                sB.append("</tr>\n");
            }
             // end of iteration

            // close up the html
            sB.append("\n</table></body></html>");
            saveFile("index_list.htm", workingDir, sB);

            // save the file
        }
         // end for not empty

        if (!bookmarksList.isEmpty()) {
            int numIndexes = bookmarksList.size();
            StringBuffer sB = new StringBuffer();
            sB.append("<html><head><title>DocSearcher Bookmark Listing</title>");
            sB.append("<body><h1>DocSearcher Bookmark Listing</h1><p align = left>");
            sB.append("Listed below are the bookmarks for DocSearcher.</p>");
            sB.append("<table border = 1>");

            // add the items
            Iterator iterator = bookmarksList.iterator();
            SimpleBookmark curI;
            while (iterator.hasNext()) {
                curI = ((SimpleBookmark)iterator.next());
                sB.append("<tr>");
                sB.append("<td>");
                sB.append(curI.desc);
                sB.append("</td>");
                sB.append("<td>");
                sB.append(curI.urlString);
                sB.append("</td>");
                sB.append("</tr>");
            }

            sB.append("</table></body></html>");
            saveFile("bookmarks.htm", workingDir, sB);
        }
         // end for bookmarks not empty
    }

public void loadIndexes() {
        // check for indexFile
        int numIndexes = 0;
        File testIndex;
	  String indexFileName="";
	  if (isCDSearchTool) {
			indexFileName=cdRomIdxList;
			System.out.println("Using Index information on CD : "+cdRomIdxList);
			} 
	  else {
		System.out.println("Loading NON - CD oriented indexes from "+indexFile);
		indexFileName=indexFile;
			}
	  testIndex = new File(indexFileName);
        StringBuffer errS = new StringBuffer();
        boolean loadErr = false;
        DocSearcherIndex curI;
        File tempFile;
        String tempFileString = "";
        String tempIndexerPath = "";
        String tempDesc = "";
        int tempDepth = 0;
        int updatePolicy = 0;
        String updateStr = "";
        int tempSbd = 0;
        boolean tempBool = false;
        boolean tempWebBool = false;
	  String tempMatchStr="";
	  boolean tempIsCdrom= false;
        String tempIsWeb = "";
        String tempReplace = "";
        String tempMatch = "";
        String tempDateStr = "";
        String tempArch = "";
        if (testIndex.exists())  {
            Table tempTable = new Table(11, 100);
            tempTable.htmlLoad(indexFileName, "");
            int numI = tempTable.colSize();
            // parse it
            for (int i = 0; i < numI; i++) {
                //
                try {
                    tempDesc = tempTable.inItem(0, i);
                    tempFileString = tempTable.inItem(1, i);
                    tempSbd = Integer.parseInt(tempTable.inItem(2, i));
                    tempIndexerPath = tempTable.inItem(4, i);
                    // isWeb content
                    tempIsWeb = tempTable.inItem(5, i);
                    tempWebBool = false;
                    tempReplace = "";
                    tempMatch = "";
                    tempDateStr = "";
                    if (tempIsWeb != null) {
                        if (tempIsWeb.equals("true")) {
                            tempWebBool = true;
                            tempMatch = tempTable.inItem(6, i);
                            tempReplace = tempTable.inItem(7, i);
                        }
                    }
			//  CDROM Stuff   tempIsCdrom  tempReplaceStr
			tempMatchStr = tempTable.inItem(6, i);
			if (tempMatchStr!=null) {
				if (tempMatchStr.startsWith("[cdrom]")) {
                            		tempMatch = tempTable.inItem(6, i);
					tempIsCdrom  = true;
                            		tempReplace = tempTable.inItem(7, i);
					// cdRomIdxDir
					if (isCDSearchTool) tempIndexerPath = Utils.addFolder(cdRomIdxDir, Utils.getNameOnly(tempIndexerPath));
					System.out.println("USING CDROM LUCENE INDEX PATH: "+tempIndexerPath);
					}
				}
                    tempDateStr = tempTable.inItem(8, i);
                    updateStr = tempTable.inItem(9, i);
                    if (updateStr == null) {
                        updatePolicy = 0;
                    }
                    else
                    {
                        updatePolicy = Integer.parseInt(updateStr);
                    }

                    if (tempDateStr == null)
                    {
                        tempDateStr = DateTimeUtils.getToday();
                    }

                    if (tempSbd == 1)
                    {
                        tempBool = false;
                    }
                    else
                    {
                        tempBool = true;
                    }

                    tempArch = tempTable.inItem(10, i);
                    if (tempArch == null)
                    {
                        tempArch = getArchiveDir();
                    }

                    tempDepth = Integer.parseInt(tempTable.inItem(3, i));
                    tempFile = new File(tempFileString);
                    if (tempFileString.toLowerCase().endsWith(".zip"))
                    {
                        curI =
                            new DocSearcherIndex(tempFileString, tempDesc,
                                                 tempBool, tempDepth,
                                                 tempIndexerPath, tempWebBool,
                                                 tempMatch, tempReplace,
                                                 tempDateStr, updatePolicy,
                                                 tempArch);
                        indexes.add(curI);
                        if (useGui) {
                            setStatus(dsIndex+" " + curI.desc + " : "
                                      + DateTimeUtils.getDaysOld(curI)
                                      + " "
				      + dsDaysOld
				      + " : " 
				      + curI.lastIndexed);
                        }

                        numIndexes++;
                    }

                    else if (tempIsCdrom) {
                        curI =
                            new DocSearcherIndex(tempFileString, tempDesc,
                                                 tempBool, tempDepth,
                                                 tempIndexerPath, tempWebBool,
                                                 tempMatch, tempReplace,
                                                 tempDateStr, updatePolicy,
                                                 tempArch);
                        indexes.add(curI);
                        setStatus(dsIndex+" " + curI.desc + " : "
                                  + DateTimeUtils.getDaysOld(curI)
				  +" "
				  + dsDaysOld
                                  + " : " 
				  + curI.lastIndexed);
                        numIndexes++;
                    }

                    else if ((tempFile.exists()) || (tempFileString.startsWith("http"))) {
                        curI =
                            new DocSearcherIndex(tempFileString, tempDesc,
                                                 tempBool, tempDepth,
                                                 tempIndexerPath, tempWebBool,
                                                 tempMatch, tempReplace,
                                                 tempDateStr, updatePolicy,
                                                 tempArch);
                        indexes.add(curI);
                        setStatus(dsIndex+" " + curI.desc + " : "
                                  + DateTimeUtils.getDaysOld(curI)
				  +" "
				  + dsDaysOld
                                  + " : " 
				  + curI.lastIndexed);
                        numIndexes++;
                    }
                    else {
                        loadErr = true;
                        errS.append(tempFileString
                                    + "\n\t"
				    +dsNotExist
				    +"\n\n");
                    }
                     // end for file doesn't exist
                }
                catch (Exception eN) {
                    loadErr = true;
                    errS.append(eN.toString() + "\n\n");
                }
            }
        }

        if (numIndexes == 0) {
            loadErr = true;
            errS.append(dsMkIdx);
        }

        // now load the bookmarks
        // from the bookmarksFile
        File testBMF = new File(bookmarksFile);
        if (testBMF.exists()) {
            Table tempTable = new Table(2, 200);
            tempTable.htmlLoad(bookmarksFile, "");
            int numI = tempTable.colSize();

            // parse it
            for (int i = 0; i < numI; i++)
            {
                addNewBookmark(new SimpleBookmark(tempTable.inItem(1, i),
                                                  tempTable.inItem(0, i)));
            }
        }

        if (loadErr) showMessage(Messages.getString("DocSearch.errLdgIdx"), errS.toString());
        else  setStatus(numIndexes + " "+ Messages.getString("DocSearch.totalIdxs"));
    }

public void checkDefaults() {
        File workingDirFile = new File(workingDir);
        if (!workingDirFile.exists()) workingDirFile.mkdir();
         // end for creating the working directory
        File defaultSaveFolderFile = new File(defaultSaveFolder);
        if (!defaultSaveFolderFile.exists()) defaultSaveFolderFile.mkdir();
         // end for creating the working directory
        blankFile = Utils.addFolder(workingDir, "blank_page.htm");
        File blankPageFile = new File(blankFile);
        if (!blankPageFile.exists()) {
            StringBuffer bp = new StringBuffer();
            bp.append("<html><head><title>"+loadingP+"</title></head><body><h1>"+loadingP+"</h1></body></html>");
            saveFile("blank_page.htm", workingDir, bp);
        }
        File indexFolder = new File(indexDir);
        if (!indexFolder.exists()) {
            setStatus(indexDir+" "+dsNotExist);
            indexFolder.mkdir();
        }
    }

public void createNewIndex(DocSearcherIndex di, boolean isCdRomIndx) throws IOException {
        setStatus(dsIdxg+" (" + di.indexerPath + ") ");
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        checkDefaults();
        StringBuffer failedBuf = new StringBuffer();
        String indexDirNew = di.indexerPath;
        File indexFolder = new File(indexDirNew);
	long curFileSizeBytes=0;
        int addedSuccessfully = 0;
        StringBuffer noRobotsBuf = new StringBuffer();
        noRobotsBuf.append(dsMetaFiles);
        int numNoIndex = 0;
        boolean newIndex = false;
        if (!indexFolder.exists()) {
            setStatus(indexDirNew+ " " + dsNotExist);
            indexFolder.mkdir();
            newIndex = true;
        }
        // BUILD THE INDEX
        File contentFolder = new File(di.path);
        int totalFolders = 1; 
        int totalFiles = 0; 
        int numErrors = 0;
        String urlStr = "";
        String dateStr = "";
        File tempDFile;
        int curSize = 1;
        if (contentFolder.exists()) {
            ArrayList folderList = new ArrayList();
            folderList.add(di.path); // add in our contentDir
            String curFolderString = di.path;
            String[] filesString;
            String[] foldersString;
            File curFolderFile;
            String curFold = "";
            String curFi = "";
            int curItemNo = 0;
            int lastItemNo = 0;
            int numFiles = 0;
            int numFolders = 0;
            int curSubNum = 0;
            int startSubNum = Utils.countSLash(di.path);
            int maxSubNum = startSubNum + di.depth;
            // creating the index
            IndexWriter writer = new IndexWriter(indexDirNew, new StandardAnalyzer(), newIndex);
	    //writer.setUseCompoundFile(true);
            do {
                // create our folder file
                curFolderString = (String)folderList.get(curItemNo);
                curFolderFile = new File(curFolderString);
                curSubNum = Utils.countSLash(curFolderString);
                try {
                    // handle any subfolders --> add them to our folderlist
                    foldersString = curFolderFile.list(ff);
                    numFolders = foldersString.length;
                    for (int i = 0; i < numFolders; i++) {
                        // add them to our folderlist
                        curFold = curFolderString + pathSep + foldersString[i] + pathSep;
                        curFold = Utils.replaceAll(pathSep + pathSep, curFold, pathSep);
                        folderList.add(curFold);
                        lastItemNo++;
                        totalFolders++;
                        // debug output
                        setStatus(dsFndFldr+" " + curFold);
                    }
                     // end for having more than 0 folder
                }
                catch (Exception eF) {
                    setStatus(curFolderString + " : " + eF.toString());
                    eF.printStackTrace();
                }
                // add our files
                try {
                    filesString = curFolderFile.list(wf);
                    numFiles = filesString.length;
                    for (int i = 0; i < numFiles; i++) {
                        // add them to our folderlist
                        curFi = curFolderString + pathSep + filesString[i];
                        curFi = Utils.replaceAll(pathSep + pathSep, curFi, pathSep);
			curFileSizeBytes=Utils.getFileSize(curFi);
			if (curFileSizeBytes>getMaxFileSize()) setStatus(dsFileTooBig+
				" ("+curFileSizeBytes+") "+filesString[i]);
			else { // file size is not too big
                        	setStatus(plsWait+" " + curFi + " # " + curSize);
                        	curSize++;
                        	addedSuccessfully = idx.addDocToIndex(curFi, writer, di, isCdRomIndx, null);
                        	switch (addedSuccessfully) {
                        	case 1: // error
                            	numErrors++;
                            	if (numErrors < 8) {
	                                failedBuf.append("\n");
                                	failedBuf.append(curFi);
                            	}
                            	break;
                        	case 2: // meta robots = noindex
                            	numNoIndex++;
                            	if (numNoIndex < 8) {
	                                noRobotsBuf.append("\n");
                                	noRobotsBuf.append(curFi);
                            	}
                            	break;
                        	default: // OK
                            	totalFiles++;
                            	break;
                        	} // end of switch
			} // end for not skipping, file size is not too big
                    }
                     // end for files
                }
                 // end of trying to get files
                catch (Exception eI) {
                    setStatus(dsErr+" " + eI.toString());
                    //eI.printStackTrace();
                }
                // increment our curItem
                folderList.set(curItemNo, null); // remove memory overhead as you go!
                curItemNo++;
                if (curSubNum >= maxSubNum) {
                    break;
                }
            }
            while (curItemNo <= lastItemNo);
            writer.close(); // close the writer
            indexes.add(di);
        }
        else {
            hasErr = true;
            errString = contentDir+" "+dsNotExist;
        }
         // end for content dir Missing
        if (hasErr) showMessage(Messages.getString("DocSearch.errCreatingIdx"), errString);
        else {
            StringBuffer resultsBuf = new StringBuffer();
            resultsBuf.append(Messages.getString("DocSearch.addedToIdx"));
            resultsBuf.append(di.desc);
            resultsBuf.append("\" ");
            resultsBuf.append(totalFiles);
	    resultsBuf.append(" ");
            resultsBuf.append(Messages.getString("DocSearch.filesFm"));
	    resultsBuf.append(" ");
            resultsBuf.append(totalFolders);
	    resultsBuf.append(" ");
            resultsBuf.append(Messages.getString("DocSearch.stgIn"));
	    resultsBuf.append(" ");
            resultsBuf.append(di.path);
            resultsBuf.append("\n\n");
	    resultsBuf.append(Messages.getString("DocSearch.forAdepthOf"));
	    resultsBuf.append(" ");
            resultsBuf.append(di.depth);
            resultsBuf.append(".");
            if (numErrors > 0) {
                resultsBuf.append("\n" + numErrors);
		resultsBuf.append(" ");
                resultsBuf.append(Messages.getString("DocSearch.filesNotIdxd"));
		resultsBuf.append(failedBuf.toString());
            }

            if (numNoIndex > 0) {
                resultsBuf.append("\n\n" + numNoIndex);
                resultsBuf.append(dsMetaFiles);
		resultsBuf.append(noRobotsBuf.toString());
            }

            showMessage(dsIdxCrtd, resultsBuf.toString());
        }

        setStatus(dsIdxCrtd);
        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }

public void doNewIndex() {
        NewIndexDialog nid =
            new NewIndexDialog(this, dsDoNewIndex, true);
        nid.init();
        nid.setVisible(true);
        if (nid.returnBool) {
            //
            String descD = nid.descField.getText();
            String noUnd = Utils.replaceAll(" ", descD, "_");
            boolean isWeb = nid.isWeb.isSelected();
	    boolean isCdRomIndx= nid.isCd.isSelected();
            String replace = nid.replaceField.getText();
            String match = nid.matchField.getText();
            int policy = nid.indexFreq.getSelectedIndex();
            try {
                createNewIndex(new DocSearcherIndex(nid.startField.getText(),
                                                    descD,
                                                    nid.searchByDefault.isSelected(),
                                                    nid.sdChoice.getSelectedIndex(),
                                                    Utils.addFolder(indexDir, noUnd),
                                                    isWeb, match, replace,
                                                    policy,
                                                    nid.archiveField.getText()), isCdRomIndx);
			// debug
			if (isCdRomIndx) System.out.println("CD Idx.. replace is : "+replace+", match: "+match);
            }
            catch (Exception eS) {
                showMessage(Messages.getString("DocSearch.errCreatingIdx"),
                            eS.toString());
            }
        }
    }


public void addNewBookmark(SimpleBookmark sbm) {
        bookmarksList.add(sbm);
        JMenuItem bmi = new JMenuItem(sbm.desc);
        bmi.setActionCommand(sbm.urlString);
        bmi.addActionListener(this);
        bookMarkMenu.add(bmi);
    }

public void rebuildIndexes() {
        if (!indexes.isEmpty()) {
            Iterator iterator = indexes.iterator();
            DocSearcherIndex di;
            while (iterator.hasNext()) {
                di = ((DocSearcherIndex)iterator.next());
                idx.updateIndex(di);
            }
        }
        setStatus(dsIdxsRblt);
}

public String getBrowserFile() {
        File testExist;
        String returnString = "";
        switch (osType) {
        case 0: // windows
            returnString =
                "C:\\Program Files\\Microsoft Internet\\Iexplore.exe";
            testExist = new File(returnString);
            if (!testExist.exists()) {
                returnString =
                    "C:\\Program Files\\Microsoft\\Internet Explorer\\Iexplore.exe";
                testExist = new File(returnString);
                if (!testExist.exists()) {
                    returnString =
                        "C:\\Program Files\\Plus!\\Microsoft Internet\\Iexplore.exe";
                    testExist = new File(returnString);
                    if (!testExist.exists()) {
                        returnString =
                            "C:\\Program Files\\Internet Explorer\\IEXPLORE.EXE";
                    }
		    else returnString="start";
                }
                 // end for file still doesn't exist
            }
             // file doesn't exist
            break;
        case 1: // Linux
            returnString = "/usr/bin/konqueror";
            testExist = new File(returnString);
            if (!testExist.exists())
            {
                returnString = "/usr/bin/mozilla";
                testExist = new File(returnString);
                if (!testExist.exists()) returnString = "/usr/bin/netscape"; // end for no mozilla
		else {
			returnString = "/usr/local/bin/mozilla";
			}
            }
             // end for no konqueror
            break;
        case 2: // Unix variant
            returnString = "/usr/bin/konqueror";
            testExist = new File(returnString);
            if (!testExist.exists())
            {
                returnString = "/usr/bin/mozilla";
                testExist = new File(returnString);
                if (!testExist.exists()) returnString = "/usr/bin/netscape"; // end for no mozilla
		else {
			returnString = "/usr/local/bin/mozilla";
			}
            }
             // end for no konqueror
            break;
        case 3: // MAC
            returnString = "open";
            break;
        case -1: //UNKNOWN
            returnString = "/usr/bin/netscape";
            break;
        }
        return returnString;
    }
    
public String hasHandler(String externalLink) {
	String returnString="";
	String ext="";
	int lastDot=externalLink.lastIndexOf(".");
	if (lastDot!=-1) {
		// get extension
		ext=externalLink.substring(lastDot+1, externalLink.length());
		ext=ext.toLowerCase();
		System.out.println("extenion is: "+ext);
		int numHndlrs=handlerList.size();
		if (numHndlrs>0) {
			Iterator it=handlerList.iterator();
			docTypeHandler dh;
			while (it.hasNext()) {
				dh=(docTypeHandler)it.next();
				if (dh.isCompat(ext)) {
					returnString=dh.app;
					break;
					}
				}
			} // end for having handlers
		else System.out.println("NO EXTERNAL HANDLERS DEFINED!");
		} // end for having an extension
	else System.out.println("NO EXTENSION FOUND!");
	return returnString;
} // end for hasHandler

public void doExternal(String externalLink) {
	String lowerL = externalLink.toLowerCase();
	System.out.println("Loading externally: "+externalLink);
	if ((externalLink.equals("home")) || (externalLink.equals("results"))) showMessage(Messages.getString("DocSearch.notExtrnlyVwble"), Messages.getString("DocSearch.ntExtVwblMsg"));
	else {
		String app=hasHandler(externalLink);
		if (lowerL.startsWith("file:/")) { // remove "file:/"
			externalLink=externalLink.substring(6, externalLink.length());
			}
		if (externalLink.indexOf(" ") != -1) {
			if (lowerL.startsWith("http")) externalLink = Utils.replaceAll(" ", externalLink, "%20");
			else {
				switch (osType) {
					case 0: // windows							
						externalLink = "\""+externalLink+"\"";
						break;
					default: // unix
						//externalLink = "'"+externalLink+"'";
						break;
					case 1: // linux
						//externalLink = Utils.escapeSpaces(externalLink);
						break;
					} // end for switching os type
				} // end for space file doesn't start with http
			} // end for has a space
		if ((app.equals("")) || (externalLink.toLowerCase().startsWith("http"))) app=defaultHndlr;
		else System.out.println("Using user specified handler: "+app);
		if (app.indexOf(" ") != -1) app= "\"" + app + "\"";
		String execString = app+ " " + externalLink;
		try {
			setStatus(execString);
			System.out.println("EXECUTING RUNTIME COMMAND:\n"+execString);
			String[] cmdArray=new String[2];
			cmdArray[0]=app;
			cmdArray[1]=externalLink;
			if (osType!=0) Runtime.getRuntime().exec(cmdArray);
			else Runtime.getRuntime().exec(execString);
                	}
		catch (Exception eR) {
			showMessage(dsErr,"\n" + execString + "\n" + eR.toString());
			}
		} // end for not "home" or "results"
} // end for doExternal

public void doBookmark() {
        if ((curPage.equals("home")) || (curPage.equals("results"))) {
            showMessage(Messages.getString("DocSearch.notBookmarkable"), Messages.getString("DocSearch.saveResultsPlease"));
	    }
         // end for not bookmarkable
        else {
            // obtain title - if there was one
            String nbt = getTitle();
            NewBookmarkDialog nbd = new NewBookmarkDialog(this, Messages.getString("DocSearch.bookmark"), true);
            nbd.descField.setText(nbt);
            String toAdd = curPage;
            if ((toAdd.startsWith("file://"))
                    && (!toAdd.startsWith("file:///"))) {
                toAdd = "file:///" + toAdd.substring(6, toAdd.length());
            }
            nbd.locationField.setText(toAdd);
            nbd.init();
            nbd.setVisible(true);
            if (nbd.returnBool) {
                addNewBookmark(new SimpleBookmark(nbd.locationField.getText(),
                                                  nbd.descField.getText()));
            }
        }
    }

public void doManageIndexes() {
        if (!indexes.isEmpty()) {
            int numIndexes = indexes.size();
            ManageIndexesDialog min = new ManageIndexesDialog(this, Messages.getString("DocSearch.idxProps"), true);
            min.init();
            min.setVisible(true);
            if (min.returnBool) {
                // proceed to make the changes
                ArrayList newIndex = new ArrayList();
                DocSearcherIndex di;
                for (int i = 0; i < numIndexes; i++) {
                    // set searched
                    if (!min.del[i].isSelected()) {
                        di = ((DocSearcherIndex)indexes.get(i));
                        di.shouldBeSearched = min.sbd[i].isSelected();
                        if (min.upd[i].isSelected()) idx.updateIndex(di);
                        if (min.expi[i].isSelected()) doExport(di);
                        newIndex.add(di);
                    }
                    else {
                        // recursively delete the content
                        //in the selected index
                        di = ((DocSearcherIndex)indexes.get(i));
                        deleteRecursive(di.indexerPath);
                    }
                     // end for deleting and index
                }
                indexes = newIndex;
            }
        }
        else showMessage(dsErr, Messages.getString("DocSearch.plsCrtNewIdx"));
    }

public void deleteRecursive(String folderToDelete) {
        int curFoldNum = 0;
        File curFolderFile;
        String curFold = "";
        String[] subFolds;
        int numSubFolds = 0;
        int totalFolds = 0;
        int numFiles = 0;
        String curFolderString = "";
        String curFileString = "";
        File testFile;
        try {
            // first obtain a list of all folders
            setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
            ArrayList allFold = new ArrayList();
            allFold.add(folderToDelete);
            setStatus(dsRmvgIdxFis);
            do {
                // get list of sub folders
                curFolderString = (String)allFold.get(curFoldNum);
                curFolderFile = new File(curFolderString);
                subFolds = curFolderFile.list(ff);
                numSubFolds = subFolds.length;
                for (int y = 0; y < numSubFolds; y++) {
                    curFold = curFolderString + pathSep + subFolds[y] + pathSep;
                    curFold =
                        Utils.replaceAll(pathSep + pathSep, curFold, pathSep);
                    allFold.add(curFold);
                    totalFolds++;
                }
                curFoldNum++;
            }
            while (curFoldNum < totalFolds);
            // next get a list of all files
            ArrayList allFiles = new ArrayList();
            Iterator foldIt = allFold.iterator();
            String[] filesString;
            while (foldIt.hasNext()) {
                curFolderString = (String)foldIt.next();
                curFolderFile = new File(curFolderString);
                // get the files
                filesString = curFolderFile.list();
                numFiles = filesString.length;
                for (int y = 0; y < numFiles; y++) {
                    // add the files
                    curFileString = curFolderString + pathSep + filesString[y];
                    curFileString =
                        Utils.replaceAll(pathSep + pathSep, curFileString,
                                         pathSep);
                    testFile = new File(curFileString);
                    if (!testFile.isDirectory()) allFiles.add(curFileString);
                }
            }
             // end for iterating
            // delete all files
            Iterator fileIt = allFiles.iterator();
            while (fileIt.hasNext()) {
                curFileString = (String)fileIt.next();
                testFile = new File(curFileString);
                testFile.delete();
            }
             // end while deleteing
            // delete all folders
            int numFoldTotal = allFiles.size();
            for (int y = numFoldTotal - 1; y >= 0; y--) {
                curFolderString = (String)allFiles.get(y);
                curFolderFile = new File(curFolderString);
                System.out.println(dsDeleting+" " + curFolderString);
                curFolderFile.delete();
            }
            // delete last folder
            curFolderFile = new File(folderToDelete);
            curFolderFile.delete();
        }
         // end for trrying recursive delete
        catch (Exception eR) {
            showMessage(dsErr,
                        eR.toString());
        }
        finally {
            setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
            setStatus(dsIdxRemoved);
        }
    }

    public void cb()
    {
        if (useAuthor.isSelected())
        {
            authorField.setEnabled(true);
        }
        else
        {
            authorField.setEnabled(false);
        }

        if (useDate.isSelected())
        {
            fromField.setEnabled(true);
            toField.setEnabled(true);
        }
        else
        {
            fromField.setEnabled(false);
            toField.setEnabled(false);
        }

        if (useSize.isSelected())
        {
            sizeFromField.setEnabled(true);
            sizeToField.setEnabled(true);
        }
        else
        {
            sizeFromField.setEnabled(false);
            sizeToField.setEnabled(false);
        }

        if (useType.isSelected())
        {
            fileType.setEnabled(true);
        }
        else
        {
            fileType.setEnabled(false);
        }
    }

void doZipArchiveUpdate(DocSearcherIndex di) {
        // try and obtain meta data from the file
        // based on this new meta data see if we can obtain new index
        // fourth column
        String tempArchiveDir = Utils.getFolderOnly(di.path);
        String metaFileName = Utils.addFolder(tempArchiveDir, "archives.htm");
        String tempManifestFileName = Utils.addFolder(workingDir, "temp_manifest.htm");
        boolean okToUpdate = true;
        if (metaFileName.toLowerCase().startsWith("http:"))  {
            okToUpdate = downloadURLToFile(metaFileName, tempManifestFileName);
            metaFileName = tempManifestFileName;
        }
        if (okToUpdate) {
            // load the meta data
            try {
                Table tempTable = new Table(6, 100);
                tempTable.htmlLoad(metaFileName, "");
                String newIndexDate = di.lastIndexed;
                okToUpdate = tempTable.loadOK;
                if (okToUpdate) {
                    // search for our new date
                    int numArchs = tempTable.colSize();
                    boolean foundArch = false;
                    int matchInt = 0;
                    for (int i = 0; i < numArchs; i++) {
                        if (tempTable.inItem(0, i).equals(di.desc))  {
                            matchInt = i;
                            foundArch = true;
                            break;
                        }
                    }
                     // end for iterating
                    if (foundArch) {
                        if (!tempTable.inItem(1, matchInt).equals(di.lastIndexed)) {
                            newIndexDate = tempTable.inItem(1, matchInt);
                            String downloadFileName =
                                Utils.addFolder(tempArchiveDir,  tempTable.inItem(2, matchInt));
                            if (downloadFileName.toLowerCase().startsWith("http:")) {
                                String tempZipFileName = Utils.addFolder(workingDir, "temp_zip_download.zip");
                                okToUpdate = downloadURLToFile(downloadFileName, tempZipFileName);
                                downloadFileName = tempZipFileName;
                            }
                            if (okToUpdate) {
                                // now delete recursively the directory
                                // and extract the new zip
                                setStatus(dsDeleting+" " + di.indexerPath);
                                deleteRecursive(di.indexerPath);
                                File newIndP = new File(di.indexerPath);
                                boolean madeFold = newIndP.mkdir();
				if (newIndP.exists()) madeFold=true;
                                boolean finalSuccess = true;
                                if (madeFold) {
                                    setStatus(dsUnZipn+" " + downloadFileName  + " --> " + di.indexerPath);
                                    UnZippHandler uz = new UnZippHandler(downloadFileName,  di.indexerPath);
                                    try {
                                        uz.unZip();
                                        setStatus(dsUnZipD);
                                        di.lastIndexed = newIndexDate;
                                    }
                                    catch (Exception eZ) {
                                        finalSuccess = false;
                                        showMessage(dsErr,
                                                    eZ.toString());
                                    }
                                }
                                else showMessage(Messages.getString("DocSearch.noMakeFolder"), di.indexerPath);
                            }
                             // end if ok to update
                        }
                         // end if dates different
                        else showMessage(Messages.getString("DocSearch.noUpdates"), Messages.getString("DocSearch.lastUpdateWas") + di.lastIndexed);
                    }
                     // end if found arch
                    else showMessage(Messages.getString("DocSearch.noMetaData"), Messages.getString("DocSearch.noMetaData")+ " " + metaFileName);
                }
                else showMessage(Messages.getString("DocSearch.noMetaData"), Messages.getString("DocSearch.noMetaData")+ " " + metaFileName);
            }
             // end for trying to update Zip
            catch (Exception metaE) {
                setStatus(Messages.getString("DocSearch.noMetaData")+" " + metaFileName);
                okToUpdate = false;
            }
        }
    }

public String getArchiveDir() { return archiveDir; }

public void doExport(DocSearcherIndex di) {
        // zip contents and place in archive Dir
        String archiveZipFileName = Utils.replaceAll(" ", di.desc, "_");
        if (!archiveZipFileName.toLowerCase().endsWith(".zip")) archiveZipFileName += ".zip";
        String content = di.path;
        if (di.isWeb) content = di.match;
        String zipFileNameOnly = archiveZipFileName;
        archiveZipFileName = Utils.addFolder(di.archiveDir, archiveZipFileName);
        ZippHandler zh = new ZippHandler(archiveZipFileName, di.indexerPath);
        boolean zipSuccess = true;
        String errMsg = "";
        setStatus(Messages.getString("DocSearch.archIdx")+" " + di.desc + " --> "
                  + archiveZipFileName + ", " + plsWait);
        try {
            zh.zip();
        }
        catch (Exception eZ) {
            errMsg = eZ.toString();
            zipSuccess = false;
        }
        finally {
		setStatus(Messages.getString("DocSearch.archDone"));
		}
        if (zipSuccess) {
            showMessage(Messages.getString("DocSearch.archiveSuccess"),
                        di.desc +" "+ Messages.getString("DocSearch.archivedFile")
                        + archiveZipFileName);
        }
        else showMessage(dsErr, errMsg);
        // OK now update the archive table
        updateArchiveTable(di.desc, di.lastIndexed, zipFileNameOnly, di.archiveDir, content);
    }

public void updateArchiveTable(String desc,
                                   String lastIndexed,
                                   String zipFileName,
                                   String archDir,
                                   String content) {
        boolean hasErr = false;
        String errMsg = "";
        try {
            String archivesFileName = Utils.addFolder(archDir, "archives.htm");
            setStatus(dsUpdtArchTbl+" " + archivesFileName);
            File textArchiveIndex = new File(archivesFileName);
            if (textArchiveIndex.exists()) {
                // read and update the file
                Table tempTable = new Table(6, 100);
                tempTable.htmlLoad(archivesFileName, "");
                tempTable.captionStr =
                    "DocSearcher Lucene Search Index Archive Listing";
                int numI = tempTable.colSize();
                String tempDesc = "";
                int foundAtNum = numI;
                // parse it
                for (int i = 1; i < numI; i++) {
                    tempDesc = tempTable.inItem(0, i);
                    if (tempDesc.equals(desc)) {
                        foundAtNum = i;
                        break;
                    }
                }
                 // end for iterating
                //
                tempTable.add(desc, 0, foundAtNum);
                tempTable.add(lastIndexed, 1, foundAtNum);
                tempTable.add(zipFileName, 2, foundAtNum);
                tempTable.add(content, 3, foundAtNum);
                // save it
                int k = tempTable.colSize();
                int l = tempTable.rowSize();
                tempTable.fpSave(archivesFileName, k, l);
            }
            else {
                // create a new archive index
                Table tempTable = new Table(6, 102);
                tempTable.captionStr =
                    "DocSearcher Lucene Search Index Archive Listing";
                //
                // add the header
                tempTable.add("Description", 0, 0);
                tempTable.add("Date of Indexing", 1, 0);
                tempTable.add("Archive Zip File", 2, 0);
                tempTable.add("Directory or Content", 3, 0);
                // add the data
                tempTable.add(desc, 0, 1);
                tempTable.add(lastIndexed, 1, 1);
                tempTable.add(zipFileName, 2, 1);
                tempTable.add(content, 3, 1);
                // save it
                int k = tempTable.colSize();
                int l = tempTable.rowSize();
                tempTable.fpSave(archivesFileName, k, l);
            }
        }
         // end for try
        catch (Exception eT) {
            hasErr = true;
            errMsg = eT.toString();
        }
        if (hasErr) showMessage(dsErr, errMsg);
        else setStatus(dsArchTblUpdtd);
}

public boolean downloadURLToFile(String urlString, String fileToSaveAs) {
        byte curBint;
        boolean returnBool = true;
        int numBytes = 0;
        int curI = 0;
        FileOutputStream dos;
        InputStream urlStream;
        int lastPercent = 0;
        int curPercent = 0;
        try {
            URL url = new URL(urlString);
            File saveFile = new File(fileToSaveAs);
            dos = new FileOutputStream(saveFile);
            URLConnection conn = (URLConnection)url.openConnection();
            conn.setDoInput(true);
            conn.setUseCaches(false);
            conn.connect();
            urlStream = conn.getInputStream();
            int totalSize = conn.getContentLength();
            while (curI != -1) {
                curI = urlStream.read();
                curBint = (byte)curI;
                if (curI == -1) break;
                dos.write(curBint);
                numBytes++;
                if (totalSize > 0) {
                    curPercent = (numBytes * 100) / totalSize;
                    if (curPercent != lastPercent) {
                        setStatus(curPercent + " " + dsPcntDnld + " " + dsOfFile +" "+ urlString + " "+ dsBytsTot +" "+ totalSize);
                        lastPercent = curPercent;
                    }
                }
                 // end if total size not zero
            }
            urlStream.close();
            dos.close();
        }
        catch (Exception eF) {
            showMessage(dsDnLdErr, eF.toString());
            returnBool = false;
            eF.printStackTrace();
        }

        return returnBool;
}

public void doImport(String zipFileString,
                         String description,
                         String dateIndexed,
                         boolean searchedByDefault,
                         boolean isWeb,
                         int indexPolicy) {
        // may be just a URL
        boolean successFulDownload = true;
        if (dateIndexed.equals("")) {
            dateIndexed = DateTimeUtils.getToday();
        }
        //
        boolean zipSuccess = true;
        String errMsg = "";
        String indexFolderName = Utils.replaceAll(" ", description, "_");
        String loadString = zipFileString;
        if (loadString.toLowerCase().startsWith("http://")) {
            // download zip and load the downloaded zip file
            String nameOnlyStr = Utils.getNameOnly(loadString);
            loadString = Utils.addFolder(archiveDir, nameOnlyStr);
            successFulDownload = downloadURLToFile(zipFileString, loadString);
            if (!successFulDownload) {
                errMsg = dsDnLdErr+" " + zipFileString;
                zipSuccess = false;
            }
        }
         // end for downloading the zip
        indexFolderName = Utils.addFolder(indexDir, indexFolderName);
        File newIndexFolder = new File(indexFolderName);
        boolean dirMade = newIndexFolder.mkdir();
	if (newIndexFolder.exists()) {
		setStatus(dsErr+" : "+FOLDER_ALREADY_EXISTS+"--> "+indexFolderName);
		dirMade=true;
		}
        if ((dirMade) && (successFulDownload)) {
            UnZippHandler uz = new UnZippHandler(loadString, indexFolderName);
            setStatus(dsImptg+" " + description + " "+plsWait);
            try {
                uz.unZip();
                // add it in there
                DocSearcherIndex di =
                    new DocSearcherIndex(zipFileString, description,
                                         searchedByDefault, 0, indexFolderName,
                                         isWeb, "", "", indexPolicy, archiveDir);
                indexes.add(di);
            }
            catch (Exception eZ) {
                errMsg = eZ.toString();
                zipSuccess = false;
            }
            finally {
                setStatus(dsImprtDn);
            }
            if (zipSuccess) {
                showMessage(dsImprtSuccess, description  + " "+ dsWasImprtd);
            }
            else  {
                showMessage(dsErrImptg+" : " + description, errMsg);
            }
        }
        else showMessage(dsErrImptg, Messages.getString("DocSearch.noMakeFolder") +"  " + indexFolderName);
 }

public void getImportInfo() {
        ImportDialog id =
            new ImportDialog(this, Messages.getString("DocSearch.imprtIdx"), true);
        id.init();
        id.setVisible(true);
        if (id.confirmed) {
            String importZipFileName = id.urlOrFile.getText().trim();
            String importFolderOnly = Utils.getFolderOnly(importZipFileName);
            String importManifestName = Utils.addFolder(importFolderOnly, "archives.htm");
            String zipArchNameOnly = Utils.getNameOnly(importZipFileName);
            boolean foundManifest = false;
            boolean foundManifestData = false;
            boolean doImport = true;
            //
            String zipFileString = importZipFileName;
            String description = "Unknown";
            String dateIndexed = "";
            boolean searchedByDefault = true;
            boolean isWeb = true;
            int indexPolicy = 0;
            //
            if (importManifestName.toLowerCase().startsWith("http:")) {
                // convert URL to file
                String tempManifestFileName = Utils.addFolder(workingDir, "temp_manifest.htm");
                foundManifest = downloadURLToFile(importManifestName, tempManifestFileName);
                if (foundManifest) {
                    importManifestName = tempManifestFileName;
                }
            }
             // end for manifest
            else {
                File testManifestFile = new File(importManifestName);
                if (testManifestFile.exists()) {
                    foundManifest = true;
                }
            }
             // end for not a URL
            if (foundManifest) {
                // try and retrieve the manifest data
                Table tempTable = new Table(11, 100);
                tempTable.htmlLoad(importManifestName, "");
                int numI = tempTable.colSize();
                int tempSbd = 0;
                String tempArchFile = "";
                String tempDesc = "";
                String tempDateIndexed = "";
                // parse it
                for (int i = 1; i < numI; i++) {
                    //
                    try {
                        tempDesc = tempTable.inItem(0, i);
                        tempArchFile = tempTable.inItem(2, i);
                        tempDateIndexed = tempTable.inItem(1, i);
                        if (zipArchNameOnly.equals(tempArchFile)) {
                            description = tempDesc;
                            dateIndexed = tempDateIndexed;
                            foundManifestData = true;
                            setStatus(dsArchDescFnd + description);
                            break;
                        }
                        else System.out.println(zipArchNameOnly + " != " + tempArchFile);
                    }
                    catch (Exception eR) {
                        setStatus(dsErrParseMnfst+" " + eR.toString());
                    }
                }
                 // end for iterating over manifest file entries
            }

            if (!foundManifestData) {
                // show a dialog to obtain archive meta data
                // IF dialog is cancelled ; doImport  =  false
                ManifestDialog md =
                    new ManifestDialog(this, Messages.getString("DocSearch.importIdxProperties"), true);
                md.init();
                md.setVisible(true);
                if (md.confirmed) {
                    description = md.descField.getText().trim();
                    dateIndexed = DateTimeUtils.getToday();
                    isWeb = md.isWebBox.isSelected();
                    searchedByDefault = md.sbdBox.isSelected();
                    indexPolicy = md.indexFreq.getSelectedIndex();
                }
                else doImport = false;
            }

            if (doImport)  {
                // create our new index!
                doImport(zipFileString, description, dateIndexed,
                         searchedByDefault, isWeb, indexPolicy);
            }
        }
         // end for confirmed
    }

public static void main(String[] args)   {
        //System.out.println("Locale:"+Locale.getDefault().toString());
        String commandString = "";
        String indexString = "";
        boolean hasCommands = false;
        if (args.length > 0)  {
            commandString = args[0];
            if (commandString != null)  {
                if (args.length > 1)   {
                    indexString = args[1];
                    if (indexString == null)  {
                        indexString = "";
                    }
                }
                hasCommands = true;
            }
        }

        final DocSearch sw;
        DocSplashViewer splash =
            new DocSplashViewer("splash.gif",
                                "DocSearcher "
				+Messages.getString("DocSearch.version")
				+" "
				+Messages.getString("DocSearch.loading"));
        if (!hasCommands) splash.display();
        sw = new DocSearch();
        if (args.length > 0) {
            sw.useGui = false;
        }
        splash.setMonitor(sw);
        sw.init();
        splash.close();
        if (!hasCommands) {
            sw.setVisible(true);
            sw.checkUpdates();
        }
        else {
            if ((commandString.equals(Messages.getString("DocSearch.updateCMD"))) && (indexString.equals("")))  {
                sw.checkUpdates();
                System.exit(0);
            }
            else sw.doCommand(commandString, indexString);
        }
    }

public void doCommand(String commandString, String indexString) {
	boolean doSndMail=sendNoticeOnIdxingChanges();
	boolean isTxtFormt=isTextEmailFormat();       
        System.out.println(Messages.getString("DocSearch.cmd") + commandString + Messages.getString("DocSearch.idx") + indexString);
        if (commandString.equals(Messages.getString("DocSearch.listCMD"))) {
            int numIndexes = indexes.size();
            if (numIndexes > 0) {
                DocSearcherIndex di;
                Iterator it = indexes.iterator();
                int countNum = 1;
                while (it.hasNext())  {
                    di = (DocSearcherIndex)it.next();
                    System.out.println(countNum + ". " + di.desc);
                    countNum++;
                }
            }
            else System.out.println(Messages.getString("DocSearch.noIndexFound"));
        }
        else if (commandString.equals(Messages.getString("DocSearch.updateCMD"))) {
            if (indexString.trim().equals("")) System.out.println(Messages.getString("DocSearch.pleaseSpecifyAnIndex"));
            else  {
                int numIndexes = indexes.size();
                boolean foundMatch = false;
                if (numIndexes > 0) {
                    DocSearcherIndex di;
		    boolean sendAMess=sendNoticeOnIdxingChanges();
                    Iterator it = indexes.iterator();
                    while (it.hasNext())  {
                        di = (DocSearcherIndex)it.next();
                        if (di.desc.equals(indexString))  {
			    idx.setDoEmail(sendAMess);
			    idx.setEmailText(isTextEmailFormat());
                            idx.updateIndex(di);
			    if ((sendAMess) && (idx.getTotalChanges()>0)) {
			    	sendEmail(di.desc+" "+dsUpdts, idx.getUpDateNotes());
			    	}
                            foundMatch = true;
                            break;
                        }
                    }
                     // end for match
                    if (!foundMatch) System.out.println(indexString + Messages.getString("DocSearch.noMatchesFound"));
                }
                else System.out.println(Messages.getString("DocSearch.noIndexFound"));
            }
             // end for we have an index
        }
         // end for update
        else if (commandString.equals(Messages.getString("DocSearch.exportCMD"))) {
            if (indexString.trim().equals("")) System.out.println(Messages.getString("DocSearch.pleaseSpecifyAnIndex"));
            else {
                int numIndexes = indexes.size();
                boolean foundMatch = false;
                if (numIndexes > 0)
                {
                    DocSearcherIndex di;
                    Iterator it = indexes.iterator();
                    while (it.hasNext()) {
                        di = (DocSearcherIndex)it.next();
                        if (di.desc.equals(indexString))  {
                            doExport(di);
                            foundMatch = true;
                            break;
                        }
                    }
                     // end for match
                    if (!foundMatch) System.out.println(indexString + Messages.getString("DocSearch.noMatchesFound"));
                }
                else System.out.println(Messages.getString("DocSearch.noIndexFound"));
            }
             // end for we have an index
        }
        else if (commandString.startsWith(Messages.getString("DocSearch.searchCMD")))  {
            String searchT = commandString.substring(7, commandString.length());
            setStatus(Messages.getString("DocSearch.searchingFor") + searchT + "...");
            if (indexString.trim().equals(""))  doSearch(searchT);
            else  {
                int numIndexes = indexes.size();
                if (numIndexes > 0)  {
                    DocSearcherIndex di;
                    boolean foundMatch = false;
                    Iterator it = indexes.iterator();
                    while (it.hasNext())  {
                        di = (DocSearcherIndex)it.next();
                        if (di.desc.equals(indexString)) {
                            di.shouldBeSearched = true;
                            foundMatch = true;
                        }
                        else di.shouldBeSearched = false;
                    }
                     // end for match

                    if (!foundMatch) System.out.println(indexString + Messages.getString("DocSearch.indexNotFound"));
                    else doSearch(searchT);
                }
                else System.out.println(Messages.getString("DocSearch.noIndexFound"));
            }

            // proceed to do search
        }
        else if (commandString.equals("analyze_log"))  {
            try  {
                LogAnalysis.doLogAnalysis(this, indexString);
            }
            catch (Exception eF)  {
                System.out.println(Messages.getString("DocSearch.errAnalyzingLogFile")
		 + indexString
		 + "\n" + eF.toString());
            }
        }
	else if (commandString.equals(Messages.getString("DocSearch.importLower"))) {
		ArchiveMetaData amd=new ArchiveMetaData (indexString);
		//
		doImport(indexString, amd.getDesc(), amd.getDI(), amd.getSDB(), amd.getIsWeb(), amd.getIndexPolicy());
		//System.out.println("\nIMPORT index -->"+indexString);
		//System.out.println("\ndescription -->"+amd.getDesc());
	} // end for importing index
        else  System.out.println(Messages.getString("DocSearch.cmdUsage")); // list the command line help
        doExit();
    }
    


    public void getSeachLogReport()
    {
        JFileChooser fdo = new JFileChooser();
        fdo.setCurrentDirectory(new File(workingDir));
        int fileGotten =
            fdo.showDialog(this, Messages.getString("DocSearch.select"));
        if (fileGotten == JFileChooser.APPROVE_OPTION)
        {
            File file = fdo.getSelectedFile();
            try
            {
                LogAnalysis.doLogAnalysis(this, file.toString());
            }
            catch (Exception eF)
            {
                setStatus(Messages.getString("DocSearch.statusLogError")
                          + eF.toString());
            }
        }
    }

protected void doMetaReport() {
        MetaReport mr = new MetaReport();
        mr.getMetaReport(this);
}

class Hyperactive
        implements HyperlinkListener {
        public void hyperlinkUpdate(HyperlinkEvent e) {
            if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
                JEditorPane pane = (JEditorPane)e.getSource();
                if (e instanceof HTMLFrameHyperlinkEvent) {
			String urlString = e.getURL().toString();
			doExternal(urlString);
			
                }
                else
                {
                    try
                    {
                        String urlString = e.getURL().toString();
				if ((urlString.toLowerCase().endsWith(".exe")) || 
					(urlString.toLowerCase().endsWith(".sh")))  {
					try {
						if (urlString.startsWith("file:/")) {
							urlString=urlString.substring(6,urlString.length());
							}
						Runtime.getRuntime().exec(urlString);
						}
					catch (Exception eR) {
						setStatus(urlString+" : "+eR.toString());
						eR.printStackTrace();
						}
					}
                        else {
				if (loadExternal) doExternal(urlString);
				else setPage(urlString);
				}
                    }
                    catch (Throwable t)
                    {
                        showMessage(errLoadPage,
                                    errReported
                                    + t.toString());
                        t.printStackTrace();
                    }
                }
            }
        }
    }
    
class comboListener implements ActionListener  {
        public void actionPerformed(ActionEvent e)  {
	    if (e!=null) {
	    	if (e.getSource()!=null) {
		    	if (e.getSource()==searchField) {
	            		String source = e.getActionCommand();
				String act="";
	    			if (searchField.getSelectedItem() != null) {
					act=e.getActionCommand();
					if (act!=null) {
			                	if (act.equals("comboBoxEdited"))  doThreadedSearch();
						}
					}
				}
			}
		}
        }
    }

class CheckBoxListener implements ActionListener  {
        public void actionPerformed(ActionEvent e)
        {
            String source = e.getActionCommand();
            cb();
        }
    }
    
    
public void doHandlers() {
    	DsProperties hd=new DsProperties(this, "Options", true);
	hd.init();
	hd.setVisible(true);
	if (hd.confirmed) {
	    String tempLafChosen="";
            // check everything
	    switch (hd.returnInt) {
	        default : // nothing
			break;
		case 0: // default hdnler
			defaultHndlr=hd.defaultHndlrField.getText();
			break;
	    	case 1: // look and feel
			tempLafChosen=(String)hd.uiChoice.getModel().getSelectedItem();
			if (!tempLafChosen.equals("")) lafChosen=tempLafChosen;
			try {
				UIManager.setLookAndFeel(lafChosen);
				SwingUtilities.updateComponentTreeUI(this);
				resize(kDefaultX, kDefaultY);
				}
			catch (Exception eN) {
				showMessage(dsErr, eN.toString());
				}
			// now for max file size to index
			long newMFSI=0;
			try {
				newMFSI=Long.parseLong(hd.maxSizeField.getText());
				if (newMFSI>0) newMFSI=newMFSI*1024;
				setMaxFileSize(newMFSI);
				}
			catch (Exception eN) {
				showMessage(dsErr, eN.toString());
				}
			// now for max hits to show
			String newMaxInt=hd.maxField.getText().trim();
			if (!newMaxInt.equals("")) {
				try {
					int newMaxN=Integer.parseInt(newMaxInt);
					if ((newMaxN>0) && (newMaxN<1000)) maxNumHitsShown=newMaxN;
					}
				catch (Exception eN) {
					showMessage(dsErr, eN.toString());
					eN.printStackTrace();
					}
				}
			if (hd.loadExternal.isSelected()) loadExternal=true;
			else loadExternal=false;
			break;
		case 2: // index directory
			//
			String newIndexDir=hd.dsDirField.getText().trim();
			if (!newIndexDir.equals("")) {
				// copy over our files
				if (hd.copyDirFiles.isSelected()) {
					// including our index list file
					copyFiles(indexDir, newIndexDir);
					// change the file settings on the DsIndex objects
					Iterator iterator = indexes.iterator();
            				DocSearcherIndex curI;
					String curIdxrStr="";
        				while (iterator.hasNext()) {
						curI=(DocSearcherIndex)iterator.next();
						curIdxrStr=curI.indexerPath;
						if (curIdxrStr.startsWith(indexDir)) {
							curI.indexerPath=newIndexDir+curIdxrStr.substring(indexDir.length(), curIdxrStr.length());
							}
						}
					setStatus(FINISHED_COPYING);
					}
				indexDir=newIndexDir;
				}
			String newDirFieldTExt=hd.tempDirField.getText().trim();
			//
			if (!newDirFieldTExt.equals("")) resetTempDir(newDirFieldTExt);
			// 
			String newWorkingDirFieldTExt=hd.workingDirField.getText().trim();
			if (!newWorkingDirFieldTExt.equals("")) resetWorkingDir(newWorkingDirFieldTExt);
			break;
		case 3 : // email stuff
			gateway=hd.gateWayField.getText();
			gatewayPwd=hd.gatewayPwdField.getText();
			gatewayUser=hd.gatewayUserField.getText();
			if (hd.sendEmailBx.isSelected()) sendEmailNotice="true";
			else sendEmailNotice="true";
			if (hd.textRB.isSelected()) emailFormat=hd.TEXT_FORMAT;
			else emailFormat=hd.HTML_FORMAT;
			break;
	    	}
	}
} // end for doing handlers
    
public void getHandlers() {
   	docTypeHandler dh;
	// pdf
	switch (osType) {
		case 0: // windows
			break;
		case 1: // linux
			if (Utils.exists("/usr/bin/xpdf")) {
				dh=new docTypeHandler("pdf", "Portable Document Format", "/usr/bin/xpdf");
				handlerList.add(dh);
				}
			else if (Utils.exists("/usr/bin/kghostview")) {
				dh=new docTypeHandler("pdf", "Portable Document Format", "/usr/bin/kghostview");
				handlerList.add(dh);
				}
			if (Utils.exists("/usr/bin/oowriter")) {
				dh=new docTypeHandler("sxw", "Star Office  or Open Office Writer", "/usr/bin/oowriter");
				handlerList.add(dh);
				dh=new docTypeHandler("doc", "Microsoft Word Document", "/usr/bin/oowriter");
				handlerList.add(dh);
				dh=new docTypeHandler("rtf", "Rich Text Format Document", "/usr/bin/oowriter");
				handlerList.add(dh);
				}
			if (Utils.exists("/usr/bin/oocalc")) {
				dh=new docTypeHandler("sxc", "Star Office  or Open Office Calc", "/usr/bin/oocalc");
				handlerList.add(dh);
				dh=new docTypeHandler("xls", "Microsoft Excell Spreadsheet", "/usr/bin/oocalc");
				handlerList.add(dh);
				}
			if (Utils.exists("/usr/bin/ooimpress")) {
				dh=new docTypeHandler("sxi", "Star Office  or Open Office Impress", "/usr/bin/ooimpress");
				handlerList.add(dh);
				dh=new docTypeHandler("ppt", "Microsoft Powerpoint Presentation", "/usr/bin/ooimpress");
				handlerList.add(dh);
				}
			if (Utils.exists("/usr/bin/kate")) {
				dh=new docTypeHandler("txt", "Text File", "/usr/bin/kate");
				handlerList.add(dh);
				dh=new docTypeHandler("java", "Java Source Code", "/usr/bin/kate");
				handlerList.add(dh);
				}
			else if (Utils.exists("/usr/bin/gedit")) {
				dh=new docTypeHandler("txt", "Text File", "/usr/bin/gedit");
				handlerList.add(dh);
				dh=new docTypeHandler("java", "Java Source Code", "/usr/bin/gedit");
				handlerList.add(dh);
				}
			if (Utils.exists("/usr/bin/konqueror")) {
				dh=new docTypeHandler("htm", "Web Page", "/usr/bin/konqueror");
				handlerList.add(dh);
				dh=new docTypeHandler("html", "Web Page", "/usr/bin/konqueror");
				handlerList.add(dh);
				dh=new docTypeHandler("jsp", "Web Page", "/usr/bin/konqueror");
				handlerList.add(dh);
				dh=new docTypeHandler("asp", "Web Page", "/usr/bin/konqueror");
				handlerList.add(dh);
				dh=new docTypeHandler("cfm", "Web Page", "/usr/bin/konqueror");
				handlerList.add(dh);
				dh=new docTypeHandler("shtml", "Web Page", "/usr/bin/konqueror");
				handlerList.add(dh);
				}
			else if (Utils.exists("/usr/bin/quanta")) {
				dh=new docTypeHandler("htm", "Web Page", "/usr/bin/quanta");
				handlerList.add(dh);
				dh=new docTypeHandler("html", "Web Page", "/usr/bin/quanta");
				handlerList.add(dh);
				dh=new docTypeHandler("jsp", "Web Page", "/usr/bin/quanta");
				handlerList.add(dh);
				dh=new docTypeHandler("asp", "Web Page", "/usr/bin/quanta");
				handlerList.add(dh);
				dh=new docTypeHandler("cfm", "Web Page", "/usr/bin/quanta");
				handlerList.add(dh);
				dh=new docTypeHandler("shtml", "Web Page", "/usr/bin/quanta");
				handlerList.add(dh);
				}
			else if (Utils.exists("/usr/bin/mozilla")) {
				dh=new docTypeHandler("htm", "Web Page", "/usr/bin/mozilla");
				handlerList.add(dh);
				dh=new docTypeHandler("html", "Web Page", "/usr/bin/mozilla");
				handlerList.add(dh);
				dh=new docTypeHandler("jsp", "Web Page", "/usr/bin/mozilla");
				handlerList.add(dh);
				dh=new docTypeHandler("asp", "Web Page", "/usr/bin/mozilla");
				handlerList.add(dh);
				dh=new docTypeHandler("cfm", "Web Page", "/usr/bin/mozilla");
				handlerList.add(dh);
				dh=new docTypeHandler("shtml", "Web Page", "/usr/bin/mozilla");
				handlerList.add(dh);
				}
			else if (Utils.exists("/usr/bin/galeon")) {
				dh=new docTypeHandler("htm", "Web Page", "/usr/bin/galeon");
				handlerList.add(dh);
				dh=new docTypeHandler("html", "Web Page", "/usr/bin/galeon");
				handlerList.add(dh);
				dh=new docTypeHandler("jsp", "Web Page", "/usr/bin/galeon");
				handlerList.add(dh);
				dh=new docTypeHandler("asp", "Web Page", "/usr/bin/galeon");
				handlerList.add(dh);
				dh=new docTypeHandler("cfm", "Web Page", "/usr/bin/galeon");
				handlerList.add(dh);
				dh=new docTypeHandler("shtml", "Web Page", "/usr/bin/galeon");
				handlerList.add(dh);
				}
			if (Utils.exists("/usr/bin/ark")) {
				dh=new docTypeHandler("zip", "Zip Archive", "/usr/bin/ark");
				handlerList.add(dh);
				}
			if (Utils.exists("/usr/bin/kpaint")) {
				dh=new docTypeHandler("png", "Portable Network Graphics", "/usr/bin/kpaint");
				handlerList.add(dh);
				dh=new docTypeHandler("gif", "GIF Graphics", "/usr/bin/kpaint");
				handlerList.add(dh);
				dh=new docTypeHandler("jpg", "JPG Graphics", "/usr/bin/kpaint");
				handlerList.add(dh);
				dh=new docTypeHandler("jpeg", "JPEG Graphics", "/usr/bin/kpaint");
				handlerList.add(dh);
				}
			else if (Utils.exists("/usr/bin/gimp")) {
				dh=new docTypeHandler("png", "Portable Network Graphics", "/usr/bin/gimp");
				handlerList.add(dh);
				dh=new docTypeHandler("gif", "GIF Graphics", "/usr/bin/gimp");
				handlerList.add(dh);
				dh=new docTypeHandler("jpg", "JPG Graphics", "/usr/bin/gimp");
				handlerList.add(dh);
				dh=new docTypeHandler("jpeg", "JPEG Graphics", "/usr/bin/gimp");
				handlerList.add(dh);
				}
			break;
		case 2: // unix
			break;
		case 3: // mac
			break;
		} // end for looking at os
   } // end for getHandlers

public void doObjectLoad(int loadInt, String fileName) {
// loadInt 0= broken links, 1= image descriptions, 2= allpages cache
String endRow="</tr";
String endCell="</td";
String startRow="<tr";
String startCell="<td";
boolean inCell=false;
boolean inTag=false;
StringBuffer tagBuf=new StringBuffer();
StringBuffer textBuf=new StringBuffer();
File loadFile=new File(fileName);
String lowerTag="";
String tag="";
int curCell=0;
String[] cells;
int numCells=0;
int numRowsForObject=Utils.getNumObjectRows(fileName);
if (numRowsForObject>0) {
	switch (loadInt) {
		case 0: // file handlers
		docTypeHandler bi;
		numCells=3;
		cells=new String[numCells];
		for (int i=0;i<numCells;i++) cells[i]="";
		// load and parse the file
		try {
			FileInputStream fi=new FileInputStream(loadFile);
			int curI=0; // reset i
			char curChar=' ';
			while(curI!=-1) {
				curI=fi.read();
				if (curI!=-1) {
					curChar=(char)curI;
					if (curChar=='<') {
						// beginning of a tag
						inTag=true;
						}
					else if (curChar=='>') {
						// end of a tag
						tagBuf.append(curChar);
						tag=tagBuf.toString();
						lowerTag=tag.toLowerCase();
						if (lowerTag.startsWith(endCell)) {
							cells[curCell]=textBuf.toString();
							textBuf=new StringBuffer();
							curCell++;
							} // end of a cell
						else if (lowerTag.startsWith(endRow)) {
							curCell=0;
							bi=new docTypeHandler(cells[0], cells[1], cells[2]);
							handlerList.add(bi);
							} // end of a row
						else if (lowerTag.startsWith(startCell)) {
							textBuf=new StringBuffer();
							} // end of startRow
						// always reset buffer
						inTag=false;
						tagBuf=new StringBuffer();
						} // end for end of a tag
					if (inTag) tagBuf.append(curChar);
					else if (curChar!='>') textBuf.append(curChar);
					}
				else break;
				} // end while reading file
			fi.close();
			}
		catch (Exception eL) {
			System.out.println("Error loading from:"+fileName);
			eL.printStackTrace();
			}
		break;
		} // end for switching loading
	} // file exists and we have rows
else System.out.println("Nothing found: "+fileName);
} // end for doIbjectLoad

public ArrayList getLafs() {
   ArrayList lafList=new ArrayList();
   Object[] objs=UIManager.getInstalledLookAndFeels();
   UIManager.LookAndFeelInfo li;
   int numLafs=objs.length;
   for (int i=0;i<numLafs;i++) {
   	li=(UIManager.LookAndFeelInfo)objs[i];
   	lafList.add(li.getClassName());
	//System.out.println(li.toString());
	}
   return lafList;
} // end for getting LAFs


public void copyFiles(String origin, String destination) {
	String stat=Messages.getString("DocSearch.copyingFolder")+" "+Utils.concatStr(origin);
	if (isLoading) curStatusString=stat;
	else setStatus(stat);
	File originFolder=new File(origin);
	File destinationFolder=new File(destination);
	if ((originFolder.exists()) && (destinationFolder.exists())) {
		String allFilesList[]=originFolder.list();
		int numFiles=allFilesList.length;
		String newNiNa="";
		String origFiNa="";
		String newNameO="";
		File testDirFi;
		File testNewDirFi;
		for (int i=0;i<numFiles;i++) {
			origFiNa=Utils.addFolder(origin,allFilesList[i]);
			testDirFi=new File(origFiNa);
			newNameO=allFilesList[i];
			newNiNa=Utils.addFolder(destination,allFilesList[i]);
			if (testDirFi.isDirectory()) {
				boolean subCreated=false;
				File newSubFile=new File(newNiNa);
				subCreated=newSubFile.mkdir();
				if (subCreated) copyFiles(origFiNa, newNiNa);
				else setStatus(ERROR_CREATING_FOLDER+" "+newNiNa);
				}
			else copyFile(origFiNa, newNiNa);
			} // end for copying the File
		} // end for a valid directory
} // end for copyFiles

public void copyFile(String originalFileName, String newFileName) {
	try {
		setStatus(plsWait+" "+COPYING_FILE+" "+Utils.concatStr(originalFileName)+" --> "+Utils.concatStr(newFileName));
		FileInputStream fis =  new FileInputStream(originalFileName);
		FileOutputStream fos =  new FileOutputStream(newFileName);
		FileChannel fcin = fis.getChannel();
		FileChannel fcout = fos.getChannel();
		fcin.transferTo(0, fcin.size(), fcout);
		fcin.close();
		fcout.close();
		fis.close();
		fos.close();
		setStatus(FINISHED_COPYING+" "+Utils.concatStr(originalFileName));
		}
	catch (Exception eR) {
		setStatus(dsErr+" : "+eR.toString());
		}
}  // end for copyFile


public void checkCdDir() {
	String changeStr="";
	boolean changeCD=false;
	if (isCDSearchTool) {
		// look at startDir
		// 0=win, 1=linux, 2=Unix, 3=Mac
		switch (osType) {
			case 0: 
				changeStr=startDir.substring(0,2);
				changeCD=true;
				break;
			case 1:
				// do nothing
				if (startDir.indexOf("/mnt/cdrom1")!=-1) {
					changeStr="/mnt/cdrom1";
					changeCD=true;
					}
				else if (startDir.indexOf("/mnt/cdrom2")!=-1) {
					changeStr="/mnt/cdrom2";
					changeCD=true;
					}
				break;
			case 2:
				break;
			case 3:
				break;
			}
		} // end for isCDSearchTool	
	if (changeCD) {
		cdDir=changeStr;
		System.out.println("NEW CD DIR IS: "+cdDir);
		}
} // end for checking CD DIR

public String getCdRomDir() {
	return cdDir;
}

public String getCdPath(String pathToChange) {
	//System.out.println("ORIG PATH: "+pathToChange);
	String ptc=pathToChange.substring(7, pathToChange.length());
	if ((ptc.startsWith("/")) || (ptc.startsWith("\\"))) ptc=ptc.substring(1, ptc.length()); 
	String tmpGetCDROMDr=getCdRomDir();
	if (!Utils.endsWithSlash(tmpGetCDROMDr)) {
		return tmpGetCDROMDr+"/"+ptc;
		}
	else return tmpGetCDROMDr+ptc;
}

public boolean isThisOnACd(String cdRomIdxList) {
	//
	// looks for startDir/cdrom_indexes
	// 
	File testCDFi=new File(cdRomIdxList);
	if (testCDFi.exists()) return true;
	else return false;
}

public void loadPrefs() {
	// loads prefs stored in savePrefsFiNa
	String prefsText=loadFile(userPrefs).toString();
	int adminEmNo=0;
	String sendEmailNoticeLoaded=Utils.getLineParam("sendEmailNotice", prefsText);
	if (!sendEmailNoticeLoaded.equals("")) sendEmailNotice=sendEmailNoticeLoaded;
	//
	String aen=Utils.getLineParam("numAdminEmails", prefsText);
	try {
		adminEmNo=Integer.parseInt(aen);
		}
	catch (Exception eN) {
		adminEmNo=0;
		}
	if (adminEmNo>0) {
		// add to arraylist of emails
		String curE="";
		for (int i=0;i<adminEmNo;i++) {
			//
			curE=Utils.getLineParam("email"+i, prefsText);
			addEmail(curE);
			} // end for adminEmNo
		}
	// maxFileSize to index
	String newMaxFISI=Utils.getLineParam("maxFileSizeToIndex", prefsText);
	long newMaxFiSiInt=0;
	if (!newMaxFISI.equals("")) {
		try {
			newMaxFiSiInt=Long.parseLong(newMaxFISI);
			setMaxFileSize(newMaxFiSiInt);
			System.out.println("Max file size to index: "+newMaxFiSiInt);
			}
		catch (Exception eR) {
			eR.printStackTrace();
			}
		} // end if we have a value
	else System.out.println("No prefs for max file size found, using default: "+getMaxFileSize());
	// emailFormat
	String emailFormatLoaded=Utils.getLineParam("emailFormat", prefsText);
	if (!emailFormatLoaded.equals("")) emailFormat=emailFormatLoaded;
	//
	String gatewayUserLoaded=Utils.getLineParam("gatewayUser", prefsText);
	if (!gatewayUserLoaded.equals("")) gatewayUser=gatewayUserLoaded;
	//
	String loadExternalLoaded=Utils.getLineParam("loadExternal", prefsText);
	if (loadExternalLoaded.equals("false")) loadExternal=false;
	else loadExternal=true;
	// 
	String gatewayPwdLoaded=Utils.getLineParam("gatewayPwd", prefsText);
	if (!gatewayPwdLoaded.equals("")) gatewayPwd=gatewayPwdLoaded;
	//
	String gatewayLoaded=Utils.getLineParam("gateway", prefsText);
	if (!gatewayLoaded.equals("")) gateway=gatewayLoaded;
	//
	String browserLoaded=Utils.getLineParam("browser", prefsText);
	if (!browserLoaded.equals("")) defaultHndlr=browserLoaded;
	// maxNumHitsShown
	String maxNumHitsShownLoaded=Utils.getLineParam("maxNumHitsShown", prefsText);
	if (!maxNumHitsShownLoaded.equals("")) {
		// maxNumHitsShown
		int tsMax=250;
		try {
			tsMax=Integer.parseInt(maxNumHitsShownLoaded);
			maxNumHitsShown=tsMax;
			}
		catch (Exception eN) {
			maxNumHitsShown=250;
			}
		}
	//
	String tempDirLoaded=Utils.getLineParam("tempDir", prefsText);
	if (!tempDirLoaded.equals("")) resetTempDir(tempDirLoaded);
	//
	String lafLoaded=Utils.getLineParam("laf", prefsText);
	if (!lafLoaded.equals(""))  {
		lafChosen=lafLoaded;
		if (useGui) try {
			UIManager.setLookAndFeel(lafChosen);
			SwingUtilities.updateComponentTreeUI(this);
			pack();
			}
		catch (Exception eL) {
			setStatus(ERROR+" : "+eL.toString());
			eL.printStackTrace();
			}
		}
	String indexDirLoaded=Utils.getLineParam("indexDir", prefsText);
	if (!indexDirLoaded.equals(""))  {
		File testIdxDir=new File(indexDirLoaded);
		if (testIdxDir.exists()) indexDir=indexDirLoaded;
		else System.out.println("Index dir doesn't exist ("+indexDirLoaded+"). Using Default:"+indexDir);
		}
	String workingDirLoaded=Utils.getLineParam("workingDir", prefsText);
	if (!workingDirLoaded.equals(""))  {
		File testworkingDir=new File(workingDirLoaded);
		if (testworkingDir.exists()) {
			resetWorkingDir(workingDirLoaded);
			}
		else System.out.println("Index dir doesn't exist ("+workingDirLoaded+"). Using Default:"+workingDir);
		}
} // end for loadPrefs

public void saveSettings() {
	// saves look and feel settings as well as browser preference 
	// in file : savePrefsFiNa
	StringBuffer prefBuf=new StringBuffer();
	String temAdEm="";
	int numAdm=numGetAdminEmails();
	prefBuf.append("gateway="+gateway+"\n");
	prefBuf.append("gatewayPwd="+gatewayPwd+"\n");
	// max file size to index
	prefBuf.append("maxFileSizeToIndex="+getMaxFileSize()+"\n");
	// maxNumHitsShown
	prefBuf.append("maxNumHitsShown="+maxNumHitsShown+"\n");
	prefBuf.append("gatewayUser="+gatewayUser+"\n");
	prefBuf.append("emailFormat="+emailFormat+"\n");
	if (loadExternal) prefBuf.append("loadExternal=true\n");
	else prefBuf.append("loadExternal=false\n");
	prefBuf.append("sendEmailNotice="+sendEmailNotice+"\n");
	prefBuf.append("numAdminEmails="+numAdm+"\n");
	for (int i=0;i<numAdm;i++) {
		temAdEm=(String)adminEmails.get(i);
		prefBuf.append("email"+i+"="+temAdEm+"\n");
		}
	prefBuf.append("browser="+defaultHndlr+"\n");
	prefBuf.append("laf="+lafChosen+"\n");
	prefBuf.append("indexDir="+indexDir+"\n");
	prefBuf.append("tempDir="+tempDir+"\n");
	prefBuf.append("workingDir="+workingDir+"\n");
	saveFile(userPrefs, prefBuf);
} // end for saveSettings

public void resetTempDir(String toSet) {
	tempDir=toSet;
	wordTextFile =  Utils.addFolder(tempDir, "temp_word_file_"+USER_NAME+".txt");
	excelTextFile = Utils.addFolder(tempDir, "temp_excel_file_"+USER_NAME+".txt");
	rtfTextFile = Utils.addFolder(tempDir, "temp_rtf_file_"+USER_NAME+".txt");
	pdfTextFile = Utils.addFolder(tempDir, "temp_pdf_file_"+USER_NAME+".txt");
	ooTextFile = Utils.addFolder(tempDir, "temp_oo_file_"+USER_NAME+".xml");
	ooMetaTextFile = Utils.addFolder(tempDir, "temp_oo_meta_file_"+USER_NAME+".xml");
	ooTextOnlyFile = Utils.addFolder(tempDir, "temp_oo_text_file_"+USER_NAME+".txt");
} // end for resetTempDir

public void resetWorkingDir(String toSet) {
	workingDir=toSet;
    	indexFile = Utils.addFolder(workingDir, "index_list.htm");
	bookmarksFile = Utils.addFolder(workingDir, "bookmarks.htm");
	archiveDir = Utils.addFolder(workingDir, "archives");
	defaultSaveFolder = Utils.addFolder(workingDir, "saved_searches");
	//
	checkDefaults();
} // end for resetWorkingDir

public void sendEmail(StringBuffer message) {
	int numEs=adminEmails.size();
	String compName="";
	try {
		compName=InetAddress.getLocalHost().toString();
		}
	catch (Exception eR) {
		compName="localhost";
		}
	String subj=DateTimeUtils.getToday()+" "+EML_SUBJ+" "+compName;
	String[] addrs=new String[numEs];
	for (int i=0;i<numEs;i++) addrs[i]=getEmail(i);
	EmailThread emt=new EmailThread(addrs, getEmailProps(), FROM_ADDR, message.toString(), subj);
	//emt.start();
	try {
		emt.sendEmail();
		}
	catch (Exception eM) {
		setStatus(ERROR+" "+eM.toString());
		eM.printStackTrace();
		}
} // end for sendEmail

public Properties getEmailProps() {
	// 
	Properties retP=System.getProperties();
	retP.put("mail.smtp.host", gateway);
	retP.put("password", gatewayPwd);
	retP.put("username", gatewayUser);
	return retP;
} // end for getProperties

public void addEmail(String toAdd) {
	adminEmails.add(toAdd);
}

public Object[] getEmails() {
	return adminEmails.toArray();
}

public void removeEmail(int toRem) {
	adminEmails.remove(toRem);
}

public String getEmail(int idx) {
	return (String)adminEmails.get(idx);
}

public void setEmail(int idx, String em) {
	adminEmails.set(idx, (Object)em);
}

public boolean isTextEmailFormat() {
	boolean returnBool=true;
	if (emailFormat.equals(Messages.getString("DocSearch.htmlFormat"))) returnBool=false;
	return returnBool;
}

public boolean sendNoticeOnIdxingChanges() {
	boolean returnBool=true;
	if (sendEmailNotice.equals("false")) returnBool=false;
	return returnBool;
}

public int numGetAdminEmails() {
	return adminEmails.size();
} // end for numGetAdminEmails

public void sendEmail(String subj, StringBuffer message) {
	int numEs=adminEmails.size();
	String[] addrs=new String[numEs];
	for (int i=0;i<numEs;i++) addrs[i]=getEmail(i);
	EmailThread emt=new EmailThread(addrs, getEmailProps(), FROM_ADDR, message.toString(), subj);
	//emt.start();
	try {
		emt.setTextFormat(isTextEmailFormat());
		emt.sendEmail();
		}
	catch (Exception eM) {
		setStatus(ERROR+" "+eM.toString());
		eM.printStackTrace();
		}
} // end for sendEmail

public ArrayList getCdArrayList() {
  ArrayList returnArry=new ArrayList();
  DocSearcherIndex di;
  int numIdxs=indexes.size();
  boolean hasCdromIdxs=false;
  for (int i=0;i<numIdxs;i++) {
  	di=(DocSearcherIndex)indexes.get(i);
  	if (di.isCdrom()) {
  		hasCdromIdxs=true;
  		returnArry.add(di);
  		}
 	}
  return returnArry;
}

public void doSearchableCdWiz() {
	//
	String CREATE_IDX_FIRST=Messages.getString("DocSearch.createIdxFirst");
	String CREATE_CD_STEPS=Messages.getString("DocSearch.createIdxInfo");
	int numIdxs=indexes.size();
	if (numIdxs==0) showMessage(dsErr, CREATE_IDX_FIRST+"\n\n"+CREATE_CD_STEPS);
	else {
		DocSearcherIndex di;
		ArrayList indexesToSelectFrom=new ArrayList();
		boolean hasCdromIdxs=false;
		for (int i=0;i<numIdxs;i++) {
			di=(DocSearcherIndex)indexes.get(i);
			if (di.isCdrom()) {
				hasCdromIdxs=true;
				indexesToSelectFrom.add(di);
				}
			}
		if (!hasCdromIdxs) {
			showMessage(dsErr, CREATE_IDX_FIRST+"\n\n"+CREATE_CD_STEPS);
			}
		else {
			// set the defaults
			String cdRootDirName=Utils.addFolder(tempDir, "CD_ROOT_DS");
			String splashImageFileName=Utils.addFolder(startDir, "splash.gif");
			String startPageFileName=Utils.addFolder(startDir, "start_page.htm");
			String helpPageFileName=Utils.addFolder(startDir, "help_page.htm");
			boolean copyAllFiles=true;
			CdAssistantDialog cad=new CdAssistantDialog(this, Messages.getString("DocSearch.cdAssistant"), true);
			cad.init();
			cad.setFields(helpPageFileName, 
				splashImageFileName, 
				startPageFileName, 
				cdRootDirName);
			cad.setVisible(true);
			if (cad.confirmed()) {
				createCDStuff(cad.getCdRootDirName(), 
					cad.getSplashImageFileName(), 
					cad.getStartPageFileName(), 
					cad.getHelpPageFileName(), 
					cad.getCopyAllFiles(), 
					cad.getCDIdxList());
				}
			} // end for we have CDROM indexes to work with
		} // end for we at least have some indexes
} // end for doSearchableCdWiz


public String getCdsList(ArrayList idxs) {
	StringBuffer rb=new StringBuffer();
	if (idxs.size()>0) {
		Iterator it=idxs.iterator();
		DocSearcherIndex di;
		while (it.hasNext()) {
			di=(DocSearcherIndex)it.next();
			rb.append(di.getDesc());
			rb.append("\n");
			}
		}
	return rb.toString();
} // end for getCdsList

public void createCDStuff(String cdRootDirName, 
					String splashImageFileName, 
					String startPageFileName, 
					String helpPageFileName, 
					boolean copyAllFiles, 
					ArrayList indexesToSelectFrom) {
boolean madeStuff=true;
StringBuffer errBuf=new StringBuffer();
StringBuffer sB=new StringBuffer();
sB.append("<html><head><title>DocSearcher Index List - CDROM</title></head><body>\n<table>");
File cdrDirFi=new File(cdRootDirName);
if (!cdrDirFi.exists()) {
	// CREATE THE CD ROOT DIR
	madeStuff=cdrDirFi.mkdir();
	if (!madeStuff) {
		errBuf.append("\n");
		errBuf.append(Messages.getString("DocSearch.unableToMkCDFold"));
		}
	}
if (madeStuff) {
	// COPY THE DOCSEARCH.JAR FILE
	String newDocSearchFileName=Utils.addFolder(cdRootDirName, "DocSearch.jar");
	String oldDocSearchFileName=Utils.addFolder(startDir, "DocSearch.jar");
	File testOldDS=new File(oldDocSearchFileName);
	if (!testOldDS.exists()) {
		madeStuff=false;
		errBuf.append("\n");
		errBuf.append(Messages.getString("DocSearch.unableToFindDSjar"));
		}
	else copyFile(oldDocSearchFileName, newDocSearchFileName);
	} // end for OK so far
if (madeStuff) {
	// COPY THE START AND HELP PAGES AS WELL AS THE SPLASH and ICONS - IF THEY EXIST!
	String newSpFiName=Utils.addFolder(cdRootDirName, "start_page.htm");
	File testSp=new File(startPageFileName);
	if (testSp.exists()) {
		copyFile(startPageFileName, newSpFiName);
		}
	String newHpFiName=Utils.addFolder(cdRootDirName, "help_page.htm");
	File testHp=new File(helpPageFileName);
	if (testHp.exists()) {
		copyFile(helpPageFileName, newHpFiName);
		}
	String newSplashFiName=Utils.addFolder(cdRootDirName, "splash.gif");
	File testSplashFi=new File(splashImageFileName);
	if (testSplashFi.exists()) {
		copyFile(splashImageFileName, newSplashFiName);
		}
	String oldIconsDir=iconDir;
	String newIconsDir=Utils.addFolder(cdRootDirName, "icons");
	File testIcons=new File(newIconsDir);
	if (!testIcons.exists()) {
		madeStuff=testIcons.mkdir();
		if (!madeStuff) {
			errBuf.append("\n");
			errBuf.append(Messages.getString("DocSearch.failToCreateDir")+" : "+newIconsDir);
			}
		copyFiles(oldIconsDir, newIconsDir);
		}
	} // end for OK so Far
if (madeStuff) {
	// NOW COPY OVER THE INDEX FILES
	String cdIdxsTemp=Utils.addFolder(cdRootDirName, "cdrom_indexes");
	String actualItdxsDir=Utils.addFolder(cdIdxsTemp, "indexes");
	File testCDIDXSTemp=new File(cdIdxsTemp);
	if (!testCDIDXSTemp.exists()) {
		madeStuff=testCDIDXSTemp.mkdir();
		if (!madeStuff) {
			errBuf.append("\n");
			errBuf.append(Messages.getString("DocSearch.failToCreateDir")+" : "+cdIdxsTemp);
			}
		}
	if (madeStuff) {
		// create the sub dir for the indexes themsevels - ...indexes
		File testActFi=new File(actualItdxsDir);
		if (!testActFi.exists()) {
			madeStuff=testActFi.mkdir();
			if (!madeStuff) {
				errBuf.append("\n");
				errBuf.append(Messages.getString("DocSearch.failToCreateDir")+" : "+actualItdxsDir);
				}
			}
		}
	if (madeStuff) {
		// copy the indexes
		Iterator it=indexesToSelectFrom.iterator();
		DocSearcherIndex di;
		String curOldIdxDir="";
		String curOldPath="";
		String curNewPath="";
		String curPnameOnly="";
		String curNewIdxDir="";
		String curNameOnly="";
		while (it.hasNext()) {
			di=(DocSearcherIndex)it.next();
			//
			curOldIdxDir=di.getIdxrPath();
			curOldPath=di.getPath();
			curPnameOnly=Utils.getNameOnly(curOldPath);
			curNameOnly=Utils.getNameOnly(curOldIdxDir);
			curOldIdxDir=Utils.addFolder(indexDir, curNameOnly);
			curNewIdxDir=Utils.addFolder(actualItdxsDir, curNameOnly);
			curNewPath=Utils.addFolder(cdRootDirName, curPnameOnly);
			File newIdxFi=new File(curNewIdxDir);
			newIdxFi.mkdir();
			copyFiles(curOldIdxDir, curNewIdxDir);
			System.out.println("Copying Index files from "+curOldIdxDir+" to "+curNewIdxDir);
			// build our save buffer
			sB.append("\n<tr>");
                	sB.append("\n<td>");
                	sB.append(di.desc);
                	sB.append("</td>");
                	sB.append("\n<td>");
                	sB.append(di.path);
                	sB.append("</td>");
                	sB.append("\n<td>");
                	if (di.shouldBeSearched) sB.append("0");
                	else sB.append("1");
                	sB.append("</td>");
                	sB.append("\n<td>");
                	sB.append(di.depth + "");
                	sB.append("</td>");
                	sB.append("\n<td>");
                	sB.append(di.indexerPath + "");
                	sB.append("</td>");
                	// now the isWeb stuff and date
                	sB.append("\n<td>");
                	if (di.isWeb) sB.append("true");
                	else sB.append("false");
                	sB.append("</td>");
                	sB.append("\n<td>");
                	sB.append(di.match);
                	sB.append("</td>");
                	sB.append("\n<td>");
                	sB.append(di.replace);
                	sB.append("</td>");
                	sB.append("\n<td>");
                	sB.append(di.lastIndexed);
                	sB.append("</td>");
                	sB.append("\n<td>");
                	sB.append(di.indexPolicy + "");
                	sB.append("</td>");
                	sB.append("\n<td>");
                	sB.append(di.archiveDir);
                	sB.append("</td>");
                	sB.append("</tr>\n");
			if (copyAllFiles) {
				// copy from di.path to CD Root
				File testNewCFi=new File(curNewPath);
				if (!testNewCFi.exists()) {
					testNewCFi.mkdir();
					copyFiles(curOldPath, curNewPath);
					}
				} // end for copying the actual files themselves
			} // end for iteration over our indexes
		sB.append("\n</table></body></html>");
		saveFile(Utils.addFolder(cdIdxsTemp, "cdrom_indexes_list.htm"), sB);
		} // end for copying the indexes
	}
if (!madeStuff) {
	showMessage(Messages.getString("DocSearch.errCrtgCDStuff"), errBuf.toString());
	}
else showMessage(Messages.getString("DocSearch.readyForBurning"), Messages.getString("DocSearch.cdMadeSuccess")+" \n\t  "+cdRootDirName);
} // end for createCDStuff

public boolean isSearching() { return currentlySearching; }

public void doThreadedSearch() {
	if ((searchField.getSelectedItem() != null) && (!isSearching())) {
 		String searchText =  searchField.getSelectedItem().toString().trim();
		if ((!searchText.equals("")) && (!searchText.equals(lastSearchedText))) {
			setStatus(plsWait+" "+dsSchin);
			ThreadedSearch ts=new ThreadedSearch(this, searchText);
			SwingUtilities.invokeLater(ts);
			//doSearch(searchText);
			lastSearchedText=searchText;
		} // end for has text
		//else setStatus(PROVIDE_TEXT);
	} // end for not null	
} // end for doThreadedSearch

public void doNewSpiderIdx() {
  /* this is the method where spidered indexes are made */
	SpiderDialog sd=new SpiderDialog(this, CREATE_NEW_SPIDER_IDX, true);
	sd.init();
	sd.setVisible(true);
	if (sd.confirmed) {
	        String spiderUrl=sd.urlField.getText().trim();
		String desc=sd.getDesc();
		int maxDocsToGet=sd.getMax();
		try {
			createSpiderIdx(spiderUrl, maxDocsToGet, desc);
			}
		catch (Exception eR) {
		         setStatus(eR.toString());
			 eR.printStackTrace();
			}
		}
} // end for doNewSpiderIdx

public String getDownloadFileName(String contT, String urlS) {
	String retS="temp_spidered_document_"+USER_NAME;
 	if (contT.toLowerCase().endsWith("html")) retS+=".htm";
	else {
	       if (urlS.endsWith(".pdf")) retS+=".pdf";
	       if (urlS.endsWith(".doc")) retS+=".doc";
	       if (urlS.endsWith(".xls")) retS+=".xls";
	       if (urlS.endsWith(".sxw")) retS+=".sxw";
	       if (urlS.endsWith(".sxc")) retS+=".sxc";
	       if (urlS.endsWith(".txt")) retS+=".txt";
	       if (urlS.endsWith(".htm")) retS+=".htm";
	       if (urlS.endsWith(".html")) retS+=".htm";
	       if (urlS.endsWith(".shtml")) retS+=".htm";
	       if (urlS.endsWith(".do")) retS+=".htm";
	       if (urlS.endsWith("/")) retS+=".htm";
	       if (urlS.endsWith(".jsp")) retS+=".htm";
	       if (urlS.endsWith(".asp")) retS+=".htm";
	       if (urlS.endsWith(".cfm")) retS+=".htm";
	       if (urlS.endsWith(".cfml")) retS+=".htm";
	       if (urlS.endsWith(".aspx")) retS+=".htm";
		}
	return retS;
}


public void createSpiderIdx(String spiderUrl, int maxDocsToGet, String desc) throws IOException {
	String outFile=Utils.addFolder(tempDir, "tmp_spider_links_"+USER_NAME+".txt");
	String noUnd=Utils.replaceAll(" ", desc, "_");
	String idxFoldr=Utils.addFolder(indexDir, noUnd);
	/* Setup the index object */
	File idxpthfi=new File(idxFoldr);
	idxpthfi.mkdir();
	DocSearcherIndex dsi=new DocSearcherIndex(spiderUrl,
                     desc,
                     true,
                     maxDocsToGet,
                     idxFoldr,
                     true,
                     outFile,
                     spiderUrl,
                     DateTimeUtils.getToday(),
                     0,
                     archiveDir);
	IndexWriter writer = new IndexWriter(idxFoldr, new StandardAnalyzer(), true);
	//writer.setUseCompoundFile(true);
	LinkFinder lf=new LinkFinder(spiderUrl, outFile, maxDocsToGet, this, dsi, writer);
	lf.init();
	lf.getAllLinks();
	writer.close(); // close the writer
	indexes.add(dsi);
} // end for createSpiderIdx

public long getMaxFileSize() { return maxFileSizeInt; }
public void setMaxFileSize(long toGet) { maxFileSizeInt=toGet; }

} // end for class
