import java.util.*;

public class DocSearcherIndex {
    boolean shouldBeSearched = false;
    String desc = "";
    String path = "";
    String indexerPath = "";
    int depth = 0;
    String lastIndexed = "";
    boolean isWeb = false;
    String match = "";
    String replace = "";
    String archiveDir = "";
    boolean isSpider=false; // indicates if our index is made from crawling
    int indexPolicy = 0;
    boolean isAnImport = false;

    DocSearcherIndex(String path,
                     String desc,
                     boolean shouldBeSearched,
                     int depth,
                     String indexerPath,
                     boolean isWeb,
                     String match,
                     String replace,
                     String lastIndexed,
                     int indexPolicy,
                     String archiveDir) {
        this.archiveDir = archiveDir;
        this.indexPolicy = indexPolicy;
        this.isWeb = isWeb;
        this.match = match;
        this.replace = replace;
        this.shouldBeSearched = shouldBeSearched;
        this.path = path;
        this.depth = depth;
        this.desc = desc;
        this.indexerPath = indexerPath;
        this.lastIndexed = lastIndexed;
	if ((path.equals(replace))  
	   && ((path.startsWith("http")) || (path.startsWith("ftp:")))) {
	      isSpider=true;
	   }
    }

    DocSearcherIndex(String path,
                     String desc,
                     boolean shouldBeSearched,
                     int depth,
                     String indexerPath,
                     boolean isWeb,
                     String match,
                     String replace,
                     int indexPolicy,
                     String archiveDir)
    {
        this.archiveDir = archiveDir;
        this.indexPolicy = indexPolicy;
        this.isWeb = isWeb;
	  if (match.startsWith("[cdrom]")) {
            this.match = match;
            this.replace = replace;
	}
        else if (!isWeb) {
            this.match = "na";
            this.replace = "na";
        }
        else {
            this.match = match;
            this.replace = replace;
        }

        this.shouldBeSearched = shouldBeSearched;
        this.path = path;
        if (path.toLowerCase().endsWith(".zip"))
        {
            isAnImport = true;
        }
         // end for an imported zip archive
        else
        {
            isAnImport = false;
        }

        this.depth = depth;
        this.desc = desc;
        this.indexerPath = indexerPath;

        // calendar info
        Calendar nowD = Calendar.getInstance();
        String mon = "" + (nowD.get(Calendar.MONTH) + 1);
        String year = "" + (nowD.get(Calendar.YEAR));
        String day = "" + nowD.get(Calendar.DAY_OF_MONTH);
        this.lastIndexed = mon + "/" + day + "/" + year;
    }

public String getDesc() {
	return desc;
}

public boolean getSearched() {
	return shouldBeSearched;
}
    
public boolean isCdrom() {
	if (match.startsWith("[cdrom]")) return true;
	else return false;
}

public String getPath() {
	return path;
	}

public String getIdxrPath() {
	return indexerPath;
	}

}
