import java.util.Properties;
import javax.mail.*;
import javax.mail.internet.*;
import java.io.*;

public class EmailThread implements Runnable {
	String[] addresses;
	Properties props;
	String from;
	String msg;
	String subj;
	Thread checker;
	boolean isText=true;

EmailThread(String[] addresses, Properties props,
	 String from, String msg, String subj) {
	this.addresses=addresses;
	this.props=props;
	this.from=from;
	this.msg=msg;
	this.subj=subj;
} // end for constructor

public void setTextFormat(boolean toSet) {
 	isText=toSet;
}

public void start() {
	if(checker == null) {
            checker = new Thread(this, "checker");
            checker.start();
        } // end if null
} // end for start

public void stop() {
	checker.interrupt();
	checker = null;
} // end for stop

public void run() {
 for(Thread thread = Thread.currentThread(); checker == thread;)
	try {
		sendEmail();
		} // end for try
	catch(Exception eR) 
		{ 

		eR.printStackTrace();
		}
	finally {
		stop();
		if (checker!=null) checker.destroy();
		} // end finally
} // end for run

public void sendEmail() throws Exception {
	// method send out our email
	Session session = Session.getDefaultInstance(props, null);
	MimeMessage message = new MimeMessage(session);
	message.setFrom(new InternetAddress(from));
	int numAdds=addresses.length;
	for (int i=0;i<numAdds;i++) {
		message.addRecipient(Message.RecipientType.TO,  new InternetAddress(addresses[i]));
		}
	message.setSubject(subj);
	if (!isText) message.setContent(msg, "text/html");
	else message.setText(msg);
	Transport.send(message);
} // end for sendEmail

} // end for EmailThread class
