import java.io.File;
import java.io.FilenameFilter;

public class FolderFilter
    implements FilenameFilter
{
 String pathSep=System.getProperty("file.separator");
 String slashDot=pathSep+".";
 
    public boolean accept(File directory,
                          String fileName)
    {
        String newFolder =
            directory.toString() + pathSep
            + fileName;
        File testFile = new File(newFolder);
        if (testFile.isDirectory())
        {
            return nonFpDir(newFolder);
        }
        return false;
    }

    public boolean nonFpDir(String dirString)
    {
        dirString = dirString.toLowerCase();
        boolean nonFp = true;
        if (dirString.indexOf("_vti") != -1)
        {
            nonFp = false;
        }
        else if (dirString.indexOf("_derived") != -1)
        {
            nonFp = false;
        }
        else if (dirString.indexOf("_private") != -1)
        {
            nonFp = false;
        }
        else if (dirString.indexOf("_themes") != -1)
        {
            nonFp = false;
        }
        else if (dirString.indexOf("_fpclass") != -1)
        {
            nonFp = false;
        }
        else if (dirString.indexOf("_borders") != -1)
        {
            nonFp = false;
        }
        else if (dirString.indexOf("cgi-bin") != -1)
        {
            nonFp = false;
        }
        else if (dirString.indexOf("_overlay") != -1)
        {
            nonFp = false;
        }
        else if (dirString.indexOf(slashDot)!=-1)
        {
            nonFp = false;
        }
        return nonFp;
    }
}
