import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;

public class NewHandlerDialog
    extends JDialog
    implements ActionListener
{
    JPanel[] panels;
    static final String ADD=Messages.getString("DocSearch.ok");
    static final String CANCEL=Messages.getString("DocSearch.btnCancel");
    static final String BROWSE=Messages.getString("DocSearch.btnBrowse");
    static final String MISSI=Messages.getString("DocSearch.msgMI");
    static final String PROVIDEALL=Messages.getString("DocSearch.provAll");
    static final String SELECT=Messages.getString("DocSearch.btnSelect");
    //
    //
    JButton okButton = new JButton(ADD);
    JButton cancelButton = new JButton(CANCEL);
    boolean returnBool = false;

    // start in
    JPanel descP=new JPanel();
    JLabel descLabel = new JLabel(Messages.getString("DocSearch.hdnlrNew"));
    JTextField descField = new JTextField(25);
	//
	JPanel appP=new JPanel();
	JLabel appLabel=new JLabel(Messages.getString("DocSearch.appl"));
	JTextField appField = new JTextField(25);
	JButton browseButton = new JButton(BROWSE);
	//
	JPanel extP=new JPanel();
	JLabel extLabel=new JLabel(Messages.getString("DocSearch.applEx"));
	JTextField extField = new JTextField(25);
	//
	JPanel topP=new JPanel();
	JPanel bp=new JPanel();
    int numPanels = 2;
    DocSearch monitor;
    Font f = new Font("Times", Font.BOLD, 16);

    NewHandlerDialog(DocSearch monitor,
                      String title,
                      boolean modal) {
        super(monitor, title, modal);
        //super(parent, "Generate Meta Tag Table", true);
        this.monitor = monitor;
	descP.add(descLabel);
	descP.add(descField);
	//
	appP.add(appLabel);
	appP.add(appField);
	appP.add(browseButton);
	//
	extP.add(extLabel);
	extP.add(extField);
	//
	topP.setLayout(new BorderLayout());
	topP.add(descP,BorderLayout.NORTH);
	topP.add(appP,BorderLayout.CENTER);
	topP.add(extP,BorderLayout.SOUTH);
        // accessibility info
        //
        okButton.setMnemonic(KeyEvent.VK_O);
        okButton.setToolTipText(ADD);
        //
        cancelButton.setMnemonic(KeyEvent.VK_C);
        cancelButton.setToolTipText(CANCEL);
	//
	bp.add(okButton);
	bp.add(cancelButton);
        //
        browseButton.setMnemonic(KeyEvent.VK_B);
        browseButton.setToolTipText(BROWSE);
	//
        okButton.addActionListener(this);
        cancelButton.addActionListener(this);
	browseButton.addActionListener(this);
	//
        panels = new JPanel[numPanels];
        for (int i = 0; i < numPanels; i++) panels[i] = new JPanel();

        panels[0].add(topP);
	panels[0].setBorder(new TitledBorder(Messages.getString("DocSearch.hndlrItems")));
        //
        panels[1].add(bp);
               // now for the gridbag
        getContentPane().setLayout(new GridLayout(1, numPanels));
        GridBagLayout gridbaglayout = new GridBagLayout();
        GridBagConstraints gridbagconstraints = new GridBagConstraints();
        getContentPane().setLayout(gridbaglayout);
        for (int i = 0; i < numPanels; i++)
        {
            //
            gridbagconstraints.fill = 1;
            gridbagconstraints.insets = new Insets(1, 1, 1, 1);
            gridbagconstraints.gridx = 0;
            gridbagconstraints.gridy = i;
            gridbagconstraints.gridwidth = 1;
            gridbagconstraints.gridheight = 1;
            gridbagconstraints.weightx = 0.0D;
            gridbagconstraints.weighty = 0.0D;
            gridbaglayout.setConstraints(panels[i], gridbagconstraints);
            getContentPane().add(panels[i]);
        }
    }

    public void init()
    {
        pack();

        // center this dialog
        Rectangle frameSize = getBounds();
        Dimension screenD = Toolkit.getDefaultToolkit().getScreenSize();
        int screenWidth = screenD.width;
        int screenHeight = screenD.height;
        int newX = 0;
        int newY = 0;
        if (screenWidth > frameSize.width)
        {
            newX = (screenWidth - frameSize.width) / 2;
        }

        if (screenHeight > frameSize.height)
        {
            newY = (screenHeight - frameSize.height) / 2;
        }

        if ((newX != 0) || (newY != 0))
        {
            setLocation(newX, newY);
        }
    }

    public void actionPerformed(ActionEvent actionevent) {
        String s = actionevent.getActionCommand();
        if (s.equals(ADD)) {
		if ((appField.getText().trim().equals("")) ||
		  (extField.getText().trim().equals("")) ||
		  (descField.getText().trim().equals(""))) monitor.showMessage(MISSI, PROVIDEALL);
		else {
			returnBool=true;
			this.setVisible(false);
			}
        }
        else if (s.equals(BROWSE)) {
            JFileChooser fdo = new JFileChooser();
            fdo.setCurrentDirectory(new File(monitor.userHome));
            int fileGotten = fdo.showDialog(this, SELECT);
            if (fileGotten == JFileChooser.APPROVE_OPTION) {
                File file = fdo.getSelectedFile();
                String fNa = file.toString();
                appField.setText(fNa);
            }
        }
        if (s.equals(CANCEL)) {
            returnBool = false;
            this.setVisible(false);
        }
    }
    
 public void setDTH(docTypeHandler dh) {
 	//
	appField.setText(dh.app);
	extField.setText(dh.extension);
	descField.setText(dh.desc);
 }
}
