import java.util.*;
import java.io.*;
import java.net.*;
import java.net.URL;
import com.twmacinta.io.*;
import com.twmacinta.util.*;

public class Utils {
    final static String pathSep=System.getProperty("file.separator");
    
    public static String replaceAll(String s, String s1, String s2) {
        while (s1.indexOf(s) != -1) {
            int i = s1.indexOf(s);
            if (i >= 1) {
                s1 = s1.substring(0, i) + s2
                     + s1.substring(i + s.length(), s1.length());
            }
            else if (i == 0) s1 = s2 + s1.substring(i + s.length(), s1.length());
        }
        return s1;
    }

public static String addFolder(String startFolder, String addedFolder) {
        String returnFolder = "";
        if (startFolder.indexOf(pathSep) != -1) {
            returnFolder = startFolder + pathSep + addedFolder;
            returnFolder = Utils.replaceAll(pathSep + pathSep, returnFolder, pathSep);
        }
        else returnFolder = startFolder + pathSep + addedFolder;
        return returnFolder;
    }


public static double getAverageSearchScore(ArrayList loggedSearches) {
int numIs=loggedSearches.size();
double returnD=0.0;
double totalD=0.0;
double temD=0.0;
LogSearch ls;
if (numIs>0) {
	Iterator it=loggedSearches.iterator();
	while (it.hasNext()) {
		ls=(LogSearch)it.next();
		temD=ls.score;
		totalD+=temD;
		} // end while
	if (totalD>0.0) returnD=totalD/numIs;
	}
return returnD;
} // end for getAverageSearchScore

public static boolean hasUser(String toMatch, ArrayList listing)  {
	int numUs=listing.size();
	boolean returnB=false;
	if (numUs>0) {
		String temC="";
		Iterator it=listing.iterator();
		while (it.hasNext()) {
			temC=(String)it.next();
			if (temC.equals(toMatch)) {
				returnB=true;
				break;
				}
			} // end while
		} // end has users
	return returnB;
} // end foir hasUserBool

public static boolean isText(String link) {
        String lowerLink = link.toLowerCase();
        if ((lowerLink.endsWith(".java")) || (lowerLink.endsWith(".txt")) || (lowerLink.endsWith(".ini"))) return true;
        else return false;
    }

public static boolean isRtf(String link) {
        String lowerLink = link.toLowerCase();
        if (lowerLink.endsWith(".rtf")) return true;
        else return false;
    }

public static boolean isWord(String link) {
        String lowerLink = link.toLowerCase();
        if (lowerLink.endsWith(".doc")) return true;
        else return false;
    }

public static boolean isExcel(String link) {
        String lowerLink = link.toLowerCase();
        if (lowerLink.endsWith(".xls")) return true;
        else return false;
    }

public static boolean isPDF(String link) {
        String lowerLink = link.toLowerCase();
        if (lowerLink.endsWith(".pdf")) return true;
	else return false;
    }

public static boolean isOo(String link) {
        String lowerLink = link.toLowerCase();
        if ((lowerLink.endsWith(".sxw")) || (lowerLink.endsWith(".sxc"))
                || (lowerLink.endsWith(".sxi")) || (
                    lowerLink.endsWith(".sxp")
                ) || (lowerLink.endsWith(".sxd"))) return true;
        else return false;
    }

public static boolean isViewAble(String link) {
        String lowerLink = link.toLowerCase();
        if ((lowerLink.endsWith(".htm")) || (lowerLink.endsWith(".html"))
                || (lowerLink.endsWith(".shtm"))
                || (lowerLink.endsWith(".shtml"))
                || (lowerLink.endsWith(".php")) || (
                    lowerLink.endsWith(".asp")
                ) || (lowerLink.endsWith(".txt"))
                || (lowerLink.endsWith(".rtf"))
                || (lowerLink.endsWith(".java"))
			|| (lowerLink.endsWith("/"))
			|| (lowerLink.endsWith(".mil/"))
			|| (lowerLink.endsWith(".exe"))
			|| (lowerLink.endsWith(".sh"))
			|| (lowerLink.endsWith(".org/"))
                || (lowerLink.endsWith(".jsp"))) return true;
        else return false;
    }

public static boolean isHtml(String link) {
        String lowerLink = link.toLowerCase();
        if ((lowerLink.endsWith(".htm")) || (lowerLink.endsWith(".html"))
                || (lowerLink.endsWith(".shtm"))
                || (lowerLink.endsWith(".shtml"))
                || (lowerLink.endsWith(".php")) || (
                    lowerLink.endsWith(".asp")
                ) || (lowerLink.endsWith(".jsp"))) {
            return true;
        }
        return false;
    }

public static boolean endsWithSlash(String toCkeck) {
	boolean retB=false;
	if ((toCkeck.endsWith("/")) || (toCkeck.endsWith("\\"))) retB=true;
	return retB;
}

public static int getTypeInt(String lowerType) {
        int returnInt = -1;
        if ((lowerType.equals("html")) || (lowerType.equals("htm"))
                || (lowerType.equals("shtml")) || (lowerType.equals("shtm"))
                || (lowerType.equals("asp")) || (lowerType.equals("jsp"))
                || (lowerType.equals("php"))) returnInt = 0; // HTML
        else if (lowerType.equals("txt")) returnInt = 1; // TEXT
        else if (lowerType.equals("doc")) returnInt = 2;
        else if (lowerType.equals("xls")) returnInt = 3;
        else if (lowerType.equals("pdf")) returnInt = 4;
        else if (lowerType.equals("rtf")) returnInt = 5;
        else if (lowerType.equals("sxw"))  returnInt = 6; // ooWriter
        else if ((lowerType.equals("sxi")) || (lowerType.equals("sxp"))) returnInt = 7; // ooInpress
        else if (lowerType.equals("sxc")) returnInt = 8; // ooCalc
        else if (lowerType.equals("sxd")) returnInt = 9; // ooDraw
        return returnInt;
    }

public static String getURL(String fileName, String match, String replace) {
        String returnString = "";
        returnString =
            replace + fileName.substring(match.length(), fileName.length());
        returnString = Utils.replaceAll("\\", returnString, "/");

        //System.out.println("Converted file("+fileName+") to "+returnString+"\nmatch:"+match+"\nreplace:"+replace);
        return returnString;
    }

public static int countSLash(String URLtoCount) {
        int returnInt = 0;
        int totalLen = URLtoCount.length();
        int startSpot = URLtoCount.indexOf(pathSep);
        if (startSpot != -1)
        {
            returnInt++;
            do
            {
                startSpot++;
                if (startSpot > totalLen)
                {
                    break;
                }

                startSpot = URLtoCount.indexOf(pathSep, startSpot);
                if (startSpot == -1)
                {
                    break;
                }

                returnInt++;

                //System.out.println("Found slash");
            }
            while (startSpot != -1);
        }

        return returnInt;
    }

public static int getNumObjectRows(String fileName) {
	int returnInt=0;
	// load file and count <tr tags
	try {
		File origFile=new File(fileName);
		if (origFile.exists()) {
			FileInputStream fi=new FileInputStream(origFile);
			int curI=0; // reset i
			char curChar=' ';
			char lastChar=' ';
			char nextToLastChar=' ';
			StringBuffer rowString;
			while(curI!=-1) {
				curI=fi.read();
				if (curI!=-1) {
					//
					lastChar=nextToLastChar;
					nextToLastChar=curChar;
					curChar=(char)curI;
					rowString=new StringBuffer();
					rowString.append(lastChar);
					rowString.append(nextToLastChar);
					rowString.append(curChar);
					if (rowString.toString().toLowerCase().equals("<tr")) returnInt++;
					} // curI!=-1
				else break;
				}
			fi.close();
			} // end for file exists
		else returnInt=-1;
		} // end of trying
	catch (Exception eF) {
		returnInt=0;
		}
return returnInt;
} // end for getNumObjectRows

    
public static String getNameOnly(String fileString) {
        if (fileString.indexOf(pathSep) != -1)
        {
            return fileString.substring(fileString.lastIndexOf(pathSep)
                                        + 1, fileString.length());
        }
        else if (fileString.indexOf("\\") != -1)
        {
            return fileString.substring(fileString.lastIndexOf("\\") + 1,
                                        fileString.length());
        }
        else if (fileString.indexOf("/") != -1)
        {
            return fileString.substring(fileString.lastIndexOf("/") + 1,
                                        fileString.length());
        }
        else
        {
            return fileString;
        }
    }

public static String getFolderOnly(String fileString) {
        if (fileString.indexOf(pathSep) != -1) return fileString.substring(0, fileString.lastIndexOf(pathSep));
        else if (fileString.indexOf("\\") != -1) return fileString.substring(0, fileString.lastIndexOf("\\"));
        else if (fileString.indexOf("/") != -1) return fileString.substring(0, fileString.lastIndexOf("/"));
        else return "";
    }
    
public static boolean exists(String fileToCheck) {
    	File eF=new File(fileToCheck);
	return eF.exists();
    }

public static int getOsType() {
	// 0=win, 1=linux, 2=Unix, 3=Mac
	int returnInt=0;
        String os = System.getProperty("os.name").toLowerCase();
        if (os.indexOf("linux") != -1) returnInt= 1;
        else if (os.indexOf("windows") != -1) returnInt= 0;
        else if (os.indexOf("nix") != -1) returnInt= 2;
        else if (os.indexOf("mac") != -1)  returnInt= 3;
        else returnInt= -1;
	return returnInt;
} // end for getOSType

public static String escapeSpaces(String toEsc) {
	StringBuffer returnBuf=new StringBuffer();
	int sizeS=toEsc.length();
	char cr=' ';
	for (int i=0;i<sizeS;i++) {
		cr=toEsc.charAt(i);
		if (cr==' ') returnBuf.append("\\ ");
		else returnBuf.append(cr);
		}
	return returnBuf.toString();
} // end for escape spaces

public static String getUserHome(int osNum, String defaultOsUserHome) {
	String returnString=defaultOsUserHome;
	String tempHome="";
	switch (osNum) { // 0=win, 1=linux, 2=Unix, 3=Mac
		case 0 : // win
			tempHome=Messages.getString("win32.home");
			if (tempHome.equals("$HOME")) returnString=System.getProperty("user.home");
			else if (tempHome.equals(".")) returnString=System.getProperty("user.dir");
			break;
		case 1 : // lin
			tempHome=Messages.getString("lin.home");
			if (tempHome.equals("$HOME")) returnString=System.getProperty("user.home");
			else if (tempHome.equals(".")) returnString=System.getProperty("user.dir");
			break;
		case 2 : // nix
			returnString=System.getProperty("user.dir");
			break;
		case 3 : // mac
			returnString=System.getProperty("user.dir");
			break;
		default : // don't know what it is
			returnString=System.getProperty("user.dir");
			break;
		}
	System.out.println("Using HOME Directory: "+returnString);
	return returnString;
} // end for getUserHome

public static String getCdDir(int osNum) {
	String returnString="";
	String tempCdDir="";
	File testFile;
	tempCdDir=System.getProperty("user.dir");
	if (!tempCdDir.equals("")) {
		testFile=new File(tempCdDir);
		if (testFile.exists())  {
			returnString=tempCdDir;
			System.out.println("CD Rom Dir: "+returnString);
			}
		else {
			returnString="";
			System.out.println("NO CD ROM DIR FOUND... ");
			}
		}
	else {
		returnString="";
		System.out.println("NO CD ROM DIR FOUND... ");
		}
	return returnString;
} // end for getCdDir


public static String concatStr(String toConcat) {
if (toConcat.length()>37) return "~"+toConcat.substring(toConcat.length()-37,toConcat.length());
else return toConcat;
} // end for concat

public static String concatStrTo(String toConcat, int len) {
if (toConcat.length()>len) return "~"+toConcat.substring(toConcat.length()-len,toConcat.length());
else return toConcat;
} // end for concat

public static String concatStrToEnd(String toConcat, int len) {
if (toConcat.length()>len) return toConcat.substring(0, len)+"...";
else return toConcat;
} // end for concat

 public static String getTagString(String toLookFor, String toLookIn) {
 // format is curLink=getTagString("href=", realTag);
String toLookInLower=toLookIn.toLowerCase();
if (toLookInLower.indexOf(toLookFor)==-1) return "";
else {
	boolean firstQFnd=true;
	StringBuffer tempS=new StringBuffer();
	int endPos=toLookIn.length();
	char tC=' ';
	int startPos=toLookInLower.indexOf(toLookFor)+toLookFor.length();
	for (int i=startPos;i<endPos;i++) {
		tC=toLookIn.charAt(i);
		if (toLookIn.charAt(i)=='"') { 
			if (!firstQFnd) { break; }			
			else firstQFnd=false;
			}
		else if (toLookIn.charAt(i)=='>') { break; }
		else tempS.append(tC);
		} // end for
	if (tempS.toString().trim().equals("")) return "";
	else return tempS.toString();
	} // end else
} //  end for getTagString

public static String getLineParam(String keyToFind, String lineToSearch) {
	String returnString="";
	// iterate over chars....
	int numCharsTotal=lineToSearch.length();
	StringBuffer curVal=new StringBuffer();
	char cu=' ';
	int keyLocaion=lineToSearch.indexOf(keyToFind);
	if (keyLocaion!=-1) {
		for (int i=keyLocaion+1+keyToFind.length();i<numCharsTotal;i++) {
			cu=lineToSearch.charAt(i);
			if ((cu=='\n') || (cu=='\r')) break;
			else curVal.append(cu);
			}
		returnString=curVal.toString();
		} // end for has key
	return returnString;
} // end for getLineParam


public static String nonTagText (String removeStr) {
    StringBuffer retBuf=new StringBuffer();
    int strLen=removeStr.length();
    boolean inTag=false;
    char curChar=' ';
    for (int i=0;i<strLen;i++) {
    	curChar=removeStr.charAt(i);
	if (curChar=='<') inTag=true;
	else if(curChar=='>') {
		retBuf.append(" ");
		inTag=false;
		}
	if ((!inTag) && (curChar!='>')) retBuf.append(curChar);
	else if ((!inTag) && (curChar=='>')) retBuf.append(" ");
    	} // end for string
    return retBuf.toString();
    } // end for nonTagText

public static String getDomainUrl(String baseUrl) {
	int endPos=-1;
	String retS="";
	endPos=baseUrl.indexOf(".com");
	int milPos=baseUrl.indexOf(".mil");
	if (endPos==-1) endPos=baseUrl.indexOf(".net");
	if (endPos==-1) endPos=baseUrl.indexOf(".org");
	if (milPos!=-1) endPos=milPos;
	if (endPos==-1) endPos=baseUrl.indexOf(".gov");
	if (endPos==-1) endPos=baseUrl.indexOf(".edu");
	if (endPos==-1) endPos=baseUrl.indexOf("8080");
	if (endPos==-1) endPos=baseUrl.indexOf(".0.1");
	if (endPos==-1) endPos=baseUrl.indexOf("host");
	if (endPos!=-1) retS=baseUrl.substring(0, endPos+4)+"/";
	else System.out.println("COULDN'T RETRIEVE domain from "+baseUrl);
	//System.out.println("DOMAIN URL: "+retS);
	return retS;
}

public static String getRealUrl(String link, String baseUrl) {
	String returnS="";
	String domainUrl=Utils.getDomainUrl(baseUrl);
	int anchorPos=link.indexOf("#");
	if (anchorPos!=-1) link=link.substring(0, anchorPos);
	// DETERMINE THE BASE URL
	if (baseUrl.endsWith("/")) {
		baseUrl=baseUrl.substring(0, baseUrl.length()-1);
		}
	if (link.startsWith("http")) {
		returnS=link;
		}
	else if (link.indexOf("/")==-1) {
		returnS=baseUrl+"/"+link;
		}
	else if (link.startsWith("/")) {
		returnS=domainUrl+link;
		}
	else if (link.indexOf("../")==-1) {
		returnS=baseUrl+"/"+link;
		}
	if (returnS.equals("")) {
		System.out.println("Failed to construct full URL from link:"+link+"\nFound on page:"+baseUrl);
		}
	return returnS;
} // end for getRealUrl

public static long getUrlModifiedDate(String urlStr) {
	long retL=0;
	try {
		URL url=new URL(urlStr);
		URLConnection conn =(URLConnection)url.openConnection();
		conn.setDoInput(true);
		conn.setDoOutput(false);
		conn.setUseCaches(false);
		conn.connect();
		retL=conn.getLastModified();
		}
	catch (Exception eL) {
		eL.printStackTrace();
		retL=0;
		}
	finally {
		return retL;
		}
}

public static int urlStatus(SpiderUrl spy, String tempFileName) {
	int returnInt=-1;
	/* -1 means broken link, 
	 *  0 means same file
	 *  1 means changed 
	 */
	try {
		/* attempt to obtain status from date */
		URL url=new URL(spy.getUrl());
		URLConnection conn =(URLConnection)url.openConnection();
		conn.setDoInput(true);
		conn.setDoOutput(false);
		conn.setUseCaches(false);
		conn.connect();
		long compDate=spy.getLastModified();
		long urlDate=conn.getLastModified();
		if ((compDate==urlDate) && (urlDate!=0)) {
			returnInt=0; // the file is not changed
			}
		else if ((compDate!=urlDate) && (compDate!=0)
			&& (urlDate!=0)) {
			returnInt=1;  // the file is changed
			}
		else {
			/* download the link and compare hashes */
			boolean downloaded=Utils.downloadUrlToFile(spy.getUrl(), tempFileName);
			if (downloaded) {
				/* compare hashes */
				String compHash=Utils.getHashString(tempFileName);
				if (compHash.equals(spy.getMd5())) returnInt=0; // same
				else returnInt=1; // changed
				} // end if downloaded
			else returnInt=-1; // end for broken link
			} // end for dates not equal
		}
	catch (Exception eR) {
	        eR.printStackTrace();
		returnInt=-1;
		}
	finally {
		return returnInt;
		}
}

public static boolean downloadUrlToFile(String urlStr, String downloadFile) {
	boolean returnBool=true;
	try {
		// if the file downloads - save it and return true
		URL url=new URL(urlStr);
		URLConnection conn =(URLConnection)url.openConnection();
		conn.setDoInput(true);
		conn.setDoOutput(false);
		conn.setUseCaches(false);
		conn.connect();
		int fileS=conn.getContentLength();
		InputStream urlStream=conn.getInputStream();
		File saveFile=new File(downloadFile);
		FileOutputStream dos = new FileOutputStream(saveFile);
		byte curBint; int curI=0;
		while(curI!=-1) {
			curI=urlStream.read();
			if (curI==-1) break;
			curBint=(byte)curI;
			dos.write(curBint);
			}
		dos.close();
		urlStream.close();
		}
	catch (Exception eN) {
		eN.printStackTrace();
		returnBool=false;
		}
	finally {
		return returnBool;
		}
} // end for downloadUrlToFile

public static long getUrlSize(String urlStr) {
	long rl=0;
	try {
		URL url=new URL(urlStr);
		URLConnection conn =(URLConnection)url.openConnection();
		conn.setDoInput(true);
		conn.setDoOutput(false);
		conn.setUseCaches(false);
		conn.connect();
		rl=conn.getContentLength();
		}
	catch (Exception eN) {
		eN.printStackTrace();
		rl=0;
		}
	finally {
		return rl;
		}
} // end for getUrlSize


public static String getNormalUrl(String link) {
	link=Utils.replaceAll("&amp;", link, "&");
	link=Utils.replaceAll("%2B", link, "+");
	link=Utils.replaceAll("%2F", link, "/");
	link=Utils.replaceAll("%2f", link, "/");
	link=Utils.replaceAll("%2C", link, ",");
	link=Utils.replaceAll("%22", link, "\"");
	link=Utils.replaceAll("%23", link, "#");
	link=Utils.replaceAll("%24", link, "$");
	link=Utils.replaceAll("%3A", link, ":");
	link=Utils.replaceAll("%25", link, "%");
	link=Utils.replaceAll("+", link, " ");
	link=Utils.replaceAll("%26", link, "&");
	link=Utils.replaceAll("%27", link, "'");
	link=Utils.replaceAll("%20", link, " ");
	link=Utils.replaceAll("%28", link, "(");
	link=Utils.replaceAll("%29", link, ")");
	link=Utils.replaceAll("%5E", link, "^");
	link=Utils.replaceAll("%3f", link, "?");
	return link;
}

 public static String concatEnd(String toShorten, int size) {
 	String returnString="";
	int comS=toShorten.length();
	if (comS>size) {
		returnString="..."+toShorten.substring(comS-size, comS);
		}
	else returnString=toShorten;
	return returnString;
 } // end of concat
 
public static String getBaseUrlFolder(String toGetFrom) {
	String returnString=toGetFrom;
	if (!toGetFrom.endsWith("/")) {
		int lastSpot=toGetFrom.lastIndexOf("/");
		if (lastSpot!=-1) {
			returnString=returnString.substring(0,lastSpot);
			System.out.println("Requiring BASE URL : "+returnString);
			}
		else returnString="";
		}
	else returnString=toGetFrom;
	return returnString;
} // end for getBaseUrlFolder

public static String getHashString(String FileToGetHashFor) {
	String returnString="";
	byte[] buf = new byte[65536];
	int num_read;
	try {
		MD5InputStream in = new MD5InputStream(new BufferedInputStream(new FileInputStream(FileToGetHashFor)));
		while ((num_read = in.read(buf)) != -1);
		returnString=MD5.asHex(in.hash());
		in.close();
		}
	catch (Exception eN) {
		eN.printStackTrace();
		}
	finally {
		return returnString;
		}
} // end for getHashString

public static ArrayList getSpiderLinks(String fName) {
	ArrayList retA=new ArrayList();
	SpiderUrl tempUrl=null;
	try {
		File loadFile=new File(fName);
		if (!loadFile.exists()) System.out.println("Spider URL file does not exist "+fName);
		else {
			FileReader fr=new FileReader(loadFile);
			BufferedReader br=new BufferedReader(fr);
			/*close file resources */
			String line;
			while ((line = br.readLine()) != null) {
				//
				tempUrl=new SpiderUrl(line);
				retA.add(tempUrl);
				}
			br.close();
			fr.close();
			} // end for loadfile exists
		}
	catch (Exception eL) {
		System.out.println("Error loading spider url links from file "+fName);
		eL.printStackTrace();
		}
	finally {
		/* return the arraylist of spider url objects */
		return retA;
		}
} // end for getSpiderLinks

public static long getFileSize(String toCheck) {
	long rl=0;
	try {
		File testFile=new File(toCheck);
		if (testFile.exists()) rl=testFile.length();
		}
	catch (Exception eF) {
		eF.printStackTrace();
		}
	finally {
	 	return rl;
		}
}

}
